unit AccessRights;

interface

uses
  Classes, dbtables, Dialogs, SysUtils, inifiles;

function SetAccessRights(const AskJeeves: boolean;
  var aAccess : array of boolean): boolean;

implementation

uses
  ConstantValues, DataMod, LoginFrm, Main;

function SetAccessRights(const AskJeeves: boolean;
  var aAccess : array of boolean): boolean;
var
  LoginParams : TStringList;
  NewPPIniFile : TIniFile;
  IniFileName : string;
  sUserName : string;
  sPassword : string;
  sDummy : string;
  q : TQuery;
  lReturn, lSuccess : boolean;
  nUserID : integer;
  sUserID : string;
  ShowLogForm : boolean;
  nRite : integer;
begin
  IniFileName := INIFILEDIRECTORY+ChangeFileExt(ExtractFileName(ParamStr(0)),'.ini');
  NewPPIniFile := TIniFile.Create(IniFileName);
  ShowLogForm := (NewPPIniFile.ReadString('General','GetLog', '1') = '1');
  NewPPIniFile.Free;
  LoginParams := TStringList.Create;
  if ShowLogForm then begin
    // "User Access" not used as 2nd parameter is False - not a Startup condition.
    lReturn := GetLoginParams('User Access',False,sDummy,LoginParams);
      sUserName := LoginParams.Values['USER NAME'];
      sPassword := LoginParams.Values['PASSWORD'];
  end
  else begin
    lReturn := True;
    sUserName := MainForm.OperatorName;
  end;
  if lReturn then begin
    q := TQuery.Create(nil);
    q.DatabaseName := 'dbPPdata';              // Contained in "DataMod" module.
    q.SQL.Add('SELECT *');
    q.SQL.Add('FROM tUser');
    q.SQL.Add('WHERE UserLogin LIKE '''+sUserName+'''');
    q.SQL.Add('AND Active = 1');
    if ShowLogForm and AskJeeves then
//      q.SQL.Add('AND Password LIKE '''+EncodeString(sPassword)+'''');
      q.SQL.Add('AND Password LIKE '''+sPassword+'''');
    q.Open;
    lSuccess := not (q.Bof and q.Eof);
    if lSuccess then begin
      nUserID := q.FieldByName('id').AsInteger;
      sUserID := IntToStr(nUserID);
      MainForm.OPERATORNUMBER := nUserID;
      MainForm.OPERATORNAME := sUserName;
      MainForm.OPERATORFULLNAME := Trim(q.FieldByName('FirstName').AsString +
        ' '+ q.FieldByName('Surname').AsString);
    end;
    q.Close;
    if not lSuccess then begin
      lReturn := False;
      MessageDlg('User and Password not found. Access is denied.',
        mtWarning, [mbOk], 0);
    end
    else begin
      if ShowLogForm then begin
        // Reset all privileges.
        for nRite := 0 to Length(aAccess) do
          aAccess[nRite] := False;
        q.SQL.Clear;
        q.SQL.Add('SELECT *');
        q.SQL.Add('FROM tUserFunction');
        q.SQL.Add('WHERE UserID = '+sUserID);
        q.SQL.Add('ORDER BY FunctionID');
        q.Open;
        while not q.Eof do begin
          aAccess[q.FieldByName('FunctionID').AsInteger-1] := True;
          q.Next;
        end;  // while.
        q.Close;
      end
      else begin
        // Set all privileges - full access for everyone.
        for nRite := 0 to Length(aAccess) do
          aAccess[nRite] := True;
      end;
    end;  // not lSuccess.
    q.Free;
  end;  // lReturn.
  LoginParams.Free;
  Result := lReturn;
end;  // SetAccessRights.

end.
 