unit ConstantValues;

interface


const
  // Elements in array of window-active states.
  WINSYSTEM    = 0;           // System tables editing window.
  WINALLBILL   = 1;           // All Bills window.
  WINSERVICE   = 2;           // Service types window.
  WINCFG       = 3;           // Configuration window.
  WINMANUAL    = 4;           // TEC window.
  WINPAY       = 5;           // Pay types window.
  WINDIV       = 6;           // Division window.
  WINTELSTRA   = 7;           // Import Telstra accounts.
  WINSERV      = 8;           // Service Providers window.
  WINTEMP      = 9;           // Review Temp table window.
  WINSUNDRY    = 10;          // Sundry window.
  WINOPTUS     = 11;          // Import Optus Billing window.
  WINCASH      = 12;          // Show cash flow summary to screen.
  WINCASHREP   = 13;          // Show cash flow summary to print.
  WINPTC       = 14;          // Import PTC phone accounts.
  WINSACC      = 15;          // Import PTC SACC accounts.
  WINPTCREV    = 16;          // Review PTC phone accounts.
  WINOPTREV    = 17;          // Review Optus phone accounts.
  WINSACCREV   = 18;          // Review PTC SACC accounts.
  WINTELSTRAREV= 19;          // Review Telstra rejects.
  WINCABLE     = 20;          // Import cable services for billing.
  WINCABLEREVW = 21;          // Review cable service rejects.
  WINCABLERATES= 22;          // Telstra rates table for billing cable services.
  WINEBSCODES  = 23;          // Telstra EBS codes, for importing billing data.
  WINBILLADDRS = 24;          // Import Billing Addresses window.
  WINCUSTPAY   = 25;          // Customer Pay Dates window.
  WINPENDREVW  = 26;          // Review Sundries Pending for later printing.
  WINVODA      = 27;          // Import Vodafone accounts.
  WINVODAREVW  = 28;          // Review Vodafone accounts.
  WINAAPT      = 29;          // Import AAPT accounts.
  WINAAPTREVW  = 30;          // Review AAPT accounts.
  WINDELAYCODE = 31;          // Review codes for delayed customer billing.
  WINBATCH     = 32;          // Batch window for all new bills to be entered.
  WINADMIN     = 33;          // Batch window for all new bills to be entered.
//  WINNUM       = 34;          // Number of elements in this (aWin) array.

  // Array elements for Security (0..15 only):
  IMPORTMANUAL  = 0;          // PP-view Manual Imports.
  IMPORTKEYED   = 1;          // PP-view Keyed Imports.
  IMPORTAUTO    = 2;          // PP-view Automtic Imports.
  BATCHREVIEW   = 3;          // PP and TBIMS.
  TBSREVENUE    = 4;          // TBIMS only, NOT PP.
  TBSEXPENSE    = 5;          // TBIMS only, NOT PP.
  REFDATA       = 6;          // PP and TBIMS.
  REFDATAVIEW   = 7;          // PP and TBIMS.
  AUDIT         = 8;          // PP and TBIMS.
  PROCESSIMPORT = 9;          // PP-Import buttons enabled on Initiate tab.
  VIEWDATA      = 10;         // TBIMS only, NOT PP.
  INVOICE       = 11;         // TBIMS only, NOT PP.
  CREDITNOTES   = 12;         // TBIMS only, NOT PP.
  USERMAINT     = 13;         // PP and TBIMS.
  DEVELOPER     = 14;         // PP and TBIMS.
  PAYABLES      = 15;         // TBIMS only, NOT PP.

  // Program BatchType selections.
  PMIN_SEMIAUTOMATIC_INVOICE = 1000; // Range 1xxx: Semi-Automatic=Import File.
  PMAX_SEMIAUTOMATIC_INVOICE = 1999;
  PIMPORTBILLINGFILE_OPTUS_FIXED_ORIGINAL  = 1001; // Original version.
  PIMPORTBILLINGFILE_OPTUS_FIXED_LONG      = 1002; // original+ an empty field.
  PIMPORTBILLINGFILE_OPTUS_MOBILE          = 1003;
  PIMPORTBILLINGFILE_OPTUS_MOBILEDATA      = 1004;

  PIMPORTBILLINGFILE_TELSTRA_FIXED_EBS     = 1101; // Landline, EBS bill format.
  PIMPORTBILLINGFILE_TELSTRA_DATA_GPRSSMARTBUS = 1102; // Wireless data.
  PIMPORTBILLINGFILE_TELSTRA_DATA_GPRS     = 1103; // Wireless data.
  PIMPORTBILLINGFILE_TELSTRA_DATA_SMARTBUSINCLUDEDRATE = 1104; // 2nd invoice
                                                   // type for Smartbus data.
  PIMPORTBILLINGFILE_TELSTRA_OBS_FIXED     = 1105; // Landline Services.
  PIMPORTBILLINGFILE_TELSTRA_OBS_MOBILE    = 1106; // Mobile Phone Services.
  PIMPORTBILLINGFILE_TELSTRA_OBS_DATA_GPRSSMARTBUS = 1107; // Wireless data.
  PIMPORTBILLINGFILE_TELSTRA_OBS_DATA_GPRS = 1108; // Wireless data.
  PIMPORTBILLINGFILE_TELSTRA_OBS_DATA_SMARTBUSINCLUDEDRATE = 1109; // 2nd invoice
                                                   // type for Smartbus data.
  PIMPORTBILLINGFILE_TELSTRA_MOBILE        = 1110; // Mobile phone, old EBS bill.
  PIMPORTBILLINGFILE_TELSTRA_OBS_PABX      = 1111; // PABX Phone Services CSV Bill.
  PIMPORTBILLINGFILE_TELSTRA_ORIG_EBS_FIXED= 1112; // Landline, old EBS bill.
  PIMPORTBILLINGFILE_TELSTRA_EBS_PABX      = 1113; // PABX Phone Services EBS Bill.

  
  IMPORTBILLINGFILE_VODAFONE               = 1201;


  PMIN_AUTOMATIC_INVOICE     = 2000;  // Range 2xxx: Automatic or Calculated.
  PMAX_AUTOMATIC_INVOICE     = 2999;
  PMIN_AUTOMATIC_ANNUAL      = 2000;  // Range 2xxx: Automatic or Calculated.
  PMAX_AUTOMATIC_ANNUAL      = 2099;
  PAUTOMATIC_ANNUAL                        = 2001;
  PAUTOMATIC_ANNUAL_SMARTBUS               = 2002;
  PAUTOMATIC_ANNUAL_CAMS                   = 2003;
  PAUTOMATIC_ANNUAL_KAMCO                  = 2004;


  PAUTOMATIC_TELMAX_RENT_CALLS             = 2101;
  PAUTOMATIC_TELMAX_DIVERSIONS             = 2102;


  PAUTOMATIC_QUETZAL_FAULTS                = 2201;
  PAUTOMATIC_QUETZAL_FAULTS_RADIO          = 2202;
  PAUTOMATIC_QUETZAL_TAXI                  = 2203;


  PAUTOMATIC_QUOTE_INSTALL                 = 2301;
  PAUTOMATIC_QUOTE_PURCHASE                = 2302;


  PAUTOMATIC_SECURITY                      = 2401;
  PAUTOMATIC_SERVICE                       = 2402;


  PMIN_MANUAL_INVOICE        = 3000;  // Range 3xxx: Manual Entry to Database.
  PMAX_MANUAL_INVOICE        = 3999;
  PMANUAL_MANUAL                           = 3001; // Manual invoice entry.

  
  // Ini file directory location.
  INIFILEDIRECTORY      = 'C:\Docume~1\alluse~1\applic~1\ppsystem\';
//  INIFILEDIRECTORY      = 'C:\Progra~3\ppsystem\';

implementation

end.
