unit LoginFrm;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, SysUtils;

type
  TLoginForm = class(TForm)
    lblEnterPassword: TLabel;
    lblEnterName: TLabel;
    edtName: TEdit;
    edtPassword: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    lblEnterDSN: TLabel;
    edtDSN: TEdit;
  public
  end;

function GetLoginParams(const sAliasDSN: string; const Startup: boolean;
      var sDSN: string; ALoginParams: TStrings): Boolean;

implementation

uses
  Main, DataMod;

{$R *.DFM}

function GetLoginParams(const sAliasDSN: string; const Startup: boolean;
  var sDSN: string; ALoginParams: TStrings): Boolean;
var
  LoginForm: TLoginForm;
  sTempString : string;
begin
  Result := False;
  LoginForm := TLoginForm.Create(nil);
  LoginForm.edtDSN.Text := sDSN;
  if Startup then begin
    LoginForm.Caption := 'SQLServer ODBC Link: '+sAliasDSN;
    LoginForm.lblEnterName.Caption := 'Enter ODBC identity:';
    LoginForm.edtName.Text := 'sa';
  end
  else begin
    // Do not ask for a database name.
    LoginForm.lblEnterDSN.Visible := False;
    LoginForm.edtDSN.Visible := False;
    // Do not allow the login/user name to be changed.
    LoginForm.lblEnterName.Caption := 'User Name:';
    LoginForm.edtName.Enabled := False;
    LoginForm.edtName.Text := MainForm.OperatorName;
  end;
  try
    if (LoginForm.ShowModal = mrOk) then begin
      ALoginParams.Values['USER NAME'] := Trim(LoginForm.edtName.Text);
      sTempString := Trim(LoginForm.edtPassWord.Text);
      if Length(sTempString) > 0 then
      ALoginParams.Values['PASSWORD'] := sTempString;
      sDSN := Trim(LoginForm.edtDSN.Text);
      Result := True;
    end;
  finally
    LoginForm.Free;
  end;
end;

end.

