unit CommonControlFns;

interface

uses
  Classes, dbtables, Registry, SysUtils;

function GetComboBoxItems(const TabPageID: integer): TStringList;

implementation

uses
  ConstantValuesSys, DataMod, PPSysMain;


function GetComboBoxItems(const TabPageID: integer): TStringList;
// Show the fields that can be used for a search by the user.
var
  qryStringList : TStringList;
//  CurrentTabSheetName : string;
  CurrentTabID : integer;
begin
  CurrentTabID := TabPageID;
  qryStringList := TStringList.Create;
  if (CurrentTabID = TabActivityID)                 then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
  end  // TabActivityID.
  else if (CurrentTabID = TabAdjustmentID)          then begin
    qryStringList.Add('ServiceID');
    qryStringList.Add('ServiceType');
    qryStringList.Add('Description');
    qryStringList.Add('CallCode');
    qryStringList.Add('RateDescription');
    qryStringList.Add('BatchID');
  end  // TabAdjustmentID.
  else if (CurrentTabID = TabAgreementID)           then begin
    qryStringList.Add('ID');
    qryStringList.Add('AgreementNo');
    qryStringList.Add('SupplierID');
    qryStringList.Add('Supplier');
  end  // TabAgreementID.
  else if (CurrentTabID = TabAgreementTariffsID)    then begin
    qryStringList.Add('ID');
    qryStringList.Add('AgreementNo');
    qryStringList.Add('AgreementType');
    qryStringList.Add('SupplierID');
    qryStringList.Add('Supplier');
    qryStringList.Add('Code');
    qryStringList.Add('ValidAccountNo');
  end  // TabAgreementTariffsID.
  else if (CurrentTabID = TabAgreementTypeID)       then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabAgreementTypeID.
  else if (CurrentTabID = TabApplicationID)         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabApplicationID.
  else if (CurrentTabID = TabAuditID)               then begin
    qryStringList.Add('ID');
    qryStringList.Add('[Table]');
    qryStringList.Add('UserLogin');
  end  // TabAuditID.
  else if (CurrentTabID = TabAuditTrailID)          then begin
    qryStringList.Add('UserID');
    qryStringList.Add('Action');
    qryStringList.Add('TableName');
    qryStringList.Add('TableID');
    qryStringList.Add('FieldName');
    qryStringList.Add('OldValue');
    qryStringList.Add('NewValue');
  end  // TabAuditTrailID.
  else if (CurrentTabID = TabBatchID)               then begin
    qryStringList.Add('ID');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchType');
    qryStringList.Add('BatchStatusID');
    qryStringList.Add('BatchStatus');
    qryStringList.Add('BillingPeriod');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierAccountID');
    qryStringList.Add('InvoiceNo');
    qryStringList.Add('RequisitionNumber');
    qryStringList.Add('OrderNumber');
    qryStringList.Add('TenderNo');
  end  // TabBatchID.
  else if (CurrentTabID = TabBatchHistoryID)        then begin
    qryStringList.Add('ID');
    qryStringList.Add('BatchID');
    qryStringList.Add('BatchType');
    qryStringList.Add('BatchStatusID');
    qryStringList.Add('BatchStatus');
    qryStringList.Add('Date');
    qryStringList.Add('BillingPeriod');
    qryStringList.Add('UserID');
    qryStringList.Add('Operator');
  end  // TabBatchHistoryID.
  else if (CurrentTabID = TabBatchStatusID)         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabBatchStatusID.
  else if (CurrentTabID = TabBatchTypeID)           then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('DataSourceTypeID');
    qryStringList.Add('DataSource');
    qryStringList.Add('ValidAccount');
    qryStringList.Add('ProgramDesc');
    qryStringList.Add('TenderNo');
    qryStringList.Add('AccountNoName');
    qryStringList.Add('InvoiceNoName');
    qryStringList.Add('TotalRevenueName');
    qryStringList.Add('TotalPayableName');
    qryStringList.Add('TotalCreditsName');
    qryStringList.Add('OpeningBalanceName');
    qryStringList.Add('PaymentsReceivedName');
    qryStringList.Add('TotalAdjustmentsName');
    qryStringList.Add('BatchStartName');
    qryStringList.Add('BatchEndName');
    qryStringList.Add('PaymentDateName');
    qryStringList.Add('CreditsToCustomersName');
    qryStringList.Add('GSTname');
    qryStringList.Add('GSTAdjustmentName');
    qryStringList.Add('OrderNumberName');
    qryStringList.Add('RequisitionNumberName');
    qryStringList.Add('IssueDateName');
    qryStringList.Add('RoundingName');
  end  // TabBatchTypeID.
  else if (CurrentTabID = TabCentreID)              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('DepartmentID');
    qryStringList.Add('Department');
    qryStringList.Add('GroupID');
    qryStringList.Add('GroupName');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('FullName');
  end  // TabCentreID.
  else if (CurrentTabID = TabCostRangeID)           then begin
    qryStringList.Add('ValidAccountNumberID');
    qryStringList.Add('AccountNo');
    qryStringList.Add('TransactionTypeID');
    qryStringList.Add('TransactionType');
  end  // TabCostRangeID.
  else if (CurrentTabID = TabCriticalTypeID)        then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabCriticalTypeID.
  else if (CurrentTabID = TabCustomerID)            then begin
    qryStringList.Add('ID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('FullName');
    qryStringList.Add('VNumber');
    qryStringList.Add('Address01');
    qryStringList.Add('Address02');
    qryStringList.Add('Address03');
    qryStringList.Add('Address04');
    qryStringList.Add('Address05');
    qryStringList.Add('Address06');
    qryStringList.Add('Status');
    qryStringList.Add('Invoice');
    qryStringList.Add('InvoiceServices');
    qryStringList.Add('PlatinumUpdate');
  end  // TabCustomerID.
  else if (CurrentTabID = TabDataCollectionMapID)   then begin
    qryStringList.Add('DCField');
    qryStringList.Add('DCValue');
    qryStringList.Add('TransValue');
  end  // TabDataCollectionMapID.
  else if (CurrentTabID = TabDataSourceDetailID)    then begin
  end  // TabDataSourceDetailID.
  else if (CurrentTabID = TabDataSourceTypeID)      then begin
    qryStringList.Add('ID');
    qryStringList.Add('DataSource');
  end  // TabDataSourceTypeID.
  else if (CurrentTabID = TabDepartmentID)          then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('GroupID');
    qryStringList.Add('GroupName');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
  end  // TabDepartmentID.
  else if (CurrentTabID = TabDestinationID)         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabDestinationID.
  else if (CurrentTabID = TabDialledNumberID)       then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabDialledNumberID.
  else if (CurrentTabID = TabDiscountID)            then begin
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
  end  // TabDiscountID.
  else if (CurrentTabID = TabDiscountedRateID)      then begin
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
  end  // TabDiscountedRateID.
  else if (CurrentTabID = TabDubiousResolutionID)   then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabDubiousResolutionID.
  else if (CurrentTabID = TabDubiousResultID)       then begin
    qryStringList.Add('ID');
    qryStringList.Add('BatchID');
    qryStringList.Add('ServiceID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('UserLogin');
    qryStringList.Add('DubiousResolution');
    qryStringList.Add('DubiousType');
    qryStringList.Add('Code');
  end  // TabDubiousResultID.
  else if (CurrentTabID = TabDubiousTypeID)         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabDubiousTypeID.
  else if (CurrentTabID = TabDubiousValidResolutionID) then begin
    qryStringList.Add('ID');
    qryStringList.Add('DubiousTypeID');
    qryStringList.Add('DubiousType');
    qryStringList.Add('DubiousResolutionID');
    qryStringList.Add('Resolution');
  end  // TabDubiousValidResolutionID.
  else if (CurrentTabID = TabElementID)             then begin
    qryStringList.Add('ID');
    qryStringList.Add('ElementCode');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('ServiceGroupID');
    qryStringList.Add('PlatinumUpdate');
    qryStringList.Add('ReportGroupID');
  end  // TabElementID.
  else if (CurrentTabID = TabFunctionID)            then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabFunctionID.
  else if (CurrentTabID = TabGroupID)               then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
  end  // TabGroupID.
  else if (CurrentTabID = TabLocationID)            then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabLocationID.
  else if (CurrentTabID = TabOriginID)              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabOriginID.
  else if (CurrentTabID = TabParameterID)           then begin
    qryStringList.Add('Parm');
    qryStringList.Add('ParmField');
    qryStringList.Add('ParmText');
//    qryStringList.Add('ParmNumber');
//    qryStringList.Add('ParmDate');
    qryStringList.Add('ParmDescription');
//    qryStringList.Add('ParmUserDefined');
  end  // TabParameterID.
  else if (CurrentTabID = TabPersonID)              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Person');
    qryStringList.Add('EmailAddress');
  end  // TabPersonID.
  else if (CurrentTabID = TabProgramID)             then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabProgramID.
  else if (CurrentTabID = TabRateID)                then begin
    qryStringList.Add('ID');
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('RateDescription');
    qryStringList.Add('LastUpdatedBy');
  end  // TabRateID.
  else if (CurrentTabID = TabRateDescriptionID)     then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabRateDescriptionID.
  else if (CurrentTabID = TabServiceIDID)           then begin
    qryStringList.Add('ID');
    qryStringList.Add('ServiceID');
    qryStringList.Add('Service');
    qryStringList.Add('Jobno');
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('SACC');
    qryStringList.Add('Description');
    qryStringList.Add('SupplierAccountID');
    qryStringList.Add('AccountNo');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('Customer');
    qryStringList.Add('CustomerCentreID');
    qryStringList.Add('CustomerCentre');
    qryStringList.Add('CustomerActivityID');
    qryStringList.Add('CustomerActivity');
    qryStringList.Add('CustomerElementID');
    qryStringList.Add('CustomerElement');
    qryStringList.Add('CustomerSubledgerID');
    qryStringList.Add('CustomerSubledger');
    qryStringList.Add('PayType');
    qryStringList.Add('CentreID');
    qryStringList.Add('Centre');
    qryStringList.Add('ActivityID');
    qryStringList.Add('Activity');
    qryStringList.Add('ElementID');
    qryStringList.Add('Element');
    qryStringList.Add('SubledgerID');
    qryStringList.Add('Subledger');
    qryStringList.Add('LocationID');
    qryStringList.Add('Location');
    qryStringList.Add('PersonID');
    qryStringList.Add('Person');
    qryStringList.Add('App_ID');
    qryStringList.Add('Application');
    qryStringList.Add('UpEnd');
    qryStringList.Add('UpMDF');
    qryStringList.Add('DownEnd');
    qryStringList.Add('DownMDF');
  end  // TabServiceIDID.
  else if (CurrentTabID = TabServiceKpiID)          then begin  // 100304 RJC.
    qryStringList.Add('ID');
    qryStringList.Add('KpiNumber');
    qryStringList.Add('Description');
    qryStringList.Add('ResponseHours');
    qryStringList.Add('RestorationHours');
    qryStringList.Add('Availability');
    qryStringList.Add('CoreHours');
    qryStringList.Add('AfterHours');
    qryStringList.Add('TravelTime');
    qryStringList.Add('FaultDetect');
  end  // TabServiceKpiID.
  else if (CurrentTabID = TabServiceMnemonicID)     then begin  // 111112 RJC.
    qryStringList.Add('ID');
    qryStringList.Add('ServiceCode');
    qryStringList.Add('Description');
    qryStringList.Add('Prefix');
    qryStringList.Add('Pass');
  end  // TabServiceMnemonicID.
  else if (CurrentTabID = TabServiceSplitID)        then begin
    qryStringList.Add('ID');
    qryStringList.Add('ServiceID');
    qryStringList.Add('ServiceID_Desc');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('CallPercentage');
    qryStringList.Add('RentPercentage');
    qryStringList.Add('OtherPercentage');
  end  // TabServiceSplitID.
  else if (CurrentTabID = TabServiceSystemID)       then begin
    qryStringList.Add('ServTypID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('SuppID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('SysID');
    qryStringList.Add('System');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchTypeDescription');
    qryStringList.Add('ValidID');
    qryStringList.Add('AccountNo');
  end  // TabServiceSystemID.
  else if (CurrentTabID = TabServiceTypeID)         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Code');
    qryStringList.Add('Description');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('RevElementID');
    qryStringList.Add('RevenueElement');
    qryStringList.Add('ExpElementID');
    qryStringList.Add('ExpenseElement');
    qryStringList.Add('AdminFee');
    qryStringList.Add('SystemID');
    qryStringList.Add('System');
    qryStringList.Add('ExportToTims');
    qryStringList.Add('SplitService');
    qryStringList.Add('VRTServiceType');
    qryStringList.Add('ExpectedRent');
    qryStringList.Add('NoCalls');
    qryStringList.Add('Active');
  end  // TabServiceTypeID.
  else if (CurrentTabID = TabStatusID)              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Status');
    qryStringList.Add('Active');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('LastUpdatedBy');
  end  // TabStatusID.
  else if (CurrentTabID = TabSubledgerID)           then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end  // TabSubledgerID.
  else if (CurrentTabID = TabSupplierID)            then begin
    qryStringList.Add('ID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('PlatinumVendorID');
    qryStringList.Add('PlatinumUpdate');
    qryStringList.Add('VicTrack');
    qryStringList.Add('Address01');
    qryStringList.Add('System');
  end  // TabSupplierID.
  else if (CurrentTabID = TabSupplierServiceCodeID) then begin
    qryStringList.Add('ID');
    qryStringList.Add('Code');
    qryStringList.Add('AmountCategory');
    qryStringList.Add('Description');
    qryStringList.Add('TransactionTypeDesc');
    qryStringList.Add('TransactionTypeID');
    qryStringList.Add('TransactionType');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
  end  // TabSupplierServiceCodeID.
  else if (CurrentTabID = TabSystemID)              then begin
    qryStringList.Add('ID');
    qryStringList.Add('System');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchType');
  end  // TabSystemID.
  else if (CurrentTabID = TabTransactionGroupID)    then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end  // TabTransactionGroupID.
  else if (CurrentTabID = TabTransactionTypeID)     then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('TransactionGroupID');
    qryStringList.Add('TransactionGroup');
    qryStringList.Add('SystemID');
    qryStringList.Add('System');
  end  // TabTransactionTypeID.
  else if (CurrentTabID = TabUserID)                then begin
    qryStringList.Add('ID');
    qryStringList.Add('UserLogin');
//    qryStringList.Add('Password');
    qryStringList.Add('FirstName');
    qryStringList.Add('Surname');
  end  // TabUserID.
  else if (CurrentTabID = TabUserFunctionID)        then begin
    qryStringList.Add('UserLogin');
    qryStringList.Add('Password');
    qryStringList.Add('FirstName');
    qryStringList.Add('Surname');
  end  // TabUserFunctionID.
  else if (CurrentTabID = TabValidAccountID)        then begin
    qryStringList.Add('ID');
    qryStringList.Add('AccountNo');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchType');
    qryStringList.Add('Active');
  end;  // TabValidAccountID.
  Result := qryStringList;
end;    // SetComboBoxItems().

end.

