unit SysEdit;
{
121104 RJC GetEdit7/8 always return Date. Test before call ensures valid.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, comctrls, dbtables, Mask, ToolEdit, Db;

type
  TSysEditForm = class(TForm)
    lblEdit1: TLabel;
    edtEdit1: TEdit;
    lblEdit2: TLabel;
    edtEdit2: TEdit;
    btnOk: TButton;
    btnCancel: TButton;
    lblEdit3: TLabel;
    edtEdit3: TEdit;
    lblEdit4: TLabel;
    edtEdit4: TEdit;
    lblEdit5: TLabel;
    edtEdit5: TEdit;
    lblEdit6: TLabel;
    edtEdit6: TEdit;
    lblEdit7: TLabel;
    lblEdit8: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    edtEdit7: TDateEdit;
    edtEdit8: TDateEdit;
    lblEdit9: TLabel;
    edtEdit9: TEdit;
    lblEdit10: TLabel;
    edtEdit10: TEdit;
    procedure btnOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    tblTypeID : integer;            // Known type of table.
    AmendString : TStringList;
    AuditString : TStringList;
    lAppend : boolean;
    sUserName : string;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    Original_Edit1Text : string;
    Original_Edit2Text : string;
    Original_Edit3Text : string;
    Original_Edit4Text : string;
    Original_Edit5Text : string;
    Original_Edit6Text : string;
    Original_Edit7Text : string;
    Original_Edit8Text : string;
    Original_Edit9Text : string;
    Original_Edit10Text: string;
    Original_Check1 : boolean;
    Original_Check2 : boolean;
    Original_Check3 : boolean;
    Original_Check4 : boolean;
  protected
    procedure SetTable(Value: Integer);
    procedure SetAppend(Value: boolean);
    procedure SetEdit1(Value: string);
    function GetEdit1: string;
    procedure SetEdit2(Value: string);
    function GetEdit2: string;
    procedure SetEdit3(Value: string);
    function GetEdit3: string;
    procedure SetEdit4(Value: string);
    function GetEdit4: string;
    procedure SetEdit5(Value: string);
    function GetEdit5: string;
    procedure SetEdit6(Value: string);
    function GetEdit6: string;
    procedure SetEdit7(Value: TDateTime);
    function GetEdit7: TDateTime;
    procedure SetEdit8(Value: TDateTime);
    function GetEdit8: TDateTime;
    procedure SetEdit9(Value: string);
    function GetEdit9: string;
    procedure SetEdit10(Value: string);
    function GetEdit10: string;
    procedure SetCheck1(Value: boolean);
    function GetCheck1: boolean;
    procedure SetCheck2(Value: boolean);
    function GetCheck2: boolean;
    procedure SetCheck3(Value: boolean);
    function GetCheck3: boolean;
    procedure SetCheck4(Value: boolean);
    function GetCheck4: boolean;
  published
    property TableNameID: Integer read tblTypeID write SetTable default -1;
    property AppendMode: boolean read lAppend write SetAppend;
    property Edit1: string read GetEdit1 write SetEdit1;
    property Edit2: string read GetEdit2 write SetEdit2;
    property Edit3: string read GetEdit3 write SetEdit3;
    property Edit4: string read GetEdit4 write SetEdit4;
    property Edit5: string read GetEdit5 write SetEdit5;
    property Edit6: string read GetEdit6 write SetEdit6;
    property Edit7: TDateTime read GetEdit7 write SetEdit7;
    property Edit8: TDateTime read GetEdit8 write SetEdit8;
    property Edit9: string read GetEdit9 write SetEdit9;
    property Edit10: string read GetEdit10 write SetEdit10;
    property Check1: boolean read GetCheck1 write SetCheck1;
    property Check2: boolean read GetCheck2 write SetCheck2;
    property Check3: boolean read GetCheck3 write SetCheck3;
    property Check4: boolean read GetCheck4 write SetCheck4;
  public
    { Public declarations }
  end;

var
  SysEditForm: TSysEditForm;

implementation

uses
  ConstantValuesSys,
  DataMod, DateFunctions,
  GenFns,
  PPSysMain;

{$R *.DFM}

procedure TSysEditForm.FormCreate(Sender: TObject);
var
  qSysEdit : TQuery;
  ActionDescription : string;
begin
  tblTypeID := -1;
  btnOk.Enabled := False;
  lAppend := False;
  AmendString := TStringList.Create;
  AuditString := TStringList.Create;
  sUserName := Trim(MainForm.OPERATORNAME);
  qSysEdit := TQuery.Create(nil);
  qSysEdit.DatabaseName := 'dbPPdata';
  qSysEdit.SQL.Add('SELECT *');
  qSysEdit.SQL.Add('FROM tEvent');
  qSysEdit.SQL.Add('WHERE Description LIKE ''Reference%''');
  qSysEdit.Open;
  while not qSysEdit.Eof do begin
    ActionDescription := UpperCase(qSysEdit.FieldByName('Description').AsString);
    if (Pos('UPDATE', ActionDescription) > 0) then
      AuditActionUpdate := qSysEdit.FieldByName('id').AsString
    else if (Pos('DELETE', ActionDescription) > 0) then
      AuditActionDelete := qSysEdit.FieldByName('id').AsString
    else if (Pos('INSERT', ActionDescription) > 0) then
      AuditActionInsert := qSysEdit.FieldByName('id').AsString;
    qSysEdit.Next;
  end;
  qSysEdit.Close;
  qSysEdit.Free;
end;  // FormCreate().

procedure TSysEditForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  AmendString.Free;
end;  // FormClose.

procedure TSysEditForm.SetAppend(Value: boolean);
begin
  lAppend := Value;
  if lAppend then Caption := Caption + ' (ADD)'
  else            Caption := Caption + ' (EDIT)';
  if (tblTypeID = TABLE_PROGRAM) then edtEdit1.Enabled := lAppend;
end;  // SetAppend.

procedure TSysEditForm.SetEdit1(Value: string);
begin
  Original_Edit1Text := Value;
  edtEdit1.Text := Original_Edit1Text;
end;  // SetEdit1.

function TSysEditForm.GetEdit1: string;
begin
  Result := Trim(edtEdit1.Text);
end;  // GetEdit1.

procedure TSysEditForm.SetEdit2(Value: string);
begin
  Original_Edit2Text := Value;
  edtEdit2.Text := Original_Edit2Text;
end;  // SetEdit2.

function TSysEditForm.GetEdit2: string;
begin
  Result := Trim(edtEdit2.Text);
end;  // GetEdit2.

procedure TSysEditForm.SetEdit3(Value: string);
begin
  Original_Edit3Text := Value;
  edtEdit3.Text := Original_Edit3Text;
end;  // SetEdit3.

function TSysEditForm.GetEdit3: string;
begin
  Result := Trim(edtEdit3.Text);
end;  // GetEdit3.

procedure TSysEditForm.SetEdit4(Value: string);
begin
  Original_Edit4Text := Value;
  edtEdit4.Text := Original_Edit4Text;
end;  // SetEdit4.

function TSysEditForm.GetEdit4: string;
begin
  Result := Trim(edtEdit4.Text);
end;  // GetEdit4.

procedure TSysEditForm.SetEdit5(Value: string);
begin
  Original_Edit5Text := Value;
  edtEdit5.Text := Original_Edit5Text;
end;  // SetEdit5.

function TSysEditForm.GetEdit5: string;
begin
  Result := Trim(edtEdit5.Text);
end;  // GetEdit5.

procedure TSysEditForm.SetEdit6(Value: string);
begin
  Original_Edit6Text := Value;
  edtEdit6.Text := Original_Edit6Text;
end;  // SetEdit6.

function TSysEditForm.GetEdit6: string;
begin
  Result := Trim(edtEdit6.Text);
end;  // GetEdit6.

procedure TSysEditForm.SetEdit7(Value: TDateTime);
begin
  if not VarIsNull(Value) then begin
    Original_Edit7Text := StandardDateString(Value);
    edtEdit7.Date := Value;
  end;
end;  // SetEdit7.

function TSysEditForm.GetEdit7: TDateTime;
begin
//  if (Length(Edit7Text)=8) then      // Commented-out RJC: 121104.
       Result := edtEdit7.Date
//  else Result := NULL;               // Commented-out RJC: 121104.
end;  // GetEdit7.

procedure TSysEditForm.SetEdit8(Value: TDateTime);
begin
  if not VarIsNull(Value) then begin
    Original_Edit8Text := StandardDateString(Value);
    edtEdit8.Date := Value;
  end;
end;  // SetEdit8.

function TSysEditForm.GetEdit8: TDateTime;
begin
//  if (Length(Edit8Text)=8) then      // Commented-out RJC: 121104.
       Result := edtEdit8.Date
//  else Result := NULL;               // Commented-out RJC: 121104.
end;  // GetEdit8.

procedure TSysEditForm.SetEdit9(Value: string);
begin
  Original_Edit9Text := Value;
  edtEdit9.Text := Original_Edit9Text;
end;  // SetEdit9.

function TSysEditForm.GetEdit9: string;
begin
  Result := Trim(edtEdit9.Text);
end;  // GetEdit9.

procedure TSysEditForm.SetEdit10(Value: string);
begin
  Original_Edit10Text := Value;
  edtEdit10.Text := Original_Edit10Text;
end;  // SetEdit10.

function TSysEditForm.GetEdit10: string;
begin
  Result := Trim(edtEdit10.Text);
end;  // GetEdit10.

procedure TSysEditForm.SetCheck1(Value: boolean);
begin
  Original_Check1 := Value;
  CheckBox1.Checked := Original_Check1;
end;  // SetCheck1.

function TSysEditForm.GetCheck1: boolean;
begin
  Result := CheckBox1.Checked;
end;  // GetCheck1.

procedure TSysEditForm.SetCheck2(Value: boolean);
begin
  Original_Check2 := Value;
  CheckBox2.Checked := Original_Check2;
end;  // SetCheck2.

function TSysEditForm.GetCheck2: boolean;
begin
  Result := CheckBox2.Checked;
end;  // GetCheck2.

procedure TSysEditForm.SetCheck3(Value: boolean);
begin
  Original_Check3 := Value;
  CheckBox3.Checked := Original_Check3;
end;  // SetCheck3.

function TSysEditForm.GetCheck3: boolean;
begin
  Result := CheckBox3.Checked;
end;  // GetCheck3.

procedure TSysEditForm.SetCheck4(Value: boolean);
begin
  Original_Check4 := Value;
  CheckBox4.Checked := Original_Check4;
end;  // SetCheck4.

function TSysEditForm.GetCheck4: boolean;
begin
  Result := CheckBox4.Checked;
end;  // GetCheck4.

procedure TSysEditForm.SetTable(Value: Integer);
begin
  if (Value > -1) and (Value < TABLE_MAX+1) then begin
    tblTypeID := Value;
    btnOk.Enabled := True;
    if (tblTypeID = TABLE_ACTIVITY) then begin
      Caption := Caption + ': tActivity';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'CustomerID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'ShipTo';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tActivity');
    end   // if TABLE_ACTIVITY.
    else if (tblTypeID = TABLE_AGREEMENT) then begin
      Caption := Caption + ': tAgreement';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'AgreementNo';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'SupplierID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Supplier';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'AgreementDateFrom';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'AgreementDateTo';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tAgreement');
    end   // if TABLE_AGREEMENT.
    else if (tblTypeID = TABLE_AGREEMENTTYPE) then begin
      Caption := Caption + ': tAgreementType';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tAgreementType');
    end   // if TABLE_AGREEMENTTYPE.
    else if (tblTypeID = TABLE_APPLICATION) then begin
      Caption := Caption + ': tApplication';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tApplication');
    end   // if TABLE_APPLICATION.
    else if (tblTypeID = TABLE_CENTRE) then begin
      Caption := Caption + ': tCentre';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'DepartmentID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Department';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tCentre');
    end   // if TABLE_CENTRE.
    else if (tblTypeID = TABLE_COSTRANGE) then begin
      Caption := Caption + ': tCostRange';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Visible := False;
      edtEdit2.Visible := False;
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'ValidAccountNumberID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'ValidAccountNumber';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'TransactionTypeID';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Caption := 'TransactionType';
      edtEdit6.Visible := True;
      edtEdit6.Enabled := False;
      lblEdit9.Visible := True;
      lblEdit9.Caption := 'CostRangeFrom';
      edtEdit9.Visible := True;
      lblEdit10.Visible:= True;
      lblEdit10.Caption:= 'CostRangeTo';
      edtEdit10.Visible:= True;
      lAudit := TestForAudit('tCostRange');
    end   // TABLE_COSTRANGE.
    else if (tblTypeID = TABLE_CRITICALTYPE) then begin
      Caption := Caption + ': tCriticalType';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tCriticalType');
    end   // TABLE_CRITICALTYPE.
    else if (tblTypeID = TABLE_DEPARTMENT) then begin
      Caption := Caption + ': tDepartment';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'GroupID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'GroupName';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tDepartment');
    end   // if TABLE_DEPARTMENT.
    else if (tblTypeID = TABLE_DESTINATION) then begin
      Caption := Caption + ': tDestination';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tDestination');
    end  // TABLE_DESTINATION.
    else if (tblTypeID = TABLE_DISCOUNT) then begin
      Caption := Caption + ': tDiscount';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'DiscountRate (max 100)';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'ServiceTypeID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Code + ServiceType';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'CustomerID';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Caption := 'ShipTo';
      edtEdit6.Visible := True;
      edtEdit6.Enabled := False;
      lblEdit9.Visible := True;
      lblEdit9.Caption := 'NonStdRevAdminFee %';
      edtEdit9.Visible := True;
      lblEdit10.Visible:= True;
      lblEdit10.Caption:= 'NonStdExpAdminFee %';
      edtEdit10.Visible:= True;
      lAudit := TestForAudit('tDiscount');
    end   // if TABLE_DISCOUNT.
    else if (tblTypeID = TABLE_DISCOUNTEDRATE) then begin
      Caption := Caption + ': tDiscountedRate';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Rate (max 100)';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'ServiceTypeID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Code + ServiceType';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'CustomerID';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Caption := 'ShipTo';
      edtEdit6.Visible := True;
      edtEdit6.Enabled := False;
      lAudit := TestForAudit('tDiscountedRate');
    end   // if TABLE_DISCOUNTEDRATE.
    else if (tblTypeID = TABLE_DUBIOUSTYPE) then begin
      Caption := Caption + ': tDubiousType';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tDubiousType');
    end   // TABLE_DUBIOUSTYPE.
    else if (tblTypeID = TABLE_DUBIOUSRESOLUTION) then begin
      Caption := Caption + ': tDubiousResolution';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tDubiousResolution');
    end   // TABLE_DUBIOUSRESOLUTION.
    else if (tblTypeID = TABLE_DUBIOUSVALIDRESN) then begin
      Caption := Caption + ': tDubiousValidResolution';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Visible := False;
      edtEdit2.Visible := False;
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'DubiousTypeID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'DubiousType';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'ResolutionID';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Caption := 'Resolution';
      edtEdit6.Visible := True;
      edtEdit6.Enabled := False;
      lAudit := TestForAudit('tDubiousValidResolution');
    end  // TABLE_DUBIOUSVALIDRESN.
    else if (tblTypeID = TABLE_ELEMENT) then begin
      Caption := Caption + ': tElement';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'ServiceGroupID';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'ElementCode';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Description';
      edtEdit4.Visible := True;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'CustomerID';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Caption := 'ShipTo';
      edtEdit6.Visible := True;
      edtEdit6.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lblEdit9.Visible := True;
      lblEdit9.Caption := 'ReportGroupID';
      edtEdit9.Visible := True;
      CheckBox1.Visible := True;
      CheckBox1.Caption := 'Platinum Update';
      CheckBox2.Visible := True;
      CheckBox2.Caption := 'Lost Revenue';
      lAudit := TestForAudit('tElement');
    end   // if TABLE_ELEMENT.
    else if (tblTypeID = TABLE_FUNCTION) then begin
      Caption := Caption + ': tFunction';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tFunction');
    end   // TABLE_FUNCTION.
    else if (tblTypeID = TABLE_GROUP) then begin
      Caption := Caption + ': tGroup';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'CustomerID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'ShipTo';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tGroup');
    end   // if TABLE_GROUP.
    else if (tblTypeID = TABLE_LOCATION) then begin
      Caption := Caption + ': tLocation';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Location';
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tLocation');
    end   // if TABLE_LOCATION.
    else if (tblTypeID = TABLE_ORIGIN) then begin
      Caption := Caption + ': tOrigin';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tOrigin');
    end  // TABLE_ORIGIN.
    else if (tblTypeID = TABLE_PERSON) then begin
      Caption := Caption + ': tPerson';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Person';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'Email Address';
      edtEdit3.Visible := True;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tPerson');
    end   // if TABLE_PERSON.
    else if (tblTypeID = TABLE_MNEMONIC) then begin
      Caption := Caption + ': tServiceMnemonic';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'ServiceCode';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'Description';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Prefix';
      edtEdit4.Visible := True;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'Pass';
      edtEdit5.Visible := True;
      lAudit := TestForAudit('tServiceMnemonic');
    end   // if TABLE_MNEMONIC.
    else if (tblTypeID = TABLE_PROGRAM) then begin
      Caption := Caption + ': tProgram';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tProgram');
    end  // TABLE_PROGRAM.
    else if (tblTypeID = TABLE_RATE) then begin
      Caption := Caption + ': tRate';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'ServiceTypeID';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'Length';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Percentage';
      edtEdit4.Visible := True;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'Cost';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Caption := 'Cost100';
      edtEdit6.Visible := True;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lblEdit9.Visible := True;
      lblEdit9.Caption := 'RateDescription';
      edtEdit9.Visible := True;
      lblEdit10.Visible := True;
      lblEdit10.Caption := 'PartCost';
      edtEdit10.Visible := True;
      lAudit := TestForAudit('tRate');
    end   // TABLE_RATE.
    else if (tblTypeID = TABLE_RATEDESCRIPTION) then begin
      Caption := Caption + ': tRateDescription';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lAudit := TestForAudit('tRateDescription');
    end   // TABLE_RATEDESCRIPTION.
    else if (tblTypeID = TABLE_SUBLEDGER) then begin
      Caption := Caption + ': tSubledger';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'CustomerID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'ShipTo';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tSubledger');
    end  // if TABLE_SUBLEDGER.
    else if (tblTypeID = TABLE_SYSTEM) then begin
      Caption := Caption + ': tSystem';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'System';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'BatchTypeID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'BatchType';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lAudit := TestForAudit('tSystem');
    end   // if TABLE_SYSTEM.
{
    else if (tblTypeID = TABLE_ORIGIN) then begin
    end  // TABLE_ORIGIN.
    else if (tblTypeID = TABLE_ORIGIN) then begin
    end  // TABLE_ORIGIN.
}
    else if (tblTypeID = TABLE_TRANSACTIONTYPE) then begin
      Caption := Caption + ': tTransactionType';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'TransactionGroupID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Enabled := False;
      lblEdit4.Caption := 'TransactionGroup';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'SystemID';
      edtEdit5.Visible := True;
      lblEdit6.Visible := True;
      lblEdit6.Enabled := False;
      lblEdit6.Caption := 'System';
      edtEdit6.Visible := True;
      edtEdit6.Enabled := False;
      lblEdit7.Visible := True;
      lblEdit7.Caption := 'StartDate';
      edtEdit7.Visible := True;
      lblEdit8.Visible := True;
      lblEdit8.Caption := 'EndDate';
      edtEdit8.Visible := True;
      lAudit := TestForAudit('tTransactionType');
    end  // TABLE_TRANSACTIONTYPE.
    else if (tblTypeID = TABLE_TRANSACTIONGROUP) then begin
      Caption := Caption + ': tTransactionGroup';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Description';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'CostRangeFrom';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'CostRangeTo';
      edtEdit4.Visible := True;
      lAudit := TestForAudit('tTransactionGroup');
    end  // TABLE_TRANSACTIONGROUP.
    else if (tblTypeID = TABLE_USER) then begin
{  // Not used. Refer to file "SysEditUserFunction.pas".
   //
      Caption := Caption + ': tUser';
      lblEdit1.Caption := 'UserID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'Operator';
      edtEdit2.Enabled := True;
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'FirstName';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'Surname';
      edtEdit4.Visible := True;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'Password';
      edtEdit5.Visible := True;
      lAudit := TestForAudit('tUser');
}
    end  // TABLE_USER.
    else if (tblTypeID = TABLE_VALIDACCOUNT) then begin
      Caption := Caption + ': tValidAccountNumber';
      lblEdit1.Caption := 'ID';
      edtEdit1.Enabled := False;
      lblEdit2.Caption := 'AccountNo';
      lblEdit3.Visible := True;
      lblEdit3.Caption := 'BatchTypeID';
      edtEdit3.Visible := True;
      lblEdit4.Visible := True;
      lblEdit4.Caption := 'BatchType';
      edtEdit4.Visible := True;
      edtEdit4.Enabled := False;
      lblEdit5.Visible := True;
      lblEdit5.Caption := 'Tender No';
      edtEdit5.Visible := True;
      lAudit := TestForAudit('tValidAccountNumber');
    end;   // if TABLE_VALIDACCOUNT.
  end
  else begin
    tblTypeID := -1;
    btnOk.Enabled := False;
  end;
end;  // SetTable().

procedure TSysEditForm.btnOkClick(Sender: TObject);
var
  q: TQuery;
  sField : string;
  sValue : string;
  sTableName : string;
  sAuditInsert: string;
  sAuditField : string;
  sAuditValue : string;
  AuditAction : string;
  lReturn : boolean;
  sStarted : string;
  sError : string;
  sDate : string;
begin
  q := TQuery.Create(SELF);
  q.DatabaseName := 'dbPPdata';
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  lReturn := True;
  if (tblTypeID = TABLE_ACTIVITY) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'CustomerID must be a number.';
      Edit3 := sStarted;
    end
    else begin
      ProveForeignKey( 'tCustomer', StrToInt(sStarted), lReturn);
    end;
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'CustomerID does not exist.';
      Edit3 := sStarted;
    end
    else begin
      sTableName := 'tActivity';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description,CustomerID';
        sValue := 'VALUES ('''+ Edit2 +''','+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (Length(sStarted) > 0) then begin
            SetAuditData('CUSTOMERID', '', sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (Length(sStarted) > 0) then begin
            SetAuditData('DESCRIPTION', '', sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        if (Length(Trim(edtEdit7.Text)) > 0) and
          (Copy(Trim(edtEdit7.Text),1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        if (Length(Trim(edtEdit8.Text)) > 0) and
          (Copy(Trim(edtEdit8.Text),1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ Edit2 +''','+
          'CustomerID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('CUSTOMERID', Original_Edit3Text, sStarted,
              AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        if (Length(Trim(edtEdit8.Text)) = 0) or
          (Copy(Trim(edtEdit8.Text),1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
        // Make sure something has changed.
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND CustomerID = '+ Edit3);
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_ACTIVITY.

  else if (tblTypeID = TABLE_AGREEMENT) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'SupplierID must be a number.';
      Edit3 := sStarted;
    end
    else begin
      ProveForeignKey( 'tSupplier', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
        sError := 'SupplierID does not exist.';
        Edit3 := sStarted;
      end
    end;
    if lReturn then begin
      sTableName := 'tAgreement';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(AgreementNo,SupplierID';
        sValue := 'VALUES ('''+ Edit2 +''','+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (Length(sStarted) > 0) then begin
            SetAuditData('SUPPLIERID', '', sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (Length(sStarted) > 0) then begin
            SetAuditData('AGREEMENTNO', '', sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and
          (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and
          (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate';
          sValue := sValue + ',''' + sStarted +'''';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET AgreementNo = '''+ Edit2 +''','+
          'SupplierID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('SUPPLIERID', Original_Edit3Text, sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('AGREEMENTNO', Original_Edit2Text, sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        if (Length(Trim(edtEdit8.Text)) = 0) or
          (Copy(Trim(edtEdit8.Text),1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', AgreementDateTo = NULL';
            if lAudit then begin
              SetAuditData('AGREEMENTDATETO', Original_Edit8Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', AgreementDateTo = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('AGREEMENTDATETO', Original_Edit8Text, sStarted, AuditString);
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE AgreementNo LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_AGREEMENT.

  else if (tblTypeID = TABLE_AGREEMENTTYPE) then begin
    sTableName := 'tAgreementType';
    sStarted := Edit2;
    if (Length(sStarted) = 0) then begin
      sError := 'Description field is Mandatory.';
      lReturn := False;
    end
    else begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM '+sTableName);
      q.SQL.Add('WHERE Description LIKE '''+sStarted+'''');
      if not lAppend then q.SQL.Add('AND id <> '+Edit1);
      q.Open;
      lReturn := (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
      if not lReturn then begin
        sError := 'This Description already exists in the table. Data not saved.';
      end;
    end;  // Length(sStarted) = 0.
    if lReturn then begin
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(Description, Active)');
        AmendString.Add('VALUES ('''+sStarted+''', 1)');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
      end
      else begin
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // if TABLE_AGREEMENTTYPE.

  else if (tblTypeID = TABLE_APPLICATION) then begin
    sStarted := Edit2;
    if (Length(sStarted) = 0) then begin
      sError := 'Description field is Mandatory.';
      lReturn := False;
    end
    else begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM tApplication');
      q.SQL.Add('WHERE Description LIKE '''+sStarted+'''');
      if not lAppend then q.SQL.Add('AND id <> '+Edit1);
      q.Open;
      lReturn := (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
      if not lReturn then begin
        sError := 'This Description already exists in the table. Data not saved.';
      end;
    end;  // Length(sStarted) = 0.
    if lReturn then begin
      sTableName := 'tApplication';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(Description, Active)');
        AmendString.Add('VALUES ('''+sStarted+''', 1)');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
      end
      else begin
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_APPLICATION.

  else if (tblTypeID = TABLE_CENTRE) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'DepartmentID must be a number.';
      Edit3 := sStarted;
    end
    else begin
      ProveForeignKey( 'tDepartment', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
        sError := 'DepartmentID does not exist.';
        Edit3 := sStarted;
      end;
    end;
    if lReturn then begin
      sTableName := 'tCentre';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description,DepartmentID';
        sValue := 'VALUES ('''+ Edit2 +''','+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('DEPARTMENTID', Original_Edit3Text, sStarted,
              AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and
          (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and
          (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ Edit2 +''','+
          'DepartmentID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('DEPARTMENTID', Original_Edit3Text, sStarted,
              AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND DepartmentID = '+ Edit3);
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // if TABLE_CENTRE.

  else if (tblTypeID = TABLE_COSTRANGE) and
    (Length(Edit3) > 0) and
    (Length(Edit5) > 0) then begin
    sStarted := Edit5;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit5 := sStarted;
      sError := 'TransactionTypeID error - must be a number.';
    end
    else begin
      ProveForeignKey( 'tTransactionType', StrToInt(sStarted), lReturn);
      if not lReturn then begin           // Field value truncated - Not Okay!
        Edit5 := sStarted;
        sError := 'TransactionTypeID does not exist.';
      end;
    end;
    if lReturn then begin
      sStarted := Edit3;
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit3 := sStarted;
        sError := 'ValidAccountNumberID error - must be a number.';
      end
      else begin
        ProveForeignKey( 'tValidAccountNumber', StrToInt(sStarted), lReturn);
        if not lReturn then begin           // Field value truncated - Not Okay!
          sError := 'ValidAccountNumberID does not exist.';
        end
      end;
      if lReturn then begin             // Field value truncated - Not Okay!
        sStarted := Edit9;
        if (Length(sStarted) > 0) then begin
          ProveReal(sStarted,lReturn);
        end;
        if not lReturn then begin         // Field value truncated - Not Okay!
          Edit9 := sStarted;
          sError := 'CostRangeFrom error - must be a number.';
        end
        else begin
          sStarted := Edit10;
          if (Length(sStarted) > 0) then begin
            ProveReal(sStarted,lReturn);
          end;
          if not lReturn then begin       // Field value truncated - Not Okay!
            Edit10 := sStarted;
            sError := 'CostRangeTo error - must be a number.';
          end
          else if not lAppend then begin
            q.SQL.Add('SELECT tCostRange.id');
            q.SQL.Add('FROM tCostRange');
            q.SQL.Add('WHERE tCostRange.ValidAccountNumberID = '+Edit3);
            q.SQL.Add('AND tCostRange.TransactionTypeID = '+Edit5);
            q.Open;
            lReturn := q.Eof;
            q.Close;
            q.SQL.Clear;
            if not lReturn then begin     // Field values already entered!
              sError := 'This combination already exists. Changes not saved.';
            end;
          end;
        end;
      end;  // lReturn.
      if lReturn then begin
        sTableName := 'tCostRange';
        if lAppend then begin                                   // Append.
          AmendString.Add('INSERT INTO '+ sTableName);
          AmendString.Add('(ValidAccountNumberID, TransactionTypeID, '+
            'CostRangeFrom, CostRangeTo)');
          sValue := 'VALUES ('+ Edit3 +''', '+ Edit5 +', ';
          sStarted := Edit9;                                 // CostRangeFrom.
          if (Length(sStarted) = 0) then sStarted := 'NULL';
          sValue := sValue + sStarted + ', ';
          sStarted := Edit10;                                // CostRangeTo.
          if (Length(sStarted) = 0) then sStarted := 'NULL';
          sValue := sValue + sStarted + ')';
          AmendString.Add(sValue);
          if lAudit then begin                               // Save everything.
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            sStarted := Edit3;
            SetAuditData('VALIDACCOUNTNUMBERID', '', sStarted, AuditString);
            sStarted := Edit5;
            SetAuditData('TRANSACTIONTYPEID', '', sStarted, AuditString);
            sStarted := Edit9;
            if (Length(sStarted) = 0) then sStarted := 'NULL';
            SetAuditData('COSTRANGEFROM', '', sStarted, AuditString);
            sStarted := Edit10;
            if (Length(sStarted) = 0) then sStarted := 'NULL';
            SetAuditData('COSTRANGETO', '', sStarted, AuditString);
          end;  // lAudit.
        end  // lAppend.
        else begin                                              // Update.
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET ValidAccountNumberID = '+ Edit3 +',');
          AmendString.Add(' TransactionTypeID = '+ Edit5 + ',');
          sStarted := Edit9;
          if (Length(sStarted) = 0) then sStarted := 'NULL';
          AmendString.Add(' CostRangeFrom = '+ sStarted + ',');
          sStarted := Edit10;
          if (Length(sStarted) = 0) then sStarted := 'NULL';
          AmendString.Add(' CostRangeTo = '+ sStarted);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            sStarted := Edit3;
            if (sStarted <> Original_Edit3Text) then begin
              SetAuditData('VALIDACCOUNTNUMBERID', Original_Edit3Text,
                sStarted, AuditString);
            end;  // changed.
            sStarted := Edit5;
            if (sStarted <> Original_Edit5Text) then begin
              SetAuditData('TRANSACTIONTYPEID', Original_Edit5Text,
                sStarted, AuditString);
            end;  // changed.
            sStarted := Edit9;
            if (sStarted <> Original_Edit9Text) then begin
              if (Length(sStarted) = 0) then sStarted := 'NULL';
              if (Length(Original_Edit9Text) = 0) then
                SetAuditData('COSTRANGEFROM', 'NULL', sStarted, AuditString)
              else
                SetAuditData('COSTRANGEFROM', Original_Edit2Text,
                  sStarted, AuditString);
            end;
            sStarted := Edit10;
            if (sStarted <> Original_Edit10Text) then begin
              if (Length(sStarted) = 0) then sStarted := 'NULL';
              if (Length(Original_Edit10Text) = 0) then
                SetAuditData('COSTRANGETO', 'NULL', sStarted, AuditString)
              else
                SetAuditData('COSTRANGETO', Original_Edit2Text,
                  sStarted, AuditString);
            end;
            if (AuditString.Count = 0) then begin
              lReturn := False;
              sError := 'No data changes were detected.';
            end;
          end;  // lAudit.
        end;  // lAppend.
        if lReturn then begin                                   // Save.
          q.SQL := AmendString;
          q.ExecSQL;
          if lAudit then begin
            if lAppend then begin
              // Get and store the new ID for this table.
              with q do begin
                SQL.Clear;
                SQL.Add('SELECT ID');
                SQL.ADD('FROM '+ sTableName);
                SQL.Add('WHERE ValidAccountNumberID = '+ Edit3);
                SQL.Add('AND TransactionTypeID = '+ Edit5);
                Open;
                SetAuditID(FieldByName('ID').AsString, sAuditValue);
                Close;
              end;  // q.
            end;  // lAppend.
            SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
          end;  // lAudit.
        end;  // lReturn.
      end;  // lReturn.
    end;  // lReturn.
  end   // if TABLE_COSTRANGE.

  else if (tblTypeID = TABLE_CRITICALTYPE) then begin
    sStarted := Edit2;
    if (Length(sStarted) = 0) then begin
      lReturn := False;
      sError := 'A Description is Mandatory.';
    end
    else begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM tCriticalType');
      q.SQL.Add('WHERE Description LIKE '''+sStarted+'''');
      if not lAppend then
        q.SQL.Add('AND id <> '+Edit1);
      q.Open;
      lReturn := (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
      if not lReturn then begin
        sError := 'This Description already exists in the table. Data not saved.';
      end;
    end;  // value saved.
    if lReturn then begin
      sTableName := 'tCriticalType';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(Description)');
        AmendString.Add('VALUES ('''+sStarted+''')');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
      end
      else begin
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_CRITICALTYPE.

  else if (tblTypeID = TABLE_DESTINATION) and
    (Length(Edit2) > 0) then begin
    sStarted := Edit2;
    sTableName := 'tDestination';
    if lAppend then begin
      AmendString.Add('INSERT INTO '+ sTableName);
      AmendString.Add('(Description,Active)');
      AmendString.Add('VALUES ('''+ sStarted +''',1)');
      if lAudit then begin
        SetAuditStart(sUserName, AuditAction, sTableName,
          sAuditInsert, sAuditField, sAuditValue);
        SetAuditData('DESCRIPTION', '', sStarted, AuditString);
      end;  // lAudit.
    end
    else begin
      if (sStarted <> Original_Edit2Text) then begin
        AmendString.Add('UPDATE '+ sTableName);
        AmendString.Add('SET Description = '''+ sStarted +'''');
        AmendString.Add('WHERE id = '+ Edit1);
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
            AuditString);
        end;  // lAudit.
      end
      else begin
        lReturn := False;
        sError := 'No data changes were detected.';
      end;  // changed.
    end;
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;
  end   // TABLE_DESTINATION.

  else if (tblTypeID = TABLE_DEPARTMENT) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit3 := sStarted;
      sError := 'GroupID must be a number.';
    end
    else begin
      ProveForeignKey( 'tGroup', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
         Edit3 := sStarted;
         sError := 'GroupID does not exist.';
      end;
    end;
    if lReturn then begin
      sTableName := 'tDepartment';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description,GroupID';
        sValue := 'VALUES ('''+ Edit2 +''','+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (Length(sStarted) > 0) then begin
            SetAuditData('GROUPID', '', sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (Length(sStarted) > 0) then begin
            SetAuditData('DESCRIPTION', '', sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ Edit2 +''','+
          'GroupID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('GROUPID', Original_Edit3Text, sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND GroupID = '+ Edit3);
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // if TABLE_DEPARTMENT.

  else if (tblTypeID = TABLE_DUBIOUSRESOLUTION) then begin
    sStarted := Edit2;
    if (Length(sStarted) = 0) then begin
      lReturn := False;
      sError := 'A Description is Mandatory.';
    end
    else begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM tDubiousResolution');
      q.SQL.Add('WHERE Description LIKE '''+sStarted+'''');
      if not lAppend then
        q.SQL.Add('AND id <> '+Edit1);
      q.Open;
      lReturn := (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
      if not lReturn then begin
        sError := 'This Description already exists in the table. Data not saved.';
      end;
    end;  // empty.
    if lReturn then begin
      sTableName := 'tDubiousResolution';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(Description)');
        AmendString.Add('VALUES ('''+sStarted+''')');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted, AuditString);
        end;  // lAudit.
      end
      else begin
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_DUBIOUSRESOLUTION.

  else if (tblTypeID = TABLE_DUBIOUSTYPE) then begin
    sStarted := Edit2;
    q.SQL.Add('SELECT *');
    q.SQL.Add('FROM tDubiousType');
    q.SQL.Add('WHERE Description LIKE '''+sStarted+'''');
    if not lAppend then
      q.SQL.Add('AND id <> '+Edit1);
    q.Open;
    lReturn := (q.Bof and q.Eof);
    q.Close;
    q.SQL.Clear;
    if not lReturn then begin
      sError := 'This Description already exists in the table. Data not saved.';
    end;
    if lReturn then begin
      sTableName := 'tDubiousType';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(Description)');
        AmendString.Add('VALUES ('''+sStarted+''')');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
      end
      else begin
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;  // lAppend;
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_DUBIOUSTYPE.

  else if (tblTypeID = TABLE_DUBIOUSVALIDRESN) and
    (Length(Edit3) > 0) and
    (Length(Edit5) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit3 := sStarted;
      sError := 'DubiousTypeID must be a number.';
    end
    else begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM tDubiousType');
      q.SQL.Add('WHERE ID = '+sStarted);
      q.Open;
      lReturn := not (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
    end;
    if not lReturn then begin
      sError := 'DubiousTypeID is an invalid number.';
    end
    else begin
      sStarted := Edit5;
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit5 := sStarted;
        sError := 'DubiousResolutionID must be a number.';
      end
      else begin
        q.SQL.Add('SELECT *');
        q.SQL.Add('FROM tDubiousResolution');
        q.SQL.Add('WHERE ID = '+sStarted);
        q.Open;
        lReturn := not (q.Bof and q.Eof);
        q.Close;
        q.SQL.Clear;
      end;
      if not lReturn then begin
        sError := 'DubiousResolutionID is an invalid number.';
      end
      else begin
        // Make sure the combination does not already exist.
        q.SQL.Add('SELECT *');
        q.SQL.Add('FROM tDubiousValidResolution');
        q.SQL.Add('WHERE DubiousTypeID = '+Edit3);
        q.SQL.Add('AND DubiousResolutionID = '+sStarted);
        if not lAppend then
          q.SQL.Add('AND ID <> '+Edit1);
        q.Open;
        lReturn := (q.Bof and q.Eof);
        if not lReturn then begin
          if lAppend and (q['Active'] = 0) then begin
            sStarted := IntToStr(q['id']);
            q.Close;
            q.SQL.Clear;
            q.SQL.Add('UPDATE tDubiousValidResolution');
            q.SQL.Add('SET Active = 1');
            q.SQL.Add('WHERE ID = '+Edit1);
            q.ExecSQL;
          end
          else if not lAppend then begin
            sError := 'This combination already exists. Changes not saved.';
          end;
        end;
        q.Close;
        q.SQL.Clear;
      end;
    end;
    if lReturn then begin
      sTableName := 'tDubiousValidResolution';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(DubiousTypeID,DubiousResolutionID,Active)');
        AmendString.Add('VALUES ('+Edit3+','+sStarted+',1)');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (sStarted <> Original_Edit5Text) then begin
            SetAuditData('DUBIOUSRESOLUTIONID', '', sStarted, AuditString);
          end;  // changed.
          sStarted := Edit3;
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('DUBIOUSTYPEID', '', sStarted, AuditString);
          end;  // changed.
          if (Length(sStarted) > 0) then begin
            SetAuditData('ACTIVE', '', sStarted, AuditString);
          end;
        end;  // lAudit.
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        AmendString.Add('SET DubiousTypeID = '+Edit3+',');
        AmendString.Add(' DubiousResolutionID = '+sStarted);
        AmendString.Add('WHERE ID = '+Edit1);
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit5Text) then begin
            SetAuditData('DUBIOUSRESOLUTIONID', Original_Edit5Text, sStarted,
              AuditString);
          end;  // changed.
          sStarted := Edit3;
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('DUBIOUSTYPEID', Original_Edit3Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
      end;  // lAppend.
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE DubiousTypeID ='+ Edit3);
            SQL.Add('AND DubiousResolutionID = '+ Edit5);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_DUBIOUSVALIDRESN.

  else if (tblTypeID = TABLE_DISCOUNT) and
    (Length(Edit3) > 0) and
    (Length(Edit5) > 0) then begin
    sStarted := Edit5;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit5 := sStarted;
      sError := 'CustomerID error - must be a number.';
    end
    else begin
      ProveForeignKey( 'tCustomer', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit5 := sStarted;
        sError := 'CustomerID does not exist.';
      end;
    end;
    if lReturn then begin
      sStarted := Edit3;
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit3 := sStarted;
        sError := 'ServiceTypeID error - must be a number.';
      end
      else begin
        ProveForeignKey( 'tServiceType', StrToInt(sStarted), lReturn);
        if not lReturn then begin             // Field value truncated - Not Okay!
           sError := 'ServiceTypeID does not exist.';
        end;
      end;
      if lReturn then begin
        sStarted := Edit2;
        if (Length(sStarted) > 0) then begin
          ProveReal(sStarted,lReturn);
        end;
        if not lReturn then begin           // Field value truncated - Not Okay!
          Edit2 := sStarted;
          sError := 'Rate error - must be a number.';
        end
        else begin
          sStarted := Edit9;
          if (Length(sStarted) > 0) then begin
            ProveReal(sStarted,lReturn);
          end;
          if not lReturn then begin         // Field value truncated - Not Okay!
            Edit9 := sStarted;
            sError := 'NonStdRevAdminFee error - must be a number.';
          end
          else begin
            sStarted := Edit10;
            if (Length(sStarted) = 0) then begin
              sStarted := 'NULL';
            end
            else begin
              ProveReal(sStarted,lReturn);
              if not lReturn then begin       // Field value truncated - Not Okay!
                Edit10 := sStarted;
                sError := 'NonStdExpAdminFee error - must be a number.';
              end;
            end;
            if lAppend then begin
              q.SQL.Add('SELECT tDiscount.id');
              q.SQL.Add('FROM tDiscount');
              q.SQL.Add('WHERE tDiscount.ServiceTypeID = '+ Edit3);
              q.SQL.Add('AND tDiscount.CustomerID = ' +Edit5);
              q.Open;
              lReturn := q.Eof;
              q.Close;
              q.SQL.Clear;
              if not lReturn then begin     // Field values already entered!
                sError := 'This combination already exists. Changes not saved.';
              end;
            end;
          end;
        end;
      end;  // lReturn.
      if lReturn then begin
        sTableName := 'tDiscount';
        if lAppend then begin                                   // Append.
          AmendString.Add('INSERT INTO '+ sTableName);
          sField := '(ServiceTypeID, CustomerID, DiscountRate, Active';
          sValue := 'VALUES ('+ Edit3 +', '+ Edit5 +', '+ sStarted +', 1';
          sStarted := Edit9;
          if (Length(sStarted) > 0) then begin
            sField := sField + ', NonStdRevAdminFee';
            sValue := sValue + ', '+ sStarted;
          end;
          sStarted := Edit10;
          if (Length(sStarted) > 0) then begin
            sField := sField + ', NonStdExpAdminFee';
            sValue := sValue + ', '+ sStarted;
          end;
          sField := sField + ')';
          sValue := sValue + ')';
          AmendString.Add(sField);
          AmendString.Add(sValue);
          if lAudit then begin                     // Save everything.
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            sStarted := Edit3;
            SetAuditData('SERVICETYPEID', '', sStarted, AuditString);
            sStarted := Edit5;
            SetAuditData('CUSTOMERID', '', sStarted, AuditString);
            sStarted := Edit2;
            if (Length(sStarted) = 0) then sStarted := 'NULL';
            SetAuditData('DISCOUNTRATE', '', sStarted, AuditString);
            sStarted := Edit9;
            if (Length(sStarted) = 0) then sStarted := 'NULL';
            SetAuditData('NONSTDREVADMINFEE', '', sStarted, AuditString);
            sStarted := Edit10;
            if (Length(sStarted) = 0) then sStarted := 'NULL';
            SetAuditData('NONSTDEXPADMINFEE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;  // lAudit.
        end  // lAppend.
        else begin                                              // Update.
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET ServiceTypeID = '+ Edit3 +',');
          AmendString.Add(' CustomerID = '+ Edit5  + ',');
          sStarted := Edit2;
          if (Length(sStarted) = 0) then begin
            sStarted := 'NULL';
          end;
          AmendString.Add(' DiscountRate = '+ sStarted + ',');
          sStarted := Edit9;
          if (Length(sStarted) = 0) then begin
            sStarted := 'NULL';
          end;
          AmendString.Add(' NonStdRevAdminFee = '+ sStarted + ',');
          sStarted := Edit10;
          if (Length(sStarted) = 0) then begin
            sStarted := 'NULL';
          end;
          AmendString.Add(' NonStdExpAdminFee = '+ sStarted);
          AmendString.Add('WHERE ServiceTypeID = '+Original_Edit3Text);
          AmendString.Add('AND CustomerID = '+Original_Edit5Text);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            sStarted := Edit3;
            if (sStarted <> Original_Edit3Text) then begin
              SetAuditData('SERVICETYPEID', Original_Edit3Text, sStarted,
              AuditString);
            end;  // changed.
            sStarted := Edit5;
            if (sStarted <> Original_Edit5Text) then begin
              SetAuditData('CUSTOMERID', Original_Edit5Text, sStarted, AuditString);
            end;  // changed.
            sStarted := Edit2;
            if (sStarted <> Original_Edit2Text) then begin
              if (Length(sStarted) = 0) then sStarted := 'NULL';
              if (Length(Original_Edit2Text) = 0) then
                SetAuditData('DISCOUNTRATE', 'NULL', sStarted, AuditString)
              else
                SetAuditData('DISCOUNTRATE', Original_Edit2Text, sStarted, AuditString);
            end;
            sStarted := Edit9;
            if (sStarted <> Original_Edit9Text) then begin
              if (Length(sStarted) = 0) then sStarted := 'NULL';
              if (Length(Original_Edit9Text) = 0) then
                SetAuditData('NONSTDREVADMINFEE', 'NULL', sStarted, AuditString)
              else
                SetAuditData('NONSTDREVADMINFEE', Original_Edit2Text,
                  sStarted, AuditString);
            end;
            sStarted := Edit10;
            if (sStarted <> Original_Edit10Text) then begin
              if (Length(sStarted) = 0) then sStarted := 'NULL';
              if (Length(Original_Edit10Text) = 0) then
                SetAuditData('NONSTDEXPADMINFEE', 'NULL', sStarted, AuditString)
              else
                SetAuditData('NONSTDEXPADMINFEE', Original_Edit2Text,
                  sStarted, AuditString);
            end;
            if (AuditString.Count = 0) then begin
              lReturn := False;
              sError := 'No data changes were detected.';
            end;
          end;  // lAudit.
        end;  // lAppend.
        if lReturn then begin                                   // Save.
          q.SQL := AmendString;
          q.ExecSQL;
          if lAudit then begin
            if lAppend then begin
              // Get and store the new ID for this table.
              with q do begin
                SQL.Clear;
                SQL.Add('SELECT ID');
                SQL.ADD('FROM '+ sTableName);
                SQL.Add('WHERE ServiceTypeID = '+ Edit3);
                SQL.Add('AND CustomerID = '+ Edit5);
                SQL.Add('AND Active = 1');
                Open;
                SetAuditID(FieldByName('ID').AsString, sAuditValue);
                Close;
              end;  // q.
            end;  // lAppend.
            SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
          end;  // lAudit.
        end;  // lReturn.
      end;  // lReturn.
    end;  // lReturn.
  end   // if TABLE_DISCOUNT.

  else if ((tblTypeID = TABLE_DISCOUNTEDRATE) and
    (Length(Edit3) > 0) and
    (Length(Edit5) > 0)) then begin
    sStarted := Edit5;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit5 := sStarted;
      sError := 'CustomerID error - must be a number.';
    end
    else begin
      ProveForeignKey( 'tCustomer', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit5 := sStarted;
        sError := 'CustomerID does not exist.';
      end
    end;
    if lReturn then begin
      sStarted := Edit3;
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit3 := sStarted;
        sError := 'ServiceTypeID error - must be a number.';
      end
      else begin
        ProveForeignKey( 'tServiceType', StrToInt(sStarted), lReturn);
        if not lReturn then begin             // Field value truncated - Not Okay!
          sError := 'ServiceTypeID does not exist.';
        end;
      end;
      if lReturn then begin
        sStarted := Edit2;
        ProveReal(sStarted,lReturn);
        if not lReturn then begin           // Field value truncated - Not Okay!
          Edit2 := sStarted;
          sError := 'Rate error - must be a number.';
        end
        else if not lAppend then begin
          q.SQL.Add('SELECT tDiscountedRate.id');
          q.SQL.Add('FROM tDiscountedRate');
          q.SQL.Add('WHERE tDiscountedRate.ServiceTypeID = '+ Edit3);
          q.SQL.Add('AND tDiscountedRate.CustomerID = '+ Edit5);
          q.Open;
          lReturn := q.Eof;
          q.Close;
          q.SQL.Clear;
          if not lReturn then begin         // Field values Okay!
            sError := 'This combination already exists. Changes not saved.';
          end;
        end;
      end;  // lReturn.
      sTableName := 'tDiscountedRate';
      if lAppend then begin                                     // Append.
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(ServiceTypeID, CustomerID, Rate, Active)');
        AmendString.Add('VALUES ('+Edit3+''', '+Edit5 +', '+sStarted +', 1)');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          sStarted := Edit3;
          SetAuditData('SERVICETYPEID', '', sStarted, AuditString);
          sStarted := Edit5;
          SetAuditData('CUSTOMERID', '', sStarted, AuditString);
          sStarted := Edit2;
          SetAuditData('RATE', '', sStarted, AuditString);
          SetAuditData('ACTIVE', '', '1', AuditString);
        end;  // lAudit.
      end
      else begin                                                // Update.
        AmendString.Add('UPDATE '+ sTableName);
        AmendString.Add('SET ServiceTypeID = '+ Edit3);
        AmendString.Add('SET CustomerID = '+ Edit5);
        AmendString.Add('SET Rate = '+ Edit2);
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
        end;  // lAudit.
        sStarted := Edit3;
        if (sStarted <> Original_Edit3Text) then begin
          SetAuditData('SERVICETYPEID', Original_Edit3Text, sStarted,
            AuditString);
        end;  // changed.
        sStarted := Edit5;
        if (sStarted <> Original_Edit5Text) then begin
          SetAuditData('CUSTOMERID', Original_Edit5Text, sStarted, AuditString);
        end;  // changed.
        if (AuditString.Count = 0) then begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;
      end;
      if lReturn then begin                                     // Save.
        q.SQL := AmendString;
        q.ExecSQL;
        if lAudit then begin
          if lAppend then begin
            // Get and store the new ID for this table.
            with q do begin
              SQL.Clear;
              SQL.Add('SELECT ID');
              SQL.ADD('FROM '+ sTableName);
              SQL.Add('WHERE ServiceTypeID = '+ Edit3);
              SQL.Add('AND CustomerID = '+ Edit5);
              SQL.Add('AND Active = 1');
              Open;
              SetAuditID(FieldByName('ID').AsString, sAuditValue);
              Close;
            end;  // q.
          end;  // lAppend.
          SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        end;  // lAudit.
      end;  // lReturn.
    end;
  end   // if TABLE_DISCOUNTEDRATE.

  else if (tblTypeID = TABLE_ELEMENT) and
    (Length(Edit3) > 0) and
    (Length(Edit5) > 0) then begin
    sStarted := Edit5;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit5 := sStarted;
      sError := 'CustomerID must be a number.';
    end
    else begin
      ProveForeignKey( 'tCustomer', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit5 := sStarted;
        sError := 'CustomerID does not exist.';
      end;
    end;
    if lReturn then begin
      sTableName := 'tElement';
      if lAppend then begin
        sStarted := UpperCase(Edit3);
        q.SQL.Add('SELECT id');
        q.SQL.Add('FROM '+ sTableName);
        q.SQL.Add('WHERE ElementCode LIKE '''+sStarted+'''');
        q.SQL.Add('AND CustomerID = '+Edit5);
        q.Open;
        lReturn := q.Eof;
        q.Close;
        q.SQL.Clear;
        if lReturn then begin                     // Field value Okay!
          AmendString.Add('INSERT INTO '+ sTableName);
          sField := '(ElementCode, CustomerID, PlatinumUpdate, '+
            'LostRevenueFlag';
          sValue := 'VALUES ('''+sStarted+''', '+Edit5;
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditData('ELEMENTCODE', '', sStarted, AuditString);
            SetAuditData('CUSTOMERID', '', Edit5, AuditString);
          end;  // lAudit.
          if (CheckBox1.State = cbUnchecked) then begin
            sValue := sValue +', 0';
            if lAudit then begin
              SetAuditData('PLATINUMUPDATE', '', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +', 1';
            if lAudit then begin
              SetAuditData('PLATINUMUPDATE', '', '1', AuditString);
            end;
          end;
          if (CheckBox2.State = cbUnchecked) then begin
            sValue := sValue +', 0';
            if lAudit then begin
              SetAuditData('LOSTREVENUEFLAG', '', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +', 1';
            if lAudit then begin
              SetAuditData('LOSTREVENUEFLAG', '', '1', AuditString);
            end;
          end;
          if (Length(Edit4) > 0) then begin
            sField := sField + ', Description';
            sValue := sValue + ', ''' + Edit4+'''';
            if lAudit then begin
              SetAuditData('DESCRIPTION', '', sStarted, AuditString);
            end;
          end;
          if (Length(Edit2) > 0) then begin
            sStarted := Edit2;
            ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
            lReturn := (not lReturn);             // Correct the logic.
            if not lReturn then begin             // Field value truncated - Not Okay!
              Edit2 := sStarted;
            end
            else begin
              sField := sField + ', ServiceGroupID';
              sValue := sValue + ', '+ Edit2;
            end;  // lReturn.
            if lAudit then begin
              SetAuditData('SERVICEGROUPID', Original_Edit2Text, sStarted,
                AuditString);
            end;
          end;
          sStarted := Trim(edtEdit7.Text);
          if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
            sStarted := StandardDateString(Edit7);
            sField := sField + ',StartDate';
            sValue := sValue + ','''+ sStarted +'''';
            if lAudit then begin
              SetAuditData('STARTDATE', '', sStarted, AuditString);
            end;
          end;
          sStarted := Trim(edtEdit8.Text);
          if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
            sStarted := StandardDateString(Edit8);
            sField := sField + ',EndDate,Active';
            sValue := sValue + ',''' + sStarted +''',0';
            if lAudit then begin
              SetAuditData('ENDDATE', '', sStarted, AuditString);
              SetAuditData('ACTIVE', '', '0', AuditString);
            end;
          end
          else begin
            sField := sField + ',Active';
            sValue := sValue + ',1';
            if lAudit then begin
              SetAuditData('ACTIVE', '', '1', AuditString);
            end;
          end;
          if (Length(Edit9) > 0) then begin
            sStarted := Edit9;
            ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
            lReturn := (not lReturn);             // Correct the logic.
            if not lReturn then begin             // Field value truncated - Not Okay!
              Edit9 := sStarted;
            end
            else begin
              sField := sField + ', ReportGroupID';
              sValue := sValue + ', '+ sStarted;
              if lAudit then begin
                SetAuditData('REPORTGROUPID', Original_Edit9Text, sStarted,
                  AuditString);
              end;
            end;  // lReturn.
          end;
          sField := sField + ')';
          sValue := sValue + ')';
          AmendString.Add(sField);
          AmendString.Add(sValue);
        end
        else begin
          sError := 'The ElementCode MUST be a unique value.';
          lReturn := False;
        end;
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);         // Cannot alter ElementCode.
//        sValue := 'SET ElementCode = '''+ Trim(edtEdit3.Text) +''','+
//          'CustomerID = '+sStarted+',Active = 1, PlatinumUpdate = ';
        sValue := 'SET CustomerID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit5Text) then begin
            SetAuditData('CUSTOMERID', Original_Edit5Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        if (CheckBox1.Checked <> Original_Check1) then begin
          sValue := sValue +', PlatinumUpdate = ';
          if (CheckBox1.State = cbUnchecked) then begin
            sValue := sValue +'0';
            if lAudit then begin
              SetAuditData('PLATINUMUPDATE', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1';
            if lAudit then begin
              SetAuditData('PLATINUMUPDATE', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
        end;  // not Original_Check1.
        if (CheckBox2.Checked<>Original_Check2) then begin
          sValue := sValue +', LostRevenueFlag = ';
          if (CheckBox2.State = cbUnchecked) then begin
            sValue := sValue +'0';
            if lAudit then begin
              SetAuditData('LOSTREVENUEFLAG', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1';
            if lAudit then begin
              SetAuditData('LOSTREVENUEFLAG', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
        end;  // not Original_Check1.
        sStarted := Edit4;
        if (sStarted<>Original_Edit4Text) then begin
          if (Length(sStarted) = 0) then begin
            sValue := sValue +', Description = NULL';
          end
          else begin
            sValue := sValue + ',';
            AmendString.Add(sValue);
            sValue := ' Description = '''+ sStarted +'''';
          end;  // empty.
          if lAudit then begin
            SetAuditData('DESCRIPTION', Original_Edit4Text, sStarted,
              AuditString);
          end;
        end;  // edtEdit4.
        sStarted := Edit2;
        ProveWholeInteger(sStarted,lReturn);  // lReturn True if contents altered.
        lReturn := (not lReturn);             // Correct the logic.
        if not lReturn then begin             // Field value truncated - Not Okay!
          Edit2 := sStarted;
        end
        else if (sStarted <> Original_Edit2Text) then begin
          if (Length(sStarted) = 0) then begin
            sValue := sValue +', ServiceGroupID = NULL';
          end
          else begin
            sValue := sValue +', ServiceGroupID = '+Trim(sStarted);
          end;  // empty.
          if lAudit then begin
            SetAuditData('SERVICEGROUPID', Original_Edit2Text, sStarted,
              AuditString);
          end;
        end;  // not lReturn.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit9;
        if (Length(sStarted) = 0) then begin
          lReturn := True;
        end
        else begin
          ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
          lReturn := (not lReturn);             // Correct the logic.
        end;
        if not lReturn then begin             // Field value truncated - Not Okay!
          Edit9 := sStarted;
        end
        else if (sStarted <> Original_Edit9Text) then begin
          if (Length(sStarted) = 0) then begin
            sValue := sValue +', ReportGroupID = NULL';
          end
          else begin
            sValue := sValue +' ReportGroupID = '+Trim(sStarted);
          end;  // empty.
          if lAudit then begin
            SetAuditData('REPORTGROUPID', Original_Edit9Text, sStarted,
              AuditString);
          end;
        end;  // not lReturn.
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      if lReturn then begin
        q.SQL := AmendString;
        q.ExecSQL;
        if lAudit then begin
          if lAppend then begin
            // Get and store the new ID for this table.
            with q do begin
              SQL.Clear;
              SQL.Add('SELECT ID');
              SQL.ADD('FROM '+ sTableName);
              SQL.Add('WHERE ElementCode LIKE '''+ Edit3 +'''');
              SQL.Add('AND CustomerID = '+ Edit5);
              SQL.Add('AND Active = 1');
              Open;
              SetAuditID(FieldByName('ID').AsString, sAuditValue);
              Close;
            end;  // q.
          end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      end;  // lReturn.
    end;  // lReturn.
  end   // if TABLE_ELEMENT.

  else if (tblTypeID = TABLE_FUNCTION) and
    (Length(Edit1) > 0) and
    (Length(Edit2) > 0) then begin
    sStarted := Edit1;
    ProveWholeInteger(sStarted,lReturn);  // lReturn True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit1 := sStarted;
      sError := 'ID must be a number.';
    end
    else if lAppend then begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM tFunction');
      q.SQL.Add('WHERE ID = '+Edit1);
      q.Open;
      lReturn := not (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
      if not lReturn then begin
        sError := 'ID must be a unique number.';
      end;
    end;
    if lReturn then begin
      sTableName := 'tFunction';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(ID, Description)');
        AmendString.Add('VALUES ('+sStarted+
          ','''+ Edit2 +''')');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
      end
      else begin
        sStarted := Edit2;
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_FUNCTION.

  else if (tblTypeID = TABLE_GROUP) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit3 := sStarted;
      sError := 'CustomerID must be a number.';
    end
    else begin
      ProveForeignKey( 'tCustomer', StrToInt(sStarted), lReturn);
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit3 := sStarted;
        sError := 'CustomerID does not exist.';
      end;
    end;
    if lReturn then begin
      sTableName := 'tGroup';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description,CustomerID';
        sValue := 'VALUES ('''+ Edit2 +''','+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (Length(sStarted) > 0) then begin
            SetAuditData('CUSTOMERID', '', sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (Length(sStarted) > 0) then begin
            SetAuditData('DESCRIPTION', '', sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ Edit2 +''','+
          'CustomerID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('CUSTOMERID', Original_Edit3Text, sStarted, AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND CustomerID = '+ Edit3);
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // if TABLE_GROUP.

  else if (tblTypeID = TABLE_LOCATION) and
    (Length(Edit2) > 0) then begin
    lReturn := True;
    if lAppend then begin
      sStarted := Edit2;
      q.SQL.Add('SELECT tLocation.id');
      q.SQL.Add('FROM tLocation');
      q.SQL.Add('WHERE tLocation.Description LIKE '''+sStarted+'''');
      q.Open;
      lReturn := q.Eof;
      q.Close;
      q.SQL.Clear;
    end;
    if lReturn then begin
      sTableName := 'tLocation';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description';
        sValue := 'VALUES ('''+ Edit2 +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        sStarted := Edit2;
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ sStarted +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end
    else begin
      sError := 'The "Description" field must be unique - try again.';
    end;  // if lReturn then begin.
  end   // TABLE_LOCATION

  else if (tblTypeID = TABLE_MNEMONIC) and
    (Length(Edit2) > 0) then begin
    sStarted := Copy(Edit2,1,2);
    sTableName := 'tServiceMnemonic';
    lReturn := True;
    if lAppend then begin
      q.SQL.Add('SELECT id');
      q.SQL.Add('FROM '+ sTableName);
      q.SQL.Add('WHERE ServiceCode LIKE '''+sStarted+'''');
      q.Open;
      lReturn := q.Eof;
      q.Close;
      q.SQL.Clear;
    end;
    if lReturn then begin
      if lAppend then begin
        //*************** APPEND *********************************************
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(ServiceCode,Active');
        AmendString.Add('VALUES ('''+ sStarted +''',1');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('SERVICECODE', '', sStarted, AuditString);
          SetAuditData('ACTIVE', '', '1', AuditString);
        end;  // lAudit.
        sStarted := Edit3;
        if (Length(sStarted) > 0) then begin
          AmendString.Strings[1] := AmendString.Strings[1] +', Description';
          AmendString.Strings[2] := AmendString.Strings[2] +','''+sStarted+'''';
          if lAudit then begin
            SetAuditData('DESCRIPTION', '', sStarted, AuditString);
          end;  // lAudit.
        end;
        sStarted := Copy(Edit4,1,5);
        if (Length(sStarted) > 0) then begin
          AmendString.Strings[1] := AmendString.Strings[1] +', Prefix';
          AmendString.Strings[2] := AmendString.Strings[2] +','''+sStarted+'''';
          if lAudit then begin
            SetAuditData('PREFIX', '', sStarted, AuditString);
          end;  // lAudit.
        end;
        sStarted := Copy(Edit5,1,5);
        if (Length(sStarted) > 0) then begin
          AmendString.Strings[1] := AmendString.Strings[1] +', Pass)';
          AmendString.Strings[2] := AmendString.Strings[2] +','''+sStarted+''')';
          if lAudit then begin
            SetAuditData('PASS', '', sStarted, AuditString);
          end;  // lAudit.
        end
        else begin
          // Terminate the SQL statement.
          AmendString.Strings[1] := AmendString.Strings[1] +')';
          AmendString.Strings[2] := AmendString.Strings[2] +')';
        end;
      end
      else begin
        //*************** UPDATE *********************************************
        lReturn := False;
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET ServiceCode = '''+ sStarted +'''';
        if (sStarted <> Original_Edit2Text) then begin
          lReturn := True;
          if lAudit then begin
            SetAuditData('SERVICECODE', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end;  // Edit2.
        sStarted := Edit3;
        if (sStarted <> Original_Edit3Text) then begin
          if not lReturn then begin
            sValue := 'SET Description = '''+ sStarted +'''';
          end
          else begin
            sValue := sValue + ', Description = '''+ sStarted +'''';
          end;
          if lAudit then begin
            SetAuditData('DESCRIPTION', Original_Edit3Text, sStarted,
              AuditString);
          end;  // lAudit.
          lReturn := True;
        end;  // Edit3.
        sStarted := Copy(Edit4,1,5);
        if (sStarted <> Original_Edit4Text) then begin
          if not lReturn then begin
            sValue := 'SET Prefix = '''+ sStarted +'''';
          end
          else begin
            sValue := sValue + ', Prefix = '''+ sStarted +'''';
          end;
          if lAudit then begin
            SetAuditData('PREFIX', Original_Edit4Text, sStarted,
              AuditString);
          end;  // lAudit.
          lReturn := True;
        end;  // Edit4.
        sStarted := Copy(Edit5,1,5);
        if (sStarted <> Original_Edit5Text) then begin
          if not lReturn then begin
            sValue := 'SET Pass = '''+ sStarted +'''';
          end
          else begin
            sValue := sValue + ', Pass = '''+ sStarted +'''';
          end;
          if lAudit then begin
            SetAuditData('PASS', Original_Edit5Text, sStarted,
              AuditString);
          end;  // lAudit.
          lReturn := True;
//        end
//        else begin
        end;  // Edit5.
        if lReturn then begin
          AmendString.Add(sValue);
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;  // lAppend.
    end;  // lReturn.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE ServiceCode LIKE '''+ Edit2 +'''');
            sStarted := Edit5;
            if (Length(sStarted) > 0) then
              SQL.Add('AND Prefix LIKE '''+ sStarted +'''')
            else
              SQL.Add('AND Prefix IS NULL OR Prefix LIKE ''''');
//            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_MNEMONIC.

  else if (tblTypeID = TABLE_ORIGIN) and
    (Length(Edit2) > 0) then begin
    sStarted := Edit2;
    sTableName := 'tOrigin';
    if lAppend then begin
      AmendString.Add('INSERT INTO '+ sTableName);
      AmendString.Add('(Description,Active)');
      AmendString.Add('VALUES ('''+ sStarted +''',1)');
      if lAudit then begin
        SetAuditStart(sUserName, AuditAction, sTableName,
          sAuditInsert, sAuditField, sAuditValue);
        SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        SetAuditData('ACTIVE', '', '1', AuditString);
      end;  // lAudit.
    end
    else begin
      if (sStarted <> Original_Edit2Text) then begin
        AmendString.Add('UPDATE '+ sTableName);
        AmendString.Add('SET Description = '''+ sStarted +'''');
        AmendString.Add('WHERE id = '+ Edit1);
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
            AuditString);
        end;  // lAudit.
      end
      else begin
        lReturn := False;
        sError := 'No data changes were detected.';
      end;  // changed.
    end;
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_ORIGIN.

  else if (tblTypeID = TABLE_PERSON) and
    (Length(Edit2) > 0) then begin
    sTableName := 'tPerson';
    lReturn := True;
    sStarted := Edit2;
    if lAppend then begin
      with q do begin
        SQL.Add('SELECT id');
        SQL.Add('FROM '+ sTableName);
        SQL.Add('WHERE Person LIKE '''+sStarted+'''');
        SQL.Add('AND Active = 1');
        Open;
        lReturn := q.Eof;
        Close;
        SQL.Clear;
      end;  // q.
    end;
    if lReturn then begin
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Person';
        sValue := 'VALUES ('''+ sStarted +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('PERSON', '', sStarted, AuditString);
        end;  // lAudit.
        sStarted := Edit3;
        if (Length(sStarted) > 0) then begin
          sField := sField + ',EmailAddress';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('EMAILADDRESS', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end  // lAppend.
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Person = '''+ sStarted +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('PERSON', Original_Edit2Text, sStarted, AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Edit3;
        if (Length(sStarted) = 0) and (Length(Original_Edit3Text) > 0) then begin
          sValue := sValue + ', EmailAddress = NULL';
          if lAudit then begin
            SetAuditData('EMAILADDRESS', Original_Edit3Text, 'NULL', AuditString);
          end;
        end
        else begin
          if (sStarted <> Original_Edit3Text) then begin
            sValue := sValue +', EmailAddress = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('EMAILADDRESS', Original_Edit3Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Person LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end
    else begin
      sError := 'The "Person" field must be unique - try again.';
    end;  // if lReturn then begin.
  end   // TABLE_PERSON.

  else if (tblTypeID = TABLE_PROGRAM) and
    (Length(Edit1) > 0) and
    (Length(Edit2) > 0) then begin
    sTableName := 'tProgram';
    if lAppend then begin
      sStarted := Edit1;
      ProveWholeInteger(sStarted, lReturn);
      if lReturn then begin             // Field value exists - Not Okay!
        sError := 'ProgramID must be an integer.';
        lReturn := False;
      end
      else begin
        ProveForeignKey( sTableName, StrToInt(sStarted), lReturn);
        if lReturn then begin             // Field value exists - Not Okay!
          sError := 'ProgramID already exists. It must be unique.';
          lReturn := False;
        end
        else begin
          lReturn := True;
          AmendString.Add('INSERT INTO '+ sTableName);
          AmendString.Add('(ID,Description)');
          AmendString.Add('VALUES ('+sStarted+','''+ Edit2 +''')');
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditData('ID', '', sStarted, AuditString);
            SetAuditData('DESCRIPTION', '', Edit2, AuditString);
          end;  // lAudit.
        end;  // ProgramID unique.
      end;  // ProgramID=integer.
    end
    else begin
      sStarted := Edit2;
      if (sStarted <> Original_Edit2Text) then begin
        lReturn := True;
        AmendString.Add('UPDATE '+ sTableName);
        AmendString.Add('SET Description = '''+ sStarted +'''');
        AmendString.Add('WHERE id = '+ Edit1);
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
            AuditString);
        end;  // lAudit.
      end
      else begin
        lReturn := False;
        sError := 'No data changes were detected.';
      end;  // changed.
    end;
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // TABLE_PROGRAM.

  else if (tblTypeID = TABLE_RATE ) and
    (Length(Edit2) > 0) and
    (Length(Edit5) > 0) and
    (Length(Edit6) > 0) then begin
    sStarted := Edit2;
    ProveWholeInteger(sStarted,lReturn);  // lReturn True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit2 := sStarted;
      sError := 'ServiceTypeID must be a number.';
    end
    else begin
      ProveForeignKey( 'tServiceType', StrToInt(sStarted), lReturn);
      if not lReturn then begin           // Field value truncated - Not Okay!
        Edit2 := sStarted;
        sError := 'ServiceTypeID does not exist.';
      end;
    end;
    if lReturn then begin        
      sStarted := Edit5;
      ProveReal(sStarted,lReturn);        // lReturn True if contents Real.
      if not lReturn then begin           // Field value truncated - Not Okay!
        Edit5 := sStarted;
        sError := 'Cost must be a real number.';
      end
      else begin
        sStarted := Edit6;
        ProveReal(sStarted,lReturn);      // lReturn True if contents Real.
        if not lReturn then begin         // Field value truncated - Not Okay!
          Edit6 := sStarted;
          sError := 'Cost100 must be a real number.';
        end
        else begin
          sTableName := 'tRate';
          if lAppend then begin           // New entry.
            AmendString.Add('INSERT INTO '+ sTableName);
            sField := '(ServiceTypeID,Cost,Cost100';
            sValue := 'VALUES ('+Edit2+','+Edit5+','+sStarted;
            if lAudit then begin
              SetAuditStart(sUserName, AuditAction, sTableName,
                sAuditInsert, sAuditField, sAuditValue);
              SetAuditData('COST100', '', sStarted, AuditString);
              SetAuditData('SERVICETYPEID', '', Edit2, AuditString);
              SetAuditData('COST', '', Edit5, AuditString);
            end;  // lAudit.
            sStarted := Edit3;
            if (Length(sStarted) = 0) then sStarted := '0'
            else                           ProveReal(sStarted, lReturn);
            if lReturn then begin
              sField := sField + ',Length';
              sStarted := FloatToStrF(
                Round(StrToFloat(sStarted) * 1000.0) / 1000.0, ffFixed,12,3 );
              sValue := sValue + ',' + sStarted;
              if (Length(sStarted) > 0) then begin
                SetAuditData('LENGTH', '', sStarted, AuditString);
              end;  // changed.
            end;
            sStarted := Edit4;
            lReturn := (Length(sStarted) > 0);
            if lReturn then ProveReal(sStarted, lReturn);
            if lReturn then begin
              sField := sField + ',Percentage';
              sValue := sValue + ',' + sStarted;
              if lAudit and (Length(sStarted) > 0) then begin
                SetAuditData('PERCENTAGE', '', sStarted, AuditString);
              end;  // changed.
            end;
            sStarted := Trim(edtEdit7.Text);
            if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
              sStarted := StandardDateString(Edit7);
              sField := sField + ',StartDate';
              sValue := sValue + ','''+ sStarted +'''';
              if lAudit then begin
                SetAuditData('STARTDATE', '', sStarted, AuditString);
              end;
            end;
            sStarted := Trim(edtEdit8.Text);
            if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
              sStarted := StandardDateString(Edit8);
              sField := sField + ',EndDate,Active';
              sValue := sValue + ',''' + sStarted +''',0';
              if lAudit then begin
                SetAuditData('ENDDATE', '', sStarted, AuditString);
                SetAuditData('ACTIVE', '', '0', AuditString);
              end;
            end
            else begin
              sField := sField + ',Active';
              sValue := sValue + ',1';
              if lAudit then begin
                SetAuditData('ACTIVE', '', '1', AuditString);
              end;
            end;
            sStarted := CleanString(Edit9);
            if (Length(sStarted) > 0) then begin
              sField := sField + ',Description';
              sValue := sValue + ',  ''' + sStarted +'''';
              if lAudit then begin
                SetAuditData('DESCRIPTION', '', sStarted, AuditString);
              end;
            end;  // changed.
            sStarted := Edit10;
            if (Length(sStarted) > 0) then begin
              ProveReal(sStarted,lReturn);        // lReturn False if contents altered.
              if not lReturn then begin           // Field value truncated - Not Okay!
                Edit10 := sStarted;
                sError := 'PartCost must be a real number.';
              end
              else begin
                sField := sField + ',PartCost';
                sValue := sValue + ',  ' + sStarted;
                if lAudit then begin
                  SetAuditData('PARTCOST', '', sStarted, AuditString);
                end;
              end;
            end;
            if (Length(sUserName) > 0) then begin
              sField := sField + ',LastUpdatedBy';
              sValue := sValue +', '''+sUserName+'''';
            end;
            sField := sField + ')';
            sValue := sValue + ')';
            AmendString.Add(sField);
            AmendString.Add(sValue);
          end
          else begin                      // Change the existing entry.
            AmendString.Add('UPDATE '+ sTableName);
            sValue := 'SET ServiceTypeID = '+Edit2+', Cost = ';
            if (Length(Edit5) = 0) then
              sValue := sValue +'NULL, Cost100 = '
            else
              sValue := sValue +Edit5+', Cost100 = ';
            if (Length(sStarted) = 0) then
              sValue := sValue +'NULL'
            else
              sValue := sValue +sStarted;
            if lAudit then begin
              SetAuditStart(sUserName, AuditAction, sTableName,
                sAuditInsert, sAuditField, sAuditValue);
              SetAuditID(Edit1, sAuditValue);
              if (sStarted <> Original_Edit6Text) then begin
                SetAuditData('COST100', Original_Edit6Text, sStarted,
                  AuditString);
              end;  // changed.
              sStarted := Edit2;
              if (sStarted <> Original_Edit2Text) then begin
                SetAuditData('SERVICETYPEID', Original_Edit2Text, sStarted,
                  AuditString);
              end;  // changed.
              sStarted := Edit5;
              if (sStarted <> Original_Edit5Text) then begin
                SetAuditData('COST', Original_Edit5Text, sStarted,
                  AuditString);
              end;  // changed.
            end;  // lAudit.
            sStarted := Edit3;
            if (Length(sStarted) = 0) then sStarted := '0'
            else                           ProveReal(sStarted, lReturn);
            if lReturn then begin
              sValue := sValue + ', Length = ' + sStarted;
            end
            else begin
              sValue := sValue + ', Length = NULL';
            end;
            if lAudit and (sStarted <> Original_Edit3Text) then begin
              SetAuditData('LENGTH', Original_Edit3Text, sStarted, AuditString);
            end;  // changed.
            sStarted := Edit4;
            lReturn := (Length(sStarted) > 0);
            if lReturn then ProveReal(sStarted, lReturn);
            if lReturn then begin                     // 3-decimal places only.
              sStarted := FloatToStrF(
                Round(StrToFloat(sStarted) * 1000.0) / 1000.0, ffFixed,12,3 );
              sValue := sValue + ', Percentage = ' + sStarted;
            end
            else begin
              sValue := sValue + ', Percentage = NULL';
            end;
            if lAudit and (sStarted <> Original_Edit4Text) then begin
              SetAuditData('PERCENTAGE', Original_Edit4Text, sStarted,
                AuditString);
            end;  // changed.
            sStarted := Trim(edtEdit7.Text);
            if (Length(sStarted) = 0) or
              (Copy(sStarted,1,1) = '/') then begin
              if (Length(Original_Edit7Text) = 8) then begin
                sValue := sValue +', StartDate = NULL';
                if lAudit then begin
                  SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
                end;
              end;
            end
            else begin
              sStarted := StandardDateString(Edit7);
              if (sStarted <> Original_Edit7Text) then begin
                sValue := sValue +', StartDate = '''+sStarted+'''';
                if lAudit then begin
                  SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                    AuditString);
                end;
              end;
            end;
            sStarted := Trim(edtEdit8.Text);
            if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
              if (Length(Original_Edit8Text) = 8) then begin
                sValue := sValue +', EndDate = NULL, Active = 1';
                if lAudit then begin
                  SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
                  SetAuditData('ACTIVE', '0', '1', AuditString);
                end;
              end;
            end
            else begin
              sStarted := StandardDateString(Edit8);
              if (sStarted <> Original_Edit8Text) then begin
                sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
                if lAudit then begin
                  SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
                  if (Length(Original_Edit8Text) <> 8) then begin
                    SetAuditData('ACTIVE', '1', '0', AuditString);
                  end;
                end;
              end;
            end;
            sStarted := CleanString(Edit9);
            if (Length(sStarted) > 0) then begin
              sValue := sValue + ', Description = ''' + sStarted +'''';
            end;
            if lAudit and (sStarted <> Original_Edit9Text) then begin
              SetAuditData('DESCRIPTION', Original_Edit9Text, sStarted,
                AuditString);
            end;  // Edit9.
            sStarted := Edit10;
            if (sStarted <> Original_Edit10Text) then begin
              if (Length(sStarted) > 0) then begin
                ProveReal(sStarted,lReturn);  // lReturn False if contents altered.
                if not lReturn then begin     // Field value truncated - Not Okay!
                  Edit10 := sStarted;
                  sError := 'PartCost must be a real number.';
                end
                else begin
                  sValue := sValue + ', PartCost = ' + sStarted;
                  if lAudit and (sStarted <> Original_Edit10Text) then begin
                    SetAuditData('PARTCOST', Original_Edit10Text, sStarted,
                      AuditString);
                  end;
                end;
              end
              else begin
                sValue := sValue + ', PartCost = NULL';
                if lAudit and (sStarted <> Original_Edit10Text) then begin
                  SetAuditData('PARTCOST', Original_Edit10Text, '',
                    AuditString);
                end;
              end;
            end;  // Edit10.
            if (Length(sUserName) > 0) then begin
              sValue := sValue +', LastUpdatedBy = '''+sUserName+'''';
            end;
            sStarted := Edit1;
            AmendString.Add(sValue);
            AmendString.Add('WHERE id = '+ sStarted);
          end;  // if lAppend then begin..else.
          q.SQL := AmendString;
          q.ExecSQL;
          if lAudit then begin
            if lAppend then begin
              // Get and store the new ID for this table.
              with q do begin
                SQL.Clear;
                SQL.Add('SELECT ID');
                SQL.ADD('FROM '+ sTableName);
                SQL.Add('WHERE ServiceTypeID = '+ Edit2);
                SQL.Add('AND Active = 1');
                Open;
                SetAuditID(FieldByName('ID').AsString, sAuditValue);
                Close;
              end;  // q.
            end;  // lAppend.
            SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
          end;  // lAudit.
        end;  // if (Length(sStarted) = 0) then begin..else.
      end;  // if not lReturn then begin.
    end;  // if (Length(sStarted) = 0) then..else.
  end  // TABLE_RATE.

  else if (tblTypeID = TABLE_RATEDESCRIPTION ) and
    (Length(Edit2) > 0) then begin
    sTableName := 'tRateDescription';
    sStarted := Edit2;
    lReturn := True;
    if lAppend then begin               // No duplicates!
      with q do begin
        SQL.Add('SELECT id');
        SQL.Add('FROM '+ sTableName);
        SQL.Add('WHERE Description LIKE '''+sStarted+'''');
        Open;
        lReturn := q.Eof;
        Close;
        SQL.Clear;
      end;  // q.
    end;
    if lReturn then begin
      if lAppend then begin           // New entry.
        AmendString.Add('INSERT INTO '+ sTableName);
        AmendString.Add('(Description, Active)');
        AmendString.Add('VALUES ('''+sStarted+''', 1)');
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
      end
      else begin                      // Change the existing entry.
        if (sStarted <> Original_Edit2Text) then begin
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET Description = '''+ sStarted +'''');
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // lAudit.
        end
        else begin
          lReturn := False;
          sError := 'No data changes were detected.';
        end;  // changed.
      end;  // if lAppend then begin..else.
    end
    else begin
      sError := 'The "Description" field must be unique - try again.';
    end;  // if lReturn then begin.
    if lReturn then begin
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // if lReturn then begin.
  end  // TABLE_RATEDESCRIPTION.

  else if (tblTypeID = TABLE_SUBLEDGER) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
    lReturn := (not lReturn);             // Correct the logic.
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit3 := sStarted;
      sError := 'CustomerID must be a number.';
    end
    else begin
      ProveForeignKey( 'tCustomer', StrToInt(sStarted), lReturn);
    end;
    if not lReturn then begin             // Field value truncated - Not Okay!
      Edit3 := sStarted;
      sError := 'CustomerID does not exist.';
    end
    else begin
      sTableName := 'tSubledger';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description,CustomerID';
        sValue := 'VALUES ('''+Edit2+''','+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('CUSTOMERID', Original_Edit3Text, sStarted,
              AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ Edit2 +''','+
          'CustomerID = '+sStarted;
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit3Text) then begin
            SetAuditData('CUSTOMERID', Original_Edit3Text, sStarted,
              AuditString);
          end;  // changed.
          sStarted := Edit2;
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            SQL.Add('AND CustomerID = '+ Edit3);
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // if TABLE_SUBLEDGER.

  else if (tblTypeID = TABLE_SYSTEM) and
    (Length(Edit2) > 0) and
    (Length(Edit3) > 0) then begin
    sStarted := Edit3;
    lReturn := (Length(sStarted) > 0);      // Added in case Edit3 test is removed.
    if lReturn then begin
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
      if not lReturn then begin             // Field value truncated - Not Okay!
        sError := 'BatchTypeID must be a number.';
        Edit3 := sStarted;
      end
      else begin
        ProveForeignKey( 'tBatchType', StrToInt(sStarted), lReturn);
        if not lReturn then begin             // Field value invalid - Not Okay!
          sError := 'BatchTypeID does not exist.';
          Edit3 := sStarted;
        end;
      end;
    end
    else begin
      sError := 'BatchTypeID must be a number.';
    end;
    if lReturn then begin
      q.SQL.Add('SELECT *');
      q.SQL.Add('FROM tSystem');
      q.SQL.Add('WHERE BatchTypeID = '+sStarted);
      if not lAppend then q.SQL.Add('AND id <> '+Edit1);
      q.Open;
      lReturn := (q.Bof and q.Eof);
      q.Close;
      q.SQL.Clear;
      if not lReturn then begin
        sError := 'This BatchTypeID already exists in the table. Data not saved.';
      end
      else begin
        sDate := ''''+StandardDateTimeString(Now)+'''';
        sTableName := 'tSystem';
        if lAppend then begin
          AmendString.Add('INSERT INTO '+ sTableName);
          AmendString.Add('(System,BatchTypeID,Active,DateEntered,'+
            'DateLastChanged,UserID)');
          AmendString.Add('VALUES ('''+ Edit2+''','+sStarted+',1,'+
            sDate+','+sDate+','+IntToStr(MainForm.OPERATORNUMBER)+')');
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditData('BATCHTYPEID', '', sStarted, AuditString);
            sStarted := Edit2;
            if (Length(sStarted) > 0) then begin
              SetAuditData('SYSTEM', '', sStarted, AuditString);
            end;  // changed.
          end;  // lAudit.
        end
        else begin
          if (Length(sStarted) = 0) then sStarted := 'NULL';
          AmendString.Add('UPDATE '+ sTableName);
          AmendString.Add('SET System = '''+ Edit2 +''','+
            'BatchTypeID = '+sStarted+', DateLastChanged = '+sDate+','+
            ' UserID = '+ IntToStr(MainForm.OPERATORNUMBER));
          AmendString.Add('WHERE id = '+ Edit1);
          if lAudit then begin
            SetAuditStart(sUserName, AuditAction, sTableName,
              sAuditInsert, sAuditField, sAuditValue);
            SetAuditID(Edit1, sAuditValue);
            if (sStarted <> Original_Edit3Text) then begin
              SetAuditData('BATCHTYPEID', Original_Edit3Text, sStarted,
                AuditString);
            end;  // changed.
            sStarted := Edit2;
            if (sStarted <> Original_Edit2Text) then begin
              SetAuditData('SYSTEM', Original_Edit2Text, sStarted,
                AuditString);
            end;  // changed.
          end;  // lAudit.
        end;  // lAppend.
        q.SQL := AmendString;
        q.ExecSQL;
        if lAudit then begin
          if lAppend then begin
            // Get and store the new ID for this table.
            with q do begin
              SQL.Clear;
              SQL.Add('SELECT ID');
              SQL.ADD('FROM '+ sTableName);
              SQL.Add('WHERE System LIKE '''+ Edit2 +'''');
              SQL.Add('AND BatchTypeID = '+ Edit3);
              SQL.Add('AND Active = 1');
              Open;
              SetAuditID(FieldByName('ID').AsString, sAuditValue);
              Close;
            end;  // q.
          end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      end;  // not lReturn.
    end;  // lReturn.
  end   // TABLE_SYSTEM.

  else if (tblTypeID = TABLE_TRANSACTIONGROUP) then begin
    sStarted := Edit2;
    if (Length(sStarted) = 0) then begin
      sError := 'Description field is Mandatory.';
    end
    else begin
      sTableName := 'tTransactionGroup';
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(Description';
        sValue := 'VALUES ('''+sStarted+'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('DESCRIPTION', '', sStarted, AuditString);
        end;  // lAudit.
        sStarted := Edit3;
        if (Length(sStarted) > 0) then begin
          sField := sField + ',CostRangeFrom';
          sValue := sValue + ',' + sStarted;
          if lAudit then begin
            SetAuditData('COSTRANGEFROM', '', sStarted, AuditString);
          end;
        end;
        sStarted := Edit4;
        if (Length(sStarted) > 0) then begin
          sField := sField + ',CostRangeTo';
          sValue := sValue + ',' + sStarted;
          if lAudit then begin
            SetAuditData('COSTRANGETO', '', sStarted, AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET Description = '''+ sStarted +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Edit3;
        if (Length(sStarted) = 0) then sValue := sValue + ', CostRangeFrom = NULL'
        else sValue := sValue + ', CostRangeFrom = ' + sStarted;
        if lAudit and (sStarted <> Original_Edit3Text) then begin
          SetAuditData('COSTRANGEFROM', Original_Edit3Text, sStarted,
            AuditString);
        end;
        sStarted := Edit4;
        if (Length(sStarted) = 0) then sValue := sValue + ', CostRangeTo = NULL'
        else sValue := sValue + ', CostRangeTo = ' + sStarted;
        if lAudit and (sStarted <> Original_Edit4Text) then begin
          SetAuditData('COSTRANGETO', Original_Edit4Text, sStarted,
            AuditString);
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;  // q.
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // if (Length(sStarted) = 0) then..else.
  end   // TABLE_TRANSACTIONGROUP.
  
  else if (tblTypeID = TABLE_TRANSACTIONTYPE) then begin
    lReturn := True;
    if (Length(Edit2) = 0) then begin
      sError := 'Description field is Mandatory.';
      lReturn := False;
    end;
    if lReturn and (Length(Edit3) = 0) then begin
      sError := 'TransactionGroupID field is Mandatory.';
      lReturn := False;
    end;
    if lReturn and (Length(Edit5) = 0) then begin
      sError := 'SystemID field is Mandatory.';
      lReturn := False;
    end;
    if lReturn then begin
      sStarted := Edit3;
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit3 := sStarted;
        sError := 'TransactionGroupID must be a number.';
      end
      else begin
        ProveForeignKey( 'tTransactionGroup', StrToInt(sStarted), lReturn);
      end;
      if not lReturn then begin             // Field value truncated - Not Okay!
        Edit3 := sStarted;
        sError := 'TransactionGroupID does not exist.';
      end
      else begin
        sStarted := Edit5;
        if (Length(sStarted) > 0) then begin
          ProveWholeInteger(sStarted,lReturn);// parameter True if contents altered.
          lReturn := (not lReturn);           // Correct the logic.
          if not lReturn then begin             // Field value truncated - Not Okay!
            Edit5 := sStarted;
            sError := 'SystemID must be a number.';
          end
          else begin
            ProveForeignKey( 'tSystem', StrToInt(sStarted), lReturn);
          end;
        end;
        if not lReturn then begin             // Field value truncated - Not Okay!
          Edit5 := sStarted;
          sError := 'SystemID does not exist.';
        end
        else begin
          sTableName := 'tTransactionType';
          if lAppend then begin
            AmendString.Add('INSERT INTO '+ sTableName);
            sField := '(Description';
            sValue := 'VALUES ('''+Edit2+'''';
            sField := sField + ',TransactionGroupID';
            sValue := sValue + ',' + Edit3;
            sField := sField + ',SystemID';
            sValue := sValue + ',' + sStarted;
            if lAudit then begin
              SetAuditStart(sUserName, AuditAction, sTableName,
                sAuditInsert, sAuditField, sAuditValue);
              SetAuditData('SYSTEMID', '', sStarted, AuditString);
              SetAuditData('DESCRIPTION', '', Edit2, AuditString);
              SetAuditData('TRANSACTIONGROUPID', '', Edit3, AuditString);
            end;  // lAudit.
            sStarted := Trim(edtEdit7.Text);
            if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
              sStarted := StandardDateString(Edit7);
              sField := sField + ',StartDate';
              sValue := sValue + ','''+ sStarted +'''';
              if lAudit then begin
                SetAuditData('STARTDATE', '', sStarted, AuditString);
              end;
            end;
            sStarted := Trim(edtEdit8.Text);
            if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
              sStarted := StandardDateString(Edit8);
              sField := sField + ',EndDate,Active';
              sValue := sValue + ',''' + sStarted +''',0';
              if lAudit then begin
                SetAuditData('ENDDATE', '', sStarted, AuditString);
                SetAuditData('ACTIVE', '', '0', AuditString);
              end;
            end
            else begin
              sField := sField + ',Active';
              sValue := sValue + ',1';
              if lAudit then begin
                SetAuditData('ACTIVE', '', '1', AuditString);
              end;
            end;
            if (Length(sUserName) > 0) then begin
              sField := sField + ',LastUpdatedBy';
              sValue := sValue +', '''+sUserName+'''';
            end;
            sField := sField + ')';
            sValue := sValue + ')';
            AmendString.Add(sField);
            AmendString.Add(sValue);
          end
          else begin
            AmendString.Add('UPDATE '+ sTableName);
            sValue := 'SET Description = '''+ Edit2 +
              ''', TransactionGroupID = ' + Edit3 + ', SystemID = ';
            if (Length(sStarted) = 0) then begin
              sValue := sValue + 'NULL';
            end
            else begin
              sValue := sValue + sStarted;
            end;
            if lAudit then begin
              SetAuditStart(sUserName, AuditAction, sTableName,
                sAuditInsert, sAuditField, sAuditValue);
              SetAuditID(Edit1, sAuditValue);
              if (sStarted <> Original_Edit5Text) then begin
                SetAuditData('SYSTEMID', Original_Edit5Text, sStarted,
                  AuditString);
              end;  // changed.
              sStarted := Edit2;
              if (sStarted <> Original_Edit2Text) then begin
                SetAuditData('DESCRIPTION', Original_Edit2Text, sStarted,
                  AuditString);
              end;  // changed.
              sStarted := Edit3;
              if (sStarted <> Original_Edit3Text) then begin
                SetAuditData('TRANSACTIONGROUPID', Original_Edit3Text, sStarted,
                AuditString);
              end;  // changed.
            end;  // lAudit.
            sStarted := Trim(edtEdit7.Text);
            if (Length(sStarted) = 0) or
              (Copy(sStarted,1,1) = '/') then begin
              if (Length(Original_Edit7Text) = 8) then begin
                sValue := sValue +', StartDate = NULL';
                if lAudit then begin
                  SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
                end;
              end;
            end
            else begin
              sStarted := StandardDateString(Edit7);
              if (sStarted <> Original_Edit7Text) then begin
                sValue := sValue +', StartDate = '''+sStarted+'''';
                if lAudit then begin
                  SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                    AuditString);
                end;
              end;
            end;
            sStarted := Trim(edtEdit8.Text);
            if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
              if (Length(Original_Edit8Text) = 8) then begin
                sValue := sValue +', EndDate = NULL, Active = 1';
                if lAudit then begin
                  SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
                  SetAuditData('ACTIVE', '0', '1', AuditString);
                end;
              end;
            end
            else begin
              sStarted := StandardDateString(Edit8);
              if (sStarted <> Original_Edit8Text) then begin
                sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
                if lAudit then begin
                  SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
                  if (Length(Original_Edit8Text) <> 8) then begin
                    SetAuditData('ACTIVE', '1', '0', AuditString);
                  end;
                end;
              end;
            end;
            if (Length(sUserName) > 0) then begin
              sValue := sValue +', LastUpdatedBy = '''+sUserName+'''';
            end;
            sStarted := Edit1;
            AmendString.Add(sValue);
            AmendString.Add('WHERE id = '+ sStarted);
          end;  // if lAppend then begin..else.
          q.SQL := AmendString;
          q.ExecSQL;
          if lAudit then begin
            if lAppend then begin
              // Get and store the new ID for this table.
              with q do begin
                SQL.Clear;
                SQL.Add('SELECT ID');
                SQL.ADD('FROM '+ sTableName);
                SQL.Add('WHERE Description LIKE '''+ Edit2 +'''');
                SQL.Add('AND TransactionGroupID = '+ Edit3);
                SQL.Add('AND SystemID = '+ Edit5);
                SQL.Add('AND Active = 1');
                Open;
                SetAuditID(FieldByName('ID').AsString, sAuditValue);
                Close;
              end;  // q.
            end;  // lAppend.
            SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
          end;  // lAudit.
        end;  // if not lReturn then begin.
      end;  // if not lReturn then begin.
    end;  // if (Length(sStarted) = 0) then..else.
  end   // TABLE_TRANSACTIONTYPE.
  
  else if (tblTypeID = TABLE_USER) then begin
    // UserFunction is used to edit this table.        //***********************
  end   // TABLE_USER.
  else if (tblTypeID = TABLE_VALIDACCOUNT) and
    (Length(Edit2) > 0) then begin
    sStarted := Edit3;
    if (Length(sStarted) = 0) then
      lReturn := True
    else begin
      ProveWholeInteger(sStarted,lReturn);  // parameter True if contents altered.
      lReturn := (not lReturn);             // Correct the logic.
    end;
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'BatchTypeID must be a number.';
      Edit3 := sStarted;
    end
    else begin
      ProveForeignKey( 'tBatchType', StrToInt(sStarted), lReturn);
    end;
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'BatchTypeID does not exist.';
      Edit3 := sStarted;
    end
    else begin
      sTableName := 'tValidAccountNumber';
      sStarted := Edit2;
      if lAppend then begin
        AmendString.Add('INSERT INTO '+ sTableName);
        sField := '(AccountNo';
        sValue := 'VALUES ('''+ sStarted +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('ACCOUNTNO', '', sStarted, AuditString);
        end;  // lAudit.
        sStarted := Edit3;
        if (Length(sStarted) > 0) then begin
          sField := sField + ',BatchTypeID';
          sValue := sValue + ','+sStarted;
          if lAudit then begin
            SetAuditData('BATCHTYPEID', '', sStarted, AuditString);
          end;
        end;
        sStarted := Edit5;
        if (Length(sStarted) > 0) then begin
          sField := sField + ',TenderNo';
          sValue := sValue + ','''+sStarted+'''';
          if lAudit then begin
            SetAuditData('TENDERNO', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit7);
          sField := sField + ',StartDate';
          sValue := sValue + ','''+ sStarted +'''';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) > 0) and (Copy(sStarted,1,1) <> '/') then begin
          sStarted := StandardDateString(Edit8);
          sField := sField + ',EndDate,Active';
          sValue := sValue + ',''' + sStarted +''',0';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + ',Active';
          sValue := sValue + ',1';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + ')';
        sValue := sValue + ')';
        AmendString.Add(sField);
        AmendString.Add(sValue);
      end
      else begin
        AmendString.Add('UPDATE '+ sTableName);
        sValue := 'SET AccountNo = '''+ sStarted +'''';
        if lAudit then begin
          SetAuditStart(sUserName, AuditAction, sTableName,
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Edit1, sAuditValue);
          if (sStarted <> Original_Edit2Text) then begin
            SetAuditData('ACCOUNTNO', Original_Edit2Text, sStarted,
              AuditString);
          end;  // changed.
        end;  // lAudit.
        sStarted := Edit3;
        if (sStarted <> Original_Edit3Text) then begin
          if (Length(sStarted) = 0) then begin
            sValue := sValue + ', BatchTypeID = NULL';
          end
          else begin
            sValue := sValue + ', BatchTypeID = '+sStarted;
          end;
          if lAudit then begin
            SetAuditData('BATCHTYPEID', Original_Edit3Text, sStarted,
              AuditString);
          end;
        end;  // changed.
        sStarted := Edit5;
        if (Length(sStarted) > 0) then begin
          sValue := sValue + ', TenderNo = '''+sStarted+'''';
          if lAudit and (sStarted <> Original_Edit5Text) then begin
            SetAuditData('TENDERNO', Original_Edit5Text, sStarted,
              AuditString);
          end;
        end;
        sStarted := Trim(edtEdit7.Text);
        if (Length(sStarted) = 0) or
          (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit7Text) = 8) then begin
            sValue := sValue +', StartDate = NULL';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, '', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit7);
          if (sStarted <> Original_Edit7Text) then begin
            sValue := sValue +', StartDate = '''+sStarted+'''';
            if lAudit then begin
              SetAuditData('STARTDATE', Original_Edit7Text, sStarted,
                AuditString);
            end;
          end;
        end;
        sStarted := Trim(edtEdit8.Text);
        if (Length(sStarted) = 0) or (Copy(sStarted,1,1) = '/') then begin
          if (Length(Original_Edit8Text) = 8) then begin
            sValue := sValue +', EndDate = NULL, Active = 1';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(Edit8);
          if (sStarted <> Original_Edit8Text) then begin
            sValue := sValue +', EndDate = '''+sStarted+''', Active = 0';
            if lAudit then begin
              SetAuditData('ENDDATE', Original_Edit8Text, sStarted, AuditString);
              if (Length(Original_Edit8Text) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        sStarted := Edit1;
        AmendString.Add(sValue);
        AmendString.Add('WHERE id = '+ sStarted);
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM '+ sTableName);
            SQL.Add('WHERE AccountNo LIKE '''+ Edit2 +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lReturn.
  end   // if TABLE_VALIDACCOUNT.
  else begin
    lReturn := False;
    sError := 'Incomplete data. You must complete all fields.';
  end;
  AmendString.Clear;
  q.Free;
  if lReturn then begin
    ModalResult := mrOk;
  end
  else begin
    Application.ProcessMessages;
    MessageDlg(sError, mtWarning, [mbOk], 0);
  end;  // lReturn.
end;  // btnOkClick().

end.
