unit SysEditBatchType;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Db, DBTables;

type
  TSysEditBatchTypeForm = class(TForm)
    ckAccountNo: TCheckBox;
    ckInvoiceNo: TCheckBox;
    ckTotalRevenue: TCheckBox;
    ckTotalPayable: TCheckBox;
    ckTotalCredits: TCheckBox;
    ckOpeningBalance: TCheckBox;
    ckPaymentsReceived: TCheckBox;
    ckTotalAdjustments: TCheckBox;
    ckBatchStart: TCheckBox;
    ckBatchEnd: TCheckBox;
    ckPaymentDate: TCheckBox;
    ckCreditsToCustomers: TCheckBox;
    ckGST: TCheckBox;
    ckGSTAdjustment: TCheckBox;
    ckOrderNumber: TCheckBox;
    ckRequisitionNumber: TCheckBox;
    ckIssueDate: TCheckBox;
    ckRentDates: TCheckBox;
    ckCallDates: TCheckBox;
    ckRounding: TCheckBox;
    edtInvoiceNo: TEdit;
    edtTotalRevenue: TEdit;
    edtTotalPayable: TEdit;
    edtTotalCredits: TEdit;
    edtOpeningBalance: TEdit;
    edtPaymentsReceived: TEdit;
    edtTotalAdjustments: TEdit;
    edtBatchStart: TEdit;
    edtBatchEnd: TEdit;
    edtPaymentDate: TEdit;
    edtCreditsToCustomers: TEdit;
    edtGST: TEdit;
    edtGSTAdjustment: TEdit;
    edtOrderNumber: TEdit;
    edtRequisitionNumber: TEdit;
    edtIssueDate: TEdit;
    edtRounding: TEdit;
    panelDubious: TPanel;
    panelCritical: TPanel;
    ckCritical01: TCheckBox;
    ckCritical02: TCheckBox;
    ckCritical03: TCheckBox;
    ckCritical04: TCheckBox;
    ckCritical05: TCheckBox;
    ckCritical06: TCheckBox;
    ckCritical07: TCheckBox;
    ckCritical08: TCheckBox;
    ckCritical09: TCheckBox;
    ckCritical10: TCheckBox;
    ckCritical11: TCheckBox;
    ckCritical12: TCheckBox;
    ckCritical13: TCheckBox;
    ckCritical14: TCheckBox;
    ckCritical15: TCheckBox;
    ckDubious01: TCheckBox;
    ckDubious02: TCheckBox;
    ckDubious03: TCheckBox;
    ckDubious04: TCheckBox;
    ckDubious05: TCheckBox;
    ckDubious06: TCheckBox;
    ckDubious07: TCheckBox;
    ckDubious08: TCheckBox;
    ckDubious09: TCheckBox;
    ckDubious10: TCheckBox;
    ckDubious11: TCheckBox;
    ckDubious12: TCheckBox;
    ckDubious13: TCheckBox;
    ckDubious14: TCheckBox;
    ckDubious15: TCheckBox;
    edtID: TEdit;
    edtDescription: TEdit;
    lblID: TLabel;
    lblDescription: TLabel;
    lblSupplierID: TLabel;
    lblDataSourceType: TLabel;
    qDataSourceType: TQuery;
    dsDataSourceType: TDataSource;
    cbDataSourceType: TDBLookupComboBox;
    qBatchType: TQuery;
    dsBatchType: TDataSource;
    cbSupplier: TDBLookupComboBox;
    qSupplier: TQuery;
    dsSupplier: TDataSource;
    edtAccountNo: TEdit;
    edtVar01: TEdit;
    edtVar02: TEdit;
    edtVar03: TEdit;
    edtVar04: TEdit;
    edtVar05: TEdit;
    edtVar06: TEdit;
    edtVar07: TEdit;
    edtVar09: TEdit;
    edtVar11: TEdit;
    edtVar08: TEdit;
    edtVar10: TEdit;
    edtVar12: TEdit;
    edtVar13: TEdit;
    edtVar14: TEdit;
    edtVar15: TEdit;
    lblVarDescription: TLabel;
    lblVar01: TLabel;
    lblVar02: TLabel;
    lblVar03: TLabel;
    lblVar04: TLabel;
    lblVar05: TLabel;
    lblVar06: TLabel;
    lblVar07: TLabel;
    lblVar08: TLabel;
    lblVar09: TLabel;
    lblVar10: TLabel;
    lblVar11: TLabel;
    lblVar12: TLabel;
    lblVar13: TLabel;
    lblVar14: TLabel;
    lblVar15: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    lblDubious: TLabel;
    lblCritical: TLabel;
    lblCheckColumn1: TLabel;
    lblDisplayNames1: TLabel;
    lblCheckColumn2: TLabel;
    lblDisplayNames2: TLabel;
    ckTenderNumber: TCheckBox;
    qSupplierid: TIntegerField;
    qSupplierSupplierName: TStringField;
    ckMultiManual: TCheckBox;
    ckPrelimRevenue: TCheckBox;
    lblProgramID: TLabel;
    qProgram: TQuery;
    dsProgram: TDataSource;
    cbProgram: TDBLookupComboBox;
    lblSupplierDisplayedName: TLabel;
    edtSupplierDisplayedName: TEdit;
    lblReportGroupID: TLabel;
    cbReportGroup: TDBLookupComboBox;
    qReportGroup: TQuery;
    dsReportGroup: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
    lAppend : boolean;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    sCritical : string;
    sDubious : string;
    sUserName : string;
    Original_Description            : string;
    Original_SupplierID             : string;
    Original_DataSourceTypeID       : string;
    Original_ProgramID              : string;
    Original_SupplierDisplayedName  : string;
    Original_ReportGroupID          : string;
    Original_AccountNo              : boolean;
    Original_AccountNoName          : string;
    Original_InvoiceNo              : boolean;
    Original_InvoiceNoName          : string;
    Original_TotalRevenue           : boolean;
    Original_TotalRevenueName       : string;
    Original_TotalPayable           : boolean;
    Original_TotalPayableName       : string;
    Original_TotalCredits           : boolean;
    Original_TotalCreditsName       : string;
    Original_OpeningBalance         : boolean;
    Original_OpeningBalanceName     : string;
    Original_PaymentsReceived       : boolean;
    Original_PaymentsReceivedName   : string;
    Original_TotalAdjustments       : boolean;
    Original_TotalAdjustmentsName   : string;
    Original_BatchStart             : boolean;
    Original_BatchStartName         : string;
    Original_BatchEnd               : boolean;
    Original_BatchEndName           : string;
    Original_PaymentDate            : boolean;
    Original_PaymentDateName        : string;
    Original_CreditsToCustomers     : boolean;
    Original_CreditsToCustomersName : string;
    Original_GST                    : boolean;
    Original_GSTName                : string;
    Original_GSTAdjustment          : boolean;
    Original_GSTAdjustmentName      : string;
    Original_OrderNumber            : boolean;
    Original_OrderNumberName        : string;
    Original_RequisitionNumber      : boolean;
    Original_RequisitionNumberName  : string;
    Original_IssueDate              : boolean;
    Original_IssueDateName          : string;
    Original_RentDates              : boolean;
    Original_CallDates              : boolean;
    Original_Rounding               : boolean;
    Original_RoundingName           : string;
    Original_TenderNumber           : boolean;
    Original_MultiManualEntry       : boolean;
    Original_EarlyRevenue           : boolean;
    Original_Var01 : string;
    Original_Var02 : string;
    Original_Var03 : string;
    Original_Var04 : string;
    Original_Var05 : string;
    Original_Var06 : string;
    Original_Var07 : string;
    Original_Var08 : string;
    Original_Var09 : string;
    Original_Var10 : string;
    Original_Var11 : string;
    Original_Var12 : string;
    Original_Var13 : string;
    Original_Var14 : string;
    Original_Var15 : string;
    Original_C1  : boolean;
    Original_C2  : boolean;
    Original_C3  : boolean;
    Original_C4  : boolean;
    Original_C5  : boolean;
    Original_C6  : boolean;
    Original_C7  : boolean;
    Original_C8  : boolean;
    Original_C9  : boolean;
    Original_C10 : boolean;
    Original_C11 : boolean;
    Original_C12 : boolean;
    Original_C13 : boolean;
    Original_C14 : boolean;
    Original_C15 : boolean;
    Original_D1  : boolean;
    Original_D2  : boolean;
    Original_D3  : boolean;
    Original_D4  : boolean;
    Original_D5  : boolean;
    Original_D6  : boolean;
    Original_D7  : boolean;
    Original_D8  : boolean;
    Original_D9  : boolean;
    Original_D10 : boolean;
    Original_D11 : boolean;
    Original_D12 : boolean;
    Original_D13 : boolean;
    Original_D14 : boolean;
    Original_D15 : boolean;
  protected
    procedure SetAppend(Value: boolean);
    procedure SetID(Value: string);
    procedure SetDescription(const Value: string);
    function GetDescription: string;
    procedure SetSupplierID(const Value: integer);
    function GetSupplierID: integer;
    procedure SetProgramID(const Value: integer);
    function GetProgramID: integer;
    procedure SetSupplierDisplayedName(const Value: string);
    function GetSupplierDisplayedName: string;
    procedure SetReportGroupID(const Value: integer);
    function GetReportGroupID: integer;
    procedure SetDataSourceTypeID(const Value: integer);
    function GetDataSourceTypeID: integer;
    procedure SetAccountNo(const Value: boolean);
    function GetAccountNo: boolean;
    procedure SetAccountNoName(const Value: string);
    function GetAccountNoName: string;
    procedure SetInvoiceNo(const Value: boolean);
    function GetInvoiceNo: boolean;
    procedure SetInvoiceNoName(const Value: string);
    function GetInvoiceNoName: string;
    procedure SetTotalRevenue(const Value: boolean);
    function GetTotalRevenue: boolean;
    procedure SetTotalRevenueName(const Value: string);
    function GetTotalRevenueName: string;
    procedure SetTotalPayable(const Value: boolean);
    function GetTotalPayable: boolean;
    procedure SetTotalPayableName(const Value: string);
    function GetTotalPayableName: string;
    procedure SetTotalCredits(const Value: boolean);
    function GetTotalCredits: boolean;
    procedure SetTotalCreditsName(const Value: string);
    function GetTotalCreditsName: string;
    procedure SetOpeningBalance(const Value: boolean);
    function GetOpeningBalance: boolean;
    procedure SetOpeningBalanceName(const Value: string);
    function GetOpeningBalanceName: string;
    procedure SetPaymentsReceived(const Value: boolean);
    function GetPaymentsReceived: boolean;
    procedure SetPaymentsReceivedName(const Value: string);
    function GetPaymentsReceivedName: string;
    procedure SetTotalAdjustments(const Value: boolean);
    function GetTotalAdjustments: boolean;
    procedure SetTotalAdjustmentsName(const Value: string);
    function GetTotalAdjustmentsName: string;
    procedure SetBatchStart(const Value: boolean);
    function GetBatchStart: boolean;
    procedure SetBatchStartName(const Value: string);
    function GetBatchStartName: string;
    procedure SetBatchEnd(const Value: boolean);
    function GetBatchEnd: boolean;
    procedure SetBatchEndName(const Value: string);
    function GetBatchEndName: string;
    procedure SetPaymentDate(const Value: boolean);
    function GetPaymentDate: boolean;
    procedure SetPaymentDateName(const Value: string);
    function GetPaymentDateName: string;
    procedure SetCreditsToCustomers(const Value: boolean);
    function GetCreditsToCustomers: boolean;
    procedure SetCreditsToCustomersName(const Value: string);
    function GetCreditsToCustomersName: string;
    procedure SetGST(const Value: boolean);
    function GetGST: boolean;
    procedure SetGSTName(const Value: string);
    function GetGSTName: string;
    procedure SetGSTAdjustment(const Value: boolean);
    function GetGSTAdjustment: boolean;
    procedure SetGSTAdjustmentName(const Value: string);
    function GetGSTAdjustmentName: string;
    procedure SetOrderNumber(const Value: boolean);
    function GetOrderNumber: boolean;
    procedure SetOrderNumberName(const Value: string);
    function GetOrderNumberName: string;
    procedure SetRequisitionNumber(const Value: boolean);
    function GetRequisitionNumber: boolean;
    procedure SetRequisitionNumberName(const Value: string);
    function GetRequisitionNumberName: string;
    procedure SetIssueDate(const Value: boolean);
    function GetIssueDate: boolean;
    procedure SetIssueDateName(const Value: string);
    function GetIssueDateName: string;
    procedure SetRentDates(const Value: boolean);
    function GetRentDates: boolean;
    procedure SetCallDates(const Value: boolean);
    function GetCallDates: boolean;
    procedure SetRounding(const Value: boolean);
    function GetRounding: boolean;
    procedure SetRoundingName(const Value: string);
    function GetRoundingName: string;
    procedure SetTenderNumber(const Value: boolean);
    function GetTenderNumber: boolean;
    procedure SetMultiManualEntry(const Value: boolean);
    function GetMultiManualEntry: boolean;
    procedure SetEarlyRevenue(const Value: boolean);
    function GetEarlyRevenue: boolean;
    procedure SetVar01(const Value: string);
    procedure SetVar02(const Value: string);
    procedure SetVar03(const Value: string);
    procedure SetVar04(const Value: string);
    procedure SetVar05(const Value: string);
    procedure SetVar06(const Value: string);
    procedure SetVar07(const Value: string);
    procedure SetVar08(const Value: string);
    procedure SetVar09(const Value: string);
    procedure SetVar10(const Value: string);
    procedure SetVar11(const Value: string);
    procedure SetVar12(const Value: string);
    procedure SetVar13(const Value: string);
    procedure SetVar14(const Value: string);
    procedure SetVar15(const Value: string);
    procedure SetCritical(Value: string);
    procedure SetDubious(Value: string);
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property BatchTypeID: string write SetID;
    property Description: string read GetDescription write SetDescription;
    property SupplierID: integer read GetSupplierID write SetSupplierID;
    property ProgramID: integer read GetProgramID write SetProgramID;
    property SupplierDisplayedName: string read GetSupplierDisplayedName write SetSupplierDisplayedName;
    property ReportGroupID: integer read GetReportGroupID write SetReportGroupID;
    property DataSourceTypeID: integer read GetDataSourceTypeID write SetDataSourceTypeID;
    property AccountNo: boolean read GetAccountNo write SetAccountNo;
    property AccountNoName: string read GetAccountNoName write SetAccountNoName;
    property InvoiceNo: boolean read GetInvoiceNo write SetInvoiceNo;
    property InvoiceNoName: string read GetInvoiceNoName write SetInvoiceNoName;
    property TotalRevenue: boolean read GetTotalRevenue write SetTotalRevenue;
    property TotalRevenueName: string read GetTotalRevenueName write SetTotalRevenueName;
    property TotalPayable: boolean read GetTotalPayable write SetTotalPayable;
    property TotalPayableName: string read GetTotalPayableName write SetTotalPayableName;
    property TotalCredits: boolean read GetTotalCredits write SetTotalCredits;
    property TotalCreditsName: string read GetTotalCreditsName write SetTotalCreditsName;
    property OpeningBalance: boolean read GetOpeningBalance write SetOpeningBalance;
    property OpeningBalanceName: string read GetOpeningBalanceName write SetOpeningBalanceName;
    property PaymentsReceived: boolean read GetPaymentsReceived write SetPaymentsReceived;
    property PaymentsReceivedName: string read GetPaymentsReceivedName write SetPaymentsReceivedName;
    property TotalAdjustments: boolean read GetTotalAdjustments write SetTotalAdjustments;
    property TotalAdjustmentsName: string read GetTotalAdjustmentsName write SetTotalAdjustmentsName;
    property BatchStart: boolean read GetBatchStart write SetBatchStart;
    property BatchStartName: string read GetBatchStartName write SetBatchStartName;
    property BatchEnd: boolean read GetBatchEnd write SetBatchEnd;
    property BatchEndName: string read GetBatchEndName write SetBatchEndName;
    property PaymentDate: boolean read GetPaymentDate write SetPaymentDate;
    property PaymentDateName: string read GetPaymentDateName write SetPaymentDateName;
    property CreditsToCustomers: boolean read GetCreditsToCustomers write SetCreditsToCustomers;
    property CreditsToCustomersName: string read GetCreditsToCustomersName write SetCreditsToCustomersName;
    property GST: boolean read GetGST write SetGST;
    property GSTName: string read GetGSTName write SetGSTName;
    property GSTAdjustment: boolean read GetGSTAdjustment write SetGSTAdjustment;
    property GSTAdjustmentName: string read GetGSTAdjustmentName write SetGSTAdjustmentName;
    property OrderNumber: boolean read GetOrderNumber write SetOrderNumber;
    property OrderNumberName: string read GetOrderNumberName write SetOrderNumberName;
    property RequisitionNumber: boolean read GetRequisitionNumber write SetRequisitionNumber;
    property RequisitionNumberName: string read GetRequisitionNumberName write SetRequisitionNumberName;
    property IssueDate: boolean read GetIssueDate write SetIssueDate;
    property IssueDateName: string read GetIssueDateName write SetIssueDateName;
    property RentDates: boolean read GetRentDates write SetRentDates;
    property CallDates: boolean read GetCallDates write SetCallDates;
    property Rounding: boolean read GetRounding write SetRounding;
    property RoundingName: string read GetRoundingName write SetRoundingName;
    property TenderNumber: boolean read GetTenderNumber write SetTenderNumber;
    property MultiManual: boolean read GetMultiManualEntry write SetMultiManualEntry;
    property EarlyRevenue: boolean read GetEarlyRevenue write SetEarlyRevenue;
    property Var01: string write SetVar01;
    property Var02: string write SetVar02;
    property Var03: string write SetVar03;
    property Var04: string write SetVar04;
    property Var05: string write SetVar05;
    property Var06: string write SetVar06;
    property Var07: string write SetVar07;
    property Var08: string write SetVar08;
    property Var09: string write SetVar09;
    property Var10: string write SetVar10;
    property Var11: string write SetVar11;
    property Var12: string write SetVar12;
    property Var13: string write SetVar13;
    property Var14: string write SetVar14;
    property Var15: string write SetVar15;
    property Critical1To15: string read sCritical write SetCritical;
    property Dubious1To15: string read sDubious write SetDubious;
  public
    { Public declarations }
  end;

var
  SysEditBatchTypeForm: TSysEditBatchTypeForm;

implementation

uses
  PPSysMain, GenFns;

{$R *.DFM}

procedure TSysEditBatchTypeForm.FormCreate(Sender: TObject);
var
  qFormCreate : TQuery;
  ActionDescription : string;
begin
//  qBatchType.Open;
  qDataSourceType.Open;
  qReportGroup.Open;
//  cbDataSourceType.Text := qDataSourceType['DataSource'];
  qSupplier.Open;
  qProgram.Open;
  sUserName := Trim(MainForm.OPERATORNAME);
  qFormCreate := TQuery.Create(SELF);
  qFormCreate.DatabaseName := 'dbPPdata';
  qFormCreate.SQL.Add('SELECT *');
  qFormCreate.SQL.Add('FROM tEvent');
  qFormCreate.SQL.Add('WHERE Description LIKE ''Reference%''');
  qFormCreate.Open;
  while not qFormCreate.Eof do begin
    ActionDescription := UpperCase(qFormCreate.FieldByName('Description').AsString);
    if (Pos('UPDATE', ActionDescription) > 0) then
      AuditActionUpdate := qFormCreate.FieldByName('id').AsString
    else if (Pos('DELETE', ActionDescription) > 0) then
      AuditActionDelete := qFormCreate.FieldByName('id').AsString
    else if (Pos('INSERT', ActionDescription) > 0) then
      AuditActionInsert := qFormCreate.FieldByName('id').AsString;
    qFormCreate.Next;
  end;
  qFormCreate.Close;
  qFormCreate.Free;
  lAudit := TestForAudit('tBatchType');
end;

procedure TSysEditBatchTypeForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  qBatchType.Close;
  qReportGroup.Close;
  qDataSourceType.close;
  qSupplier.Close;
  qProgram.Close;
end;

procedure TSysEditBatchTypeForm.SetAppend(Value: boolean);
begin
  lAppend := Value;
  if lAppend then begin
    Caption := Caption + ' (ADD)';
    edtID.Text := '';
  end  // if lAppend then begin.
  else begin
    Caption := Caption + ' (EDIT)';
  end;  // if lAppend then begin..else.
end;  // SetAppend.

procedure TSysEditBatchTypeForm.SetID(Value: string);
//var
//  sFunction : string;
begin
  if not lAppend then edtID.Text := Value;
end;  // SetID.

procedure TSysEditBatchTypeForm.SetDescription(const Value: string);
begin
  Original_Description := Trim(Value);
  edtDescription.Text := Original_Description;
end;  // SetDescription.

function TSysEditBatchTypeForm.GetDescription: string;
begin
  Result := Trim(edtDescription.Text);
end;  // GetDescription.

procedure TSysEditBatchTypeForm.SetSupplierID(const Value: integer);
begin
  Original_SupplierID := IntToStr(Value);
  cbSupplier.KeyValue := Value;
end;  // SetSupplierID.

function TSysEditBatchTypeForm.GetSupplierID: integer;
begin
  if (Length(Trim(cbSupplier.Text)) > 0) then
    Result := qSupplier.FieldByName('id').AsInteger
  else
    Result := 0;
end;  // GetSupplierID.

procedure TSysEditBatchTypeForm.SetProgramID(const Value: integer);
begin
  Original_ProgramID := IntToStr(Value);
  cbProgram.KeyValue := Value;
end;  // SetProgramID.

function TSysEditBatchTypeForm.GetProgramID: integer;
begin
  if (Length(Trim(cbProgram.Text)) > 0) then
    Result := qProgram.FieldByName('id').AsInteger
  else
    Result := 0;
end;  // GetProgramID.

procedure TSysEditBatchTypeForm.SetSupplierDisplayedName(const Value: string);
begin
  Original_SupplierDisplayedName := Trim(Value);
  edtSupplierDisplayedName.Text := Original_SupplierDisplayedName;
end;  // SetSupplierDisplayedName.

function TSysEditBatchTypeForm.GetSupplierDisplayedName: string;
begin
  Result := Trim(edtSupplierDisplayedName.Text);
end;  // GetSupplierDisplayedName.

procedure TSysEditBatchTypeForm.SetReportGroupID(const Value: integer);
begin
  Original_ReportGroupID := IntToStr(Value);
  cbReportGroup.KeyValue := Value;
end;  // SetReportGroupID.

function TSysEditBatchTypeForm.GetReportGroupID: integer;
begin
  if (Length(Trim(cbReportGroup.Text)) > 0) then
    Result := qReportGroup.FieldByName('id').AsInteger
  else
    Result := 0;
end;  // GetReportGroupID.

procedure TSysEditBatchTypeForm.SetDataSourceTypeID(const Value: integer);
begin
  Original_DataSourceTypeID := IntToStr(Value);
  cbDataSourceType.KeyValue := Value;
end;  // SetDataSourceTypeID.

function TSysEditBatchTypeForm.GetDataSourceTypeID: integer;
begin
  if (Length(Trim(cbDataSourceType.Text)) > 0) then
    Result := qDataSourceType.FieldByName('id').AsInteger
  else
    Result := 0;
end;  // GetDataSourceTypeID.

procedure TSysEditBatchTypeForm.SetAccountNo(const Value: boolean);
begin
  Original_AccountNo := Value;
  ckAccountNo.Checked := Original_AccountNo;
end;  // SetAccountNo.

function TSysEditBatchTypeForm.GetAccountNo: boolean;
begin
  Result := ckAccountNo.Checked;
end;  // GetAccountNo.

procedure TSysEditBatchTypeForm.SetAccountNoName(const Value: string);
begin
  Original_AccountNoName := Trim(Value);
  edtAccountNo.Text := Original_AccountNoName;
end;

function TSysEditBatchTypeForm.GetAccountNoName: string;
begin
  Result := Trim(edtAccountNo.Text);
end;

procedure TSysEditBatchTypeForm.SetInvoiceNo(const Value: boolean);
begin
  Original_InvoiceNo := Value;
  ckInvoiceNo.Checked := Original_InvoiceNo;
end;

function TSysEditBatchTypeForm.GetInvoiceNo: boolean;
begin
  Result := ckInvoiceNo.Checked;
end;

procedure TSysEditBatchTypeForm.SetInvoiceNoName(const Value: string);
begin
  Original_InvoiceNoName := Trim(Value);
  edtInvoiceNo.Text := Original_InvoiceNoName;
end;

function TSysEditBatchTypeForm.GetInvoiceNoName: string;
begin
  Result := Trim(edtInvoiceNo.Text);
end;

procedure TSysEditBatchTypeForm.SetTotalRevenue(const Value: boolean);
begin
  Original_TotalRevenue := Value;
  ckTotalRevenue.Checked := Original_TotalRevenue;
end;

function TSysEditBatchTypeForm.GetTotalRevenue: boolean;
begin
  Result := ckTotalRevenue.Checked;
end;

procedure TSysEditBatchTypeForm.SetTotalRevenueName(const Value: string);
begin
  Original_TotalRevenueName := Trim(Value);
  edtTotalRevenue.Text := Original_TotalRevenueName;
end;

function TSysEditBatchTypeForm.GetTotalRevenueName: string;
begin
  Result := Trim(edtTotalRevenue.Text);
end;

procedure TSysEditBatchTypeForm.SetTotalPayable(const Value: boolean);
begin
  Original_TotalPayable := Value;
  ckTotalPayable.Checked := Original_TotalPayable;
end;

function TSysEditBatchTypeForm.GetTotalPayable: boolean;
begin
  Result := ckTotalPayable.Checked;
end;

procedure TSysEditBatchTypeForm.SetTotalPayableName(const Value: string);
begin
  Original_TotalPayableName := Trim(Value);
  edtTotalPayable.Text := Original_TotalPayableName;
end;

function TSysEditBatchTypeForm.GetTotalPayableName: string;
begin
  Result := Trim(edtTotalPayable.Text);
end;

procedure TSysEditBatchTypeForm.SetTotalCredits(const Value: boolean);
begin
  Original_TotalCredits := Value;
  ckTotalCredits.Checked := Original_TotalCredits;
end;

function TSysEditBatchTypeForm.GetTotalCredits: boolean;
begin
  Result := ckTotalCredits.Checked;
end;

procedure TSysEditBatchTypeForm.SetTotalCreditsName(const Value: string);
begin
  Original_TotalCreditsName := Trim(Value);
  edtTotalCredits.Text := Original_TotalCreditsName;
end;

function TSysEditBatchTypeForm.GetTotalCreditsName: string;
begin
  Result := Trim(edtTotalCredits.Text);
end;

procedure TSysEditBatchTypeForm.SetOpeningBalance(const Value: boolean);
begin
  Original_OpeningBalance := Value;
  ckOpeningBalance.Checked := Original_OpeningBalance;
end;

function TSysEditBatchTypeForm.GetOpeningBalance: boolean;
begin
  Result := ckOpeningBalance.Checked;
end;

procedure TSysEditBatchTypeForm.SetOpeningBalanceName(const Value: string);
begin
  Original_OpeningBalanceName := Trim(Value);
  edtOpeningBalance.Text := Original_OpeningBalanceName;
end;

function TSysEditBatchTypeForm.GetOpeningBalanceName: string;
begin
  Result := Trim(edtOpeningBalance.Text);
end;

procedure TSysEditBatchTypeForm.SetPaymentsReceived(const Value: boolean);
begin
  Original_PaymentsReceived := Value;
  ckPaymentsReceived.Checked := Original_PaymentsReceived;
end;

function TSysEditBatchTypeForm.GetPaymentsReceived: boolean;
begin
  Result := ckPaymentsReceived.Checked;
end;

procedure TSysEditBatchTypeForm.SetPaymentsReceivedName(const Value: string);
begin
  Original_PaymentsReceivedName := Trim(Value);
  edtPaymentsReceived.Text := Original_PaymentsReceivedName;
end;

function TSysEditBatchTypeForm.GetPaymentsReceivedName: string;
begin
  Result := Trim(edtPaymentsReceived.Text);
end;

procedure TSysEditBatchTypeForm.SetTotalAdjustments(const Value: boolean);
begin
  Original_TotalAdjustments := Value;
  ckTotalAdjustments.Checked := Original_TotalAdjustments;
end;

function TSysEditBatchTypeForm.GetTotalAdjustments: boolean;
begin
  Result := ckTotalAdjustments.Checked;
end;

procedure TSysEditBatchTypeForm.SetTotalAdjustmentsName(const Value: string);
begin
  Original_TotalAdjustmentsName := Trim(Value);
  edtTotalAdjustments.Text := Original_TotalAdjustmentsName;
end;

function TSysEditBatchTypeForm.GetTotalAdjustmentsName: string;
begin
  Result := Trim(edtTotalAdjustments.Text);
end;

procedure TSysEditBatchTypeForm.SetBatchStart(const Value: boolean);
begin
  Original_BatchStart := Value;
  ckBatchStart.Checked := Original_BatchStart;
end;

function TSysEditBatchTypeForm.GetBatchStart: boolean;
begin
  Result := ckBatchStart.Checked;
end;

procedure TSysEditBatchTypeForm.SetBatchStartName(const Value: string);
begin
  Original_BatchStartName := Trim(Value);
  edtBatchStart.Text := Original_BatchStartName;
end;

function TSysEditBatchTypeForm.GetBatchStartName: string;
begin
  Result := Trim(edtBatchStart.Text);
end;

procedure TSysEditBatchTypeForm.SetBatchEnd(const Value: boolean);
begin
  Original_BatchEnd := Value;
  ckBatchEnd.Checked := Original_BatchEnd;
end;

function TSysEditBatchTypeForm.GetBatchEnd: boolean;
begin
  Result := ckBatchEnd.Checked;
end;

procedure TSysEditBatchTypeForm.SetBatchEndName(const Value: string);
begin
  Original_BatchEndName := Trim(Value);
  edtBatchEnd.Text := Original_BatchEndName;
end;

function TSysEditBatchTypeForm.GetBatchEndName: string;
begin
  Result := Trim(edtBatchEnd.Text);
end;

procedure TSysEditBatchTypeForm.SetPaymentDate(const Value: boolean);
begin
  Original_PaymentDate := Value;
  ckPaymentDate.Checked := Original_PaymentDate;
end;

function TSysEditBatchTypeForm.GetPaymentDate: boolean;
begin
  Result := ckPaymentDate.Checked;
end;

procedure TSysEditBatchTypeForm.SetPaymentDateName(const Value: string);
begin
  Original_PaymentDateName := Trim(Value);
  edtPaymentDate.Text := Original_PaymentDateName;
end;

function TSysEditBatchTypeForm.GetPaymentDateName: string;
begin
  Result := Trim(edtPaymentDate.Text);
end;

procedure TSysEditBatchTypeForm.SetCreditsToCustomers(const Value: boolean);
begin
  Original_CreditsToCustomers := Value;
  ckCreditsToCustomers.Checked := Original_CreditsToCustomers;
end;

function TSysEditBatchTypeForm.GetCreditsToCustomers: boolean;
begin
  Result := ckCreditsToCustomers.Checked;
end;

procedure TSysEditBatchTypeForm.SetCreditsToCustomersName(const Value: string);
begin
  Original_CreditsToCustomersName := Trim(Value);
  edtCreditsToCustomers.Text := Original_CreditsToCustomersName;
end;

function TSysEditBatchTypeForm.GetCreditsToCustomersName: string;
begin
  Result := Trim(edtCreditsToCustomers.Text);
end;

procedure TSysEditBatchTypeForm.SetGST(const Value: boolean);
begin
  Original_GST := Value;
  ckGST.Checked := Original_GST;
end;

function TSysEditBatchTypeForm.GetGST: boolean;
begin
  Result := ckGST.Checked;
end;

procedure TSysEditBatchTypeForm.SetGSTName(const Value: string);
begin
  Original_GSTName := Trim(Value);
  edtGST.Text := Original_GSTName;
end;

function TSysEditBatchTypeForm.GetGSTName: string;
begin
  Result := Trim(edtGST.Text);
end;

procedure TSysEditBatchTypeForm.SetGSTAdjustment(const Value: boolean);
begin
  Original_GSTAdjustment := Value;
  ckGSTAdjustment.Checked := Original_GSTAdjustment;
end;

function TSysEditBatchTypeForm.GetGSTAdjustment: boolean;
begin
  Result := ckGSTAdjustment.Checked;
end;

procedure TSysEditBatchTypeForm.SetGSTAdjustmentName(const Value: string);
begin
  Original_GSTAdjustmentName := Trim(Value);
  edtGSTAdjustment.Text := Original_GSTAdjustmentName;
end;

function TSysEditBatchTypeForm.GetGSTAdjustmentName: string;
begin
  Result := Trim(edtGSTAdjustment.Text);
end;

procedure TSysEditBatchTypeForm.SetOrderNumber(const Value: boolean);
begin
  Original_OrderNumber := Value;
  ckOrderNumber.Checked := Original_OrderNumber;
end;

function TSysEditBatchTypeForm.GetOrderNumber: boolean;
begin
  Result := ckOrderNumber.Checked;
end;

procedure TSysEditBatchTypeForm.SetOrderNumberName(const Value: string);
begin
  Original_OrderNumberName := Trim(Value);
  edtOrderNumber.Text := Original_OrderNumberName;
end;

function TSysEditBatchTypeForm.GetOrderNumberName: string;
begin
  Result := Trim(edtOrderNumber.Text);
end;

procedure TSysEditBatchTypeForm.SetRequisitionNumber(const Value: boolean);
begin
  Original_RequisitionNumber := Value;
  ckRequisitionNumber.Checked := Original_RequisitionNumber;
end;

function TSysEditBatchTypeForm.GetRequisitionNumber: boolean;
begin
  Result := ckRequisitionNumber.Checked;
end;

procedure TSysEditBatchTypeForm.SetRequisitionNumberName(const Value: string);
begin
  Original_RequisitionNumberName := Trim(Value);
  edtRequisitionNumber.Text := Original_RequisitionNumberName;
end;

function TSysEditBatchTypeForm.GetRequisitionNumberName: string;
begin
  Result := Trim(edtRequisitionNumber.Text);
end;

procedure TSysEditBatchTypeForm.SetIssueDate(const Value: boolean);
begin
  Original_IssueDate := Value;
  ckIssueDate.Checked := Original_IssueDate;
end;

function TSysEditBatchTypeForm.GetIssueDate: boolean;
begin
  Result := ckIssueDate.Checked;
end;

procedure TSysEditBatchTypeForm.SetIssueDateName(const Value: string);
begin
  Original_IssueDateName := Trim(Value);
  edtIssueDate.Text := Original_IssueDateName;
end;

function TSysEditBatchTypeForm.GetIssueDateName: string;
begin
  Result := Trim(edtIssueDate.Text);
end;

procedure TSysEditBatchTypeForm.SetRentDates(const Value: boolean);
begin
  Original_RentDates := Value;
  ckRentDates.Checked := Original_RentDates;
end;

function TSysEditBatchTypeForm.GetRentDates: boolean;
begin
  Result := ckRentDates.Checked;
end;

procedure TSysEditBatchTypeForm.SetCallDates(const Value: boolean);
begin
  Original_CallDates := Value;
  ckCallDates.Checked := Original_CallDates;
end;

function TSysEditBatchTypeForm.GetCallDates: boolean;
begin
  Result := ckCallDates.Checked;
end;

procedure TSysEditBatchTypeForm.SetRounding(const Value: boolean);
begin
  Original_Rounding := Value;
  ckRounding.Checked := Original_Rounding;
end;

function TSysEditBatchTypeForm.GetRounding: boolean;
begin
  Result := ckRounding.Checked;
end;

procedure TSysEditBatchTypeForm.SetRoundingName(const Value: string);
begin
  Original_RoundingName := Trim(Value);
  edtRounding.Text := Original_RoundingName;
end;

function TSysEditBatchTypeForm.GetRoundingName: string;
begin
  Result := Trim(edtRounding.Text);
end;

procedure TSysEditBatchTypeForm.SetTenderNumber(const Value: boolean);
begin
  Original_TenderNumber := Value;
  ckTenderNumber.Checked := Original_TenderNumber;
end;

function TSysEditBatchTypeForm.GetTenderNumber: boolean;
begin
  Result := ckTenderNumber.Checked;
end;

procedure TSysEditBatchTypeForm.SetMultiManualEntry(const Value: boolean);
begin
  Original_MultiManualEntry := Value;
  ckMultiManual.Checked := Original_MultiManualEntry;
end;

function TSysEditBatchTypeForm.GetMultiManualEntry: boolean;
begin
  Result := ckMultiManual.Checked;
end;

procedure TSysEditBatchTypeForm.SetEarlyRevenue(const Value: boolean);
begin
  Original_EarlyRevenue := Value;
  ckPrelimRevenue.Checked := Original_EarlyRevenue;
end;

function TSysEditBatchTypeForm.GetEarlyRevenue: boolean;
begin
  Result := ckPrelimRevenue.Checked;
end;

procedure TSysEditBatchTypeForm.SetVar01(const Value: string);
begin
  Original_Var01 := Trim(Value);
  edtVar01.Text := Original_Var01;
end;

procedure TSysEditBatchTypeForm.SetVar02(const Value: string);
begin
  Original_Var02 := Trim(Value);
  edtVar02.Text := Original_Var02;
end;

procedure TSysEditBatchTypeForm.SetVar03(const Value: string);
begin
  Original_Var03 := Trim(Value);
  edtVar03.Text := Original_Var03;
end;

procedure TSysEditBatchTypeForm.SetVar04(const Value: string);
begin
  Original_Var04 := Trim(Value);
  edtVar04.Text := Original_Var04;
end;

procedure TSysEditBatchTypeForm.SetVar05(const Value: string);
begin
  Original_Var05 := Trim(Value);
  edtVar05.Text := Original_Var05;
end;

procedure TSysEditBatchTypeForm.SetVar06(const Value: string);
begin
  Original_Var06 := Trim(Value);
  edtVar06.Text := Original_Var06;
end;

procedure TSysEditBatchTypeForm.SetVar07(const Value: string);
begin
  Original_Var07 := Trim(Value);
  edtVar07.Text := Original_Var07;
end;

procedure TSysEditBatchTypeForm.SetVar08(const Value: string);
begin
  Original_Var08 := Trim(Value);
  edtVar08.Text := Original_Var08;
end;

procedure TSysEditBatchTypeForm.SetVar09(const Value: string);
begin
  Original_Var09 := Trim(Value);
  edtVar09.Text := Original_Var09;
end;

procedure TSysEditBatchTypeForm.SetVar10(const Value: string);
begin
  Original_Var10 := Trim(Value);
  edtVar10.Text := Original_Var10;
end;

procedure TSysEditBatchTypeForm.SetVar11(const Value: string);
begin
  Original_Var11 := Trim(Value);
  edtVar11.Text := Original_Var11;
end;

procedure TSysEditBatchTypeForm.SetVar12(const Value: string);
begin
  Original_Var12 := Trim(Value);
  edtVar12.Text := Original_Var12;
end;

procedure TSysEditBatchTypeForm.SetVar13(const Value: string);
begin
  Original_Var13 := Trim(Value);
  edtVar13.Text := Original_Var13;
end;

procedure TSysEditBatchTypeForm.SetVar14(const Value: string);
begin
  Original_Var14 := Trim(Value);
  edtVar14.Text := Original_Var14;
end;

procedure TSysEditBatchTypeForm.SetVar15(const Value: string);
begin
  Original_Var15 := Trim(Value);
  edtVar15.Text := Original_Var15;
end;

procedure TSysEditBatchTypeForm.SetCritical(Value: string);
var
  sTemp : string;
  lTruncated : boolean;
begin
  sTemp := Value;
  // Only 16-digit integer tolerated.
  ProveInteger(sTemp,lTruncated);
  if lTruncated then sTemp := Copy(sTemp+'0000000000000000',1,16);
  sCritical := sTemp;
  ckCritical01.Checked := (Copy(sCritical, 1,1)<>'0');
  ckCritical02.Checked := (Copy(sCritical, 2,1)<>'0');
  ckCritical03.Checked := (Copy(sCritical, 3,1)<>'0');
  ckCritical04.Checked := (Copy(sCritical, 4,1)<>'0');
  ckCritical05.Checked := (Copy(sCritical, 5,1)<>'0');
  ckCritical06.Checked := (Copy(sCritical, 6,1)<>'0');
  ckCritical07.Checked := (Copy(sCritical, 7,1)<>'0');
  ckCritical08.Checked := (Copy(sCritical, 8,1)<>'0');
  ckCritical09.Checked := (Copy(sCritical, 9,1)<>'0');
  ckCritical10.Checked := (Copy(sCritical,10,1)<>'0');
  ckCritical11.Checked := (Copy(sCritical,11,1)<>'0');
  ckCritical12.Checked := (Copy(sCritical,12,1)<>'0');
  ckCritical13.Checked := (Copy(sCritical,13,1)<>'0');
  ckCritical14.Checked := (Copy(sCritical,14,1)<>'0');
  ckCritical15.Checked := (Copy(sCritical,15,1)<>'0');
  Original_C1  := ckCritical01.Checked;
  Original_C2  := ckCritical02.Checked;
  Original_C3  := ckCritical03.Checked;
  Original_C4  := ckCritical04.Checked;
  Original_C5  := ckCritical05.Checked;
  Original_C6  := ckCritical06.Checked;
  Original_C7  := ckCritical07.Checked;
  Original_C8  := ckCritical08.Checked;
  Original_C9  := ckCritical09.Checked;
  Original_C10 := ckCritical10.Checked;
  Original_C11 := ckCritical11.Checked;
  Original_C12 := ckCritical12.Checked;
  Original_C13 := ckCritical13.Checked;
  Original_C14 := ckCritical14.Checked;
  Original_C15 := ckCritical15.Checked;
end;  // SetCritical.

procedure TSysEditBatchTypeForm.SetDubious(Value: string);
var
  sTemp : string;
  lTruncated : boolean;
begin
  sTemp := Value;
  // Only 16-digit integer tolerated.
  ProveInteger(sTemp,lTruncated);
  if lTruncated then sTemp := Copy(sTemp+'0000000000000000',1,16);
  sDubious := sTemp;
  ckDubious01.Checked := (Copy(sDubious, 1,1)<>'0');
  ckDubious02.Checked := (Copy(sDubious, 2,1)<>'0');
  ckDubious03.Checked := (Copy(sDubious, 3,1)<>'0');
  ckDubious04.Checked := (Copy(sDubious, 4,1)<>'0');
  ckDubious05.Checked := (Copy(sDubious, 5,1)<>'0');
  ckDubious06.Checked := (Copy(sDubious, 6,1)<>'0');
  ckDubious07.Checked := (Copy(sDubious, 7,1)<>'0');
  ckDubious08.Checked := (Copy(sDubious, 8,1)<>'0');
  ckDubious09.Checked := (Copy(sDubious, 9,1)<>'0');
  ckDubious10.Checked := (Copy(sDubious,10,1)<>'0');
  ckDubious11.Checked := (Copy(sDubious,11,1)<>'0');
  ckDubious12.Checked := (Copy(sDubious,12,1)<>'0');
  ckDubious13.Checked := (Copy(sDubious,13,1)<>'0');
  ckDubious14.Checked := (Copy(sDubious,14,1)<>'0');
  ckDubious15.Checked := (Copy(sDubious,15,1)<>'0');
  Original_D1  := ckDubious01.Checked;
  Original_D2  := ckDubious02.Checked;
  Original_D3  := ckDubious03.Checked;
  Original_D4  := ckDubious04.Checked;
  Original_D5  := ckDubious05.Checked;
  Original_D6  := ckDubious06.Checked;
  Original_D7  := ckDubious07.Checked;
  Original_D8  := ckDubious08.Checked;
  Original_D9  := ckDubious09.Checked;
  Original_D10 := ckDubious10.Checked;
  Original_D11 := ckDubious11.Checked;
  Original_D12 := ckDubious12.Checked;
  Original_D13 := ckDubious13.Checked;
  Original_D14 := ckDubious14.Checked;
  Original_D15 := ckDubious15.Checked;
end;  // SetDubious.

procedure TSysEditBatchTypeForm.btnOkClick(Sender: TObject);
var
  AmendString : TStringList;
  AuditString : TStringlist;
  sField : string;
  sValue : string;
  sTempValue : string;
  sAuditInsert : string;
  sAuditField : string;
  sAuditValue : string;
  AuditAction : string;
  sOperatorName: string;
  slFieldList : TStringList;
  slValueList : TStringList;
  nCount : integer;
  nMaxCount : integer;
  sStarted : string;
  lChanged : boolean;
begin
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  sOperatorName := MainForm.OPERATORNAME;
  AmendString := TStringList.Create;
  AuditString := TStringList.Create;
  if lAppend then begin
    slFieldList := TStringList.Create;
    slValueList := TStringList.Create;
    if lAudit then begin
{
      SetAuditSelect(sUserName, AuditAction, 'tBatchType',
        AuditString, sAuditField, sAuditValue);
}
      SetAuditStart(sUserName, AuditAction, 'tBatchType',
        sAuditInsert, sAuditField, sAuditValue);
    end;  // lAudit.
    AmendString.Add('INSERT INTO tBatchType');
    sField := '(Description, SupplierID, DataSourceTypeID, Active,';
    sStarted := Copy(Description,1,50);
    if (Length(sStarted)=0) then sValue := 'NULL,'
    else begin
      sValue := ''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('DESCRIPTION', '', sStarted, AuditString);
      end;
    end;
    slFieldList.Add(sField);
    slValueList.Add('VALUES ('+ sValue +
      IntToStr(SupplierID)+','+
      IntToStr(DataSourceTypeID)+',1,');
    sField := '';
    sValue := '';
    if lAudit then begin
      SetAuditData('SUPPLIERID', '', IntToStr(SupplierID),
        AuditString);
      SetAuditData('DATASOURCETYPEID', '',
        IntToStr(DataSourceTypeID), AuditString);
    end;

    sField := 'SupplierDisplayedName, ReportGroupID,';
    sStarted := Copy(SupplierDisplayedName,1,100);
    if (Length(sStarted)=0) then sValue := 'NULL,'
    else begin
      sValue := ''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('SUPPLIERDISPLAYEDNAME', '', sStarted, AuditString);
      end;
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue +
      IntToStr(ReportGroupID)+',');
    sField := '';
    sValue := '';
    if lAudit then begin
      SetAuditData('REPORTGROUPID', '', IntToStr(ReportGroupID),
        AuditString);
    end;

    sField := 'AccountNo, InvoiceNo, TotalRevenue, TotalPayable, '+
      'TotalCredits, OpeningBalance, PaymentsReceived,';
    if ckAccountNo.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('ACCOUNTNO', '', sTempValue, AuditString);
    end;
    if ckInvoiceNo.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('INVOICENO', '', sTempValue, AuditString);
    end;
    if ckTotalRevenue.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('TOTALREVENUE', '', sTempValue, AuditString);
    end;
    if ckTotalPayable.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('TOTALPAYABLE', '', sTempValue, AuditString);
    end;
    if ckTotalCredits.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('TOTALCREDITS', '', sTempValue, AuditString);
    end;
    if ckOpeningBalance.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('OPENINGBALANCE', '', sTempValue, AuditString);
    end;
    if ckPaymentsReceived.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('PAYMENTSRECEIVED ', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sField := 'TotalAdjustments, BatchStart, BatchEnd, PaymentDate, '+
      'CreditsToCustomers, GST, GSTAdjustment,';
    if ckTotalAdjustments.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('TOTALADJUSTMENTS', '', sTempValue, AuditString);
    end;
    if ckBatchStart.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('BATCHSTART', '', sTempValue, AuditString);
    end;
    if ckBatchEnd.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('BATCHEND', '', sTempValue, AuditString);
    end;
    if ckPaymentDate.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('PAYMENTDATE', '', sTempValue, AuditString);
    end;
    if ckCreditsToCustomers.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CREDITSTOCUSTOMERS', '', sTempValue, AuditString);
    end;
    if ckGST.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('GST', '', sTempValue, AuditString);
    end;
    if ckGSTAdjustment.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('GSTADJUSTMENT', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sField := 'OrderNumber, RequisitionNumber, IssueDate, RentDates, '+
      'CallDates, Rounding, TenderNumber,MultiManualEntry,EarlyRevenue,';
    if ckOrderNumber.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('ORDERNUMBER', '', sTempValue, AuditString);
    end;
    if ckRequisitionNumber.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('REQUISITIONNUMBER', '', sTempValue, AuditString);
    end;
    if ckIssueDate.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('ISSUEDATE', '', sTempValue, AuditString);
    end;
    if ckRentDates.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('RENTDATES', '', sTempValue, AuditString);
    end;
    if ckCallDates.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CALLDATES', '', sTempValue, AuditString);
    end;
    if ckRounding.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('ROUNDING', '', sTempValue, AuditString);
    end;
    if ckTenderNumber.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('TENDERNUMBER', '', sTempValue, AuditString);
    end;
    if ckMultiManual.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('MULTIMANUALENTRY', '', sTempValue, AuditString);
    end;
    if ckPrelimRevenue.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('EARLYREVENUE', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sField := 'CriticalCheck01, CriticalCheck02, CriticalCheck03, '+
      'CriticalCheck04, CriticalCheck05, CriticalCheck06, CriticalCheck07,';
    if ckCritical01.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK01', '', sTempValue, AuditString);
    end;
    if ckCritical02.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK02', '', sTempValue, AuditString);
    end;
    if ckCritical03.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK03', '', sTempValue, AuditString);
    end;
    if ckCritical04.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK04', '', sTempValue, AuditString);
    end;
    if ckCritical05.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK05', '', sTempValue, AuditString);
    end;
    if ckCritical06.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK06', '', sTempValue, AuditString);
    end;
    if ckCritical07.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK07', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sField := 'CriticalCheck08, CriticalCheck09, CriticalCheck10, CriticalCheck11, '+
      'CriticalCheck12, CriticalCheck13, CriticalCheck14, CriticalCheck15,';
    if ckCritical08.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK08', '', sTempValue, AuditString);
    end;
    if ckCritical09.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK09', '', sTempValue, AuditString);
    end;
    if ckCritical10.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK10', '', sTempValue, AuditString);
    end;
    if ckCritical11.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK11', '', sTempValue, AuditString);
    end;
    if ckCritical12.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK12', '', sTempValue, AuditString);
    end;
    if ckCritical13.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK13', '', sTempValue, AuditString);
    end;
    if ckCritical14.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK14', '', sTempValue, AuditString);
    end;
    if ckCritical15.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('CRITICALCHECK15', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sField := 'DubiousCheck01, DubiousCheck02, DubiousCheck03, DubiousCheck04, '+
      'DubiousCheck05, DubiousCheck06, DubiousCheck07,';
    if ckDubious01.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK01', '', sTempValue, AuditString);
    end;
    if ckDubious02.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK02', '', sTempValue, AuditString);
    end;
    if ckDubious03.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK03', '', sTempValue, AuditString);
    end;
    if ckDubious04.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK04', '', sTempValue, AuditString);
    end;
    if ckDubious05.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK05', '', sTempValue, AuditString);
    end;
    if ckDubious06.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK06', '', sTempValue, AuditString);
    end;
    if ckDubious07.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK07', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sField := 'DubiousCheck08, DubiousCheck09, DubiousCheck10, DubiousCheck11, '+
      'DubiousCheck12, DubiousCheck13, DubiousCheck14, DubiousCheck15,';
    if ckDubious08.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK08', '', sTempValue, AuditString);
    end;
    if ckDubious09.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK09', '', sTempValue, AuditString);
    end;
    if ckDubious10.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK10', '', sTempValue, AuditString);
    end;
    if ckDubious11.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK11', '', sTempValue, AuditString);
    end;
    if ckDubious12.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK12', '', sTempValue, AuditString);
    end;
    if ckDubious13.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK13', '', sTempValue, AuditString);
    end;
    if ckDubious14.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK14', '', sTempValue, AuditString);
    end;
    if ckDubious15.Checked then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue + ',';
    if lAudit then begin
      SetAuditData('DUBIOUSCHECK15', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sTempValue := IntToStr(ProgramID);
    if (sTempValue = '0') then begin
      sTempValue := 'NULL';
    end
    else if lAudit then begin
      SetAuditData('PROGRAMID', '', sTempValue, AuditString);
    end;
    sField := 'ProgramID,';
    sValue := sValue +sTempValue+',';
    sTempValue := Copy(Trim(edtAccountNo.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField + 'AccountNoName,';
      sValue := sValue +''''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ACCOUNTNONAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtInvoiceNo.Text),1,50);
    if (Length(sTempValue) > 0) then begin
       sField := sField +' InvoiceNoName,';
       sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('INVOICENONAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtTotalRevenue.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' TotalRevenueName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('TOTALREVENUENAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtTotalPayable.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' TotalPayableName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('TOTALPAYABLENAME', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtTotalCredits.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' TotalCreditsName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('TOTALCREDITSNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtOpeningBalance.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' OpeningBalanceName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('OPENINGBALANCENAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtPaymentsReceived.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' PaymentsReceivedName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('PAYMENTSRECEIVEDNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtTotalAdjustments.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' TotalAdjustmentsName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('TOTALADJUSTMENTSNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtBatchStart.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' BatchStartName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('BATCHSTARTNAME', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtBatchEnd.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' BatchEndName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('BATCHENDNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtPaymentDate.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' PaymentDateName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('PAYMENTDATENAME', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtGST.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' GSTName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('GSTNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtGSTAdjustment.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' GSTAdjustmentName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('GSTADJUSTMENTNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtOrderNumber.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' OrderNumberName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ORDERNUMBERNAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtRequisitionNumber.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' RequisitionNumberName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('REQUISITIONNUMBERNAME', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtIssueDate.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' IssueDateName,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ISSUEDATENAME', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtRounding.Text),1,50);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' RoundingName,';
      if lAudit then begin
        SetAuditData('ROUNDINGNAME', '', sTempValue, AuditString);
      end;
      sValue := sValue +' '''+sTempValue+''',';
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtVar01.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var01Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR01DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar02.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var02Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR02DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar03.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var03Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR03DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar04.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var04Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR04DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtVar05.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var05Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR05DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar06.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var06Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR06DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar07.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var07Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR07DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar08.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var08Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR08DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtVar09.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var09Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR09DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar10.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var10Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR10DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar11.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var11Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR11DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar12.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var12Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR12DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Trim(edtVar13.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var13Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR13DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar14.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var14Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR14DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Trim(edtVar15.Text),1,20);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Var15Description,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('VAR15DESCRIPTION', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    // Last char must be a closed parenthesis.
    sField := slFieldList[slFieldList.Count-1];
    sField := Copy(sField, 1, Length(sField)-1) + ')';
    slFieldList[slFieldList.Count-1] := sField;
    sValue := slValueList[slValueList.Count-1];
    sValue := Copy(sValue, 1, Length(sValue)-1) + ')';
    slValueList[slValueList.Count-1] := sValue;
    // Now compose the full SQL statement.
    nMaxCount := slFieldList.Count - 1;
    for nCount := 0 to nMaxCount do AmendString.Add(slFieldList[nCount]);
    for nCount := 0 to nMaxCount do AmendString.Add(slValueList[nCount]);
{
    if lAudit and (Length(AuditTrailDesc) = 0) then begin
      lAudit := False;
    end;  // lAudit.
}
  end  // if lAppend then begin.     *****************************************
  else begin                      // ********************** UPDATE ***********
    AmendString.Add('UPDATE tBatchType');
    sTempValue := Description;
    // Define Description as a Null or as a String.
    if (Length(sTempValue)=0) then sValue := 'NULL,'
    else                           sValue := ''''+Copy(sTempValue,1,50)+''', ';
    if lAudit then begin
{
      SetAuditSelect(sUserName, AuditAction, 'tBatchType',
        AuditString, sAuditField, sAuditValue);
      sAuditField := sAuditField +',TableID';
      sAuditValue := sAuditValue +','+ Trim(edtID.Text);
}
      SetAuditStart(sUserName, AuditAction, 'tBatchType',
        sAuditInsert, sAuditField, sAuditValue);
      SetAuditID(Trim(edtID.Text), sAuditValue);
      if (sValue <> Original_Description) then begin
        SetAuditData('DESCRIPTION', Original_Description, sTempValue, AuditString);
      end;
      sTempValue := IntToStr(SupplierID);
      if (sTempValue <> Original_SupplierID) then begin
        SetAuditData('SUPPLIERID', Original_SupplierID, sTempValue, AuditString);
      end;
      sTempValue := IntToStr(DataSourceTypeID);
      if (sTempValue <> Original_DataSourceTypeID) then begin
        SetAuditData('DATASOURCETYPEID', Original_DataSourceTypeID, sTempValue,
          AuditString);
      end;
    end;  // lAudit.
    sValue := 'SET Description = '+sValue+
              'SupplierID = '+ IntToStr(SupplierID)+', '+
              'DataSourceTypeID = '+ IntToStr(DataSourceTypeID)+',';
    AmendString.Add(sValue);
    sValue := '';
    sTempValue := Copy(SupplierDisplayedName,1,100);
    if (sTempValue <> Original_SupplierDisplayedName) then begin
      if (Length(sStarted)=0) then sStarted := 'NULL,'
      else                         sStarted := ''''+sTempValue+''',';
      sValue := ' SupplierDisplayedName = '+ sStarted;
      if lAudit then begin
        SetAuditData('SUPPLIERDISPLAYEDNAME', Original_SupplierDisplayedName,
          sTempValue, AuditString);
      end;
    end;
    sStarted := IntToStr(ReportGroupID);
    if (sStarted <> Original_ReportGroupID) then begin
      sValue := sValue +' ReportGroupID = '+ IntToStr(ReportGroupID)+',';
      if lAudit then begin
        SetAuditData('REPORTGROUPID', Original_ReportGroupID, sStarted,
          AuditString);
      end;
    end;
    if (Length(sValue) > 0) then begin
      AmendString.Add(sValue);
      sValue := '';
    end;
    if ckAccountNo.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_AccountNo then begin
        SetAuditData('ACCOUNTNO', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_AccountNo then begin
        SetAuditData('ACCOUNTNO', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' AccountNo = '+sTempValue;
    if ckInvoiceNo.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_InvoiceNo then begin
        SetAuditData('INVOICENO', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_InvoiceNo then begin
        SetAuditData('INVOICENO', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' InvoiceNo = '+sTempValue;
    if ckTotalRevenue.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_TotalRevenue then begin
        SetAuditData('TOTALREVENUE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_TotalRevenue then begin
        SetAuditData('TOTALREVENUE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' TotalRevenue = '+sTempValue;
    if ckTotalPayable.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_TotalPayable then begin
        SetAuditData('TOTALPAYABLE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_TotalPayable then begin
        SetAuditData('TOTALPAYABLE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' TotalPayable = '+sTempValue;
    if ckTotalCredits.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_TotalCredits then begin
        SetAuditData('TOTALCREDITS', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_TotalCredits then begin
        SetAuditData('TOTALCREDITS', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' TotalCredits = '+sTempValue;
    if ckOpeningBalance.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_OpeningBalance then begin
        SetAuditData('OPENINGBALANCE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_OpeningBalance then begin
        SetAuditData('OPENINGBALANCE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' OpeningBalance = '+sTempValue;
    if ckPaymentsReceived.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_PaymentsReceived then begin
        SetAuditData('PAYMENTSRECEIVED', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_PaymentsReceived then begin
        SetAuditData('PAYMENTSRECEIVED', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' PaymentsReceived = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    if ckTotalAdjustments.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_TotalAdjustments then begin
        SetAuditData('TOTALADJUSTMENTS', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_TotalAdjustments then begin
        SetAuditData('TOTALADJUSTMENTS', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' TotalAdjustments = '+sTempValue;
    if ckBatchStart.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_BatchStart then begin
        SetAuditData('BATCHSTART', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_BatchStart then begin
        SetAuditData('BATCHSTART', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' BatchStart = '+sTempValue;
    if ckBatchEnd.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_BatchEnd then begin
        SetAuditData('BATCHEND', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_BatchEnd then begin
        SetAuditData('BATCHEND', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' BatchEnd = '+sTempValue;
    if ckPaymentDate.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_PaymentDate then begin
        SetAuditData('PAYMENTDATE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_PaymentDate then begin
        SetAuditData('PAYMENTDATE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' PaymentDate = '+sTempValue;
    if ckCreditsToCustomers.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_CreditsToCustomers then begin
        SetAuditData('CREDITSTOCUSTOMERS', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_CreditsToCustomers then begin
        SetAuditData('CREDITSTOCUSTOMERS', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CreditsToCustomers = '+sTempValue;
    if ckGST.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_GST then begin
        SetAuditData('GST', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_GST then begin
        SetAuditData('GST', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' GST = '+sTempValue;
    if ckGSTAdjustment.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_GSTAdjustment then begin
        SetAuditData('GSTADJUSTMENT', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_GSTAdjustment then begin
        SetAuditData('GSTADJUSTMENT', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' GSTAdjustment = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    if ckOrderNumber.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_OrderNumber then begin
        SetAuditData('ORDERNUMBER', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_OrderNumber then begin
        SetAuditData('ORDERNUMBER', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' OrderNumber = '+sTempValue;
    if ckRequisitionNumber.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_RequisitionNumber then begin
        SetAuditData('REQUISITIONNUMBER', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_RequisitionNumber then begin
        SetAuditData('REQUISITIONNUMBER', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' RequisitionNumber = '+sTempValue;
    if ckIssueDate.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_IssueDate then begin
        SetAuditData('ISSUEDATE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_IssueDate then begin
        SetAuditData('ISSUEDATE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' IssueDate = '+sTempValue;
    if ckRentDates.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_RentDates then begin
        SetAuditData('RENTDATES', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_RentDates then begin
        SetAuditData('RENTDATES', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' RentDates = '+sTempValue;
    if ckCallDates.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_CallDates then begin
        SetAuditData('CALLDATES', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_CallDates then begin
        SetAuditData('CALLDATES', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CallDates = '+sTempValue;
    if ckRounding.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_Rounding then begin
        SetAuditData('ROUNDING', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_Rounding then begin
        SetAuditData('ROUNDING', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' Rounding = '+sTempValue;
    if ckTenderNumber.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_TenderNumber then begin
        SetAuditData('TENDERNUMBER', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_TenderNumber then begin
        SetAuditData('TENDERNUMBER', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' TenderNumber = '+sTempValue;
    if ckMultiManual.Checked then begin
      sTempValue := '1';
      if lAudit and not Original_MultiManualEntry then begin
        SetAuditData('MULTIMANUALENTRY', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0';
      if lAudit and Original_MultiManualEntry then begin
        SetAuditData('MULTIMANUALENTRY', '1', '0', AuditString);
      end;
    end;
    sValue := sValue + ' MultiManualEntry = ' + sTempValue +',';
    if ckPrelimRevenue.Checked then begin
      sTempValue := '1';
      if lAudit and not Original_EarlyRevenue then begin
        SetAuditData('EARLYREVENUE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0';
      if lAudit and Original_EarlyRevenue then begin
        SetAuditData('EARLYREVENUE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue + ' EarlyRevenue = ' + sTempValue +',';
    if ckCritical01.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C1 then begin
        SetAuditData('CRITICALCHECK01', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C1 then begin
        SetAuditData('CRITICALCHECK01', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck01 = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    if ckCritical02.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C2 then begin
        SetAuditData('CRITICALCHECK02', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C2 then begin
        SetAuditData('CRITICALCHECK02', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck02 = '+sTempValue;
    if ckCritical03.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C3 then begin
        SetAuditData('CRITICALCHECK03', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C3 then begin
        SetAuditData('CRITICALCHECK03', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck03 = '+sTempValue;
    if ckCritical04.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C4 then begin
        SetAuditData('CRITICALCHECK04', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C4 then begin
        SetAuditData('CRITICALCHECK04', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck04 = '+sTempValue;
    if ckCritical05.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C5 then begin
        SetAuditData('CRITICALCHECK05', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C5 then begin
        SetAuditData('CRITICALCHECK05', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck05 = '+sTempValue;
    if ckCritical06.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C6 then begin
        SetAuditData('CRITICALCHECK06', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C6 then begin
        SetAuditData('CRITICALCHECK06', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck06 = '+sTempValue;
    if ckCritical07.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C7 then begin
        SetAuditData('CRITICALCHECK07', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C7 then begin
        SetAuditData('CRITICALCHECK07', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck07 = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    if ckCritical08.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C8 then begin
        SetAuditData('CRITICALCHECK08', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C8 then begin
        SetAuditData('CRITICALCHECK08', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck08 = '+sTempValue;
    if ckCritical09.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C9 then begin
        SetAuditData('CRITICALCHECK09', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C9 then begin
        SetAuditData('CRITICALCHECK09', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck09 = '+sTempValue;
    if ckCritical10.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C10 then begin
        SetAuditData('CRITICALCHECK10', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C10 then begin
        SetAuditData('CRITICALCHECK10', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck10 = '+sTempValue;
    if ckCritical11.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C11 then begin
        SetAuditData('CRITICALCHECK11', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C11 then begin
        SetAuditData('CRITICALCHECK11', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck11 = '+sTempValue;
    if ckCritical12.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C12 then begin
        SetAuditData('CRITICALCHECK12', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C12 then begin
        SetAuditData('CRITICALCHECK12', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck12 = '+sTempValue;
    if ckCritical13.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C13 then begin
        SetAuditData('CRITICALCHECK13', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C13 then begin
        SetAuditData('CRITICALCHECK13', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck13 = '+sTempValue;
    if ckCritical14.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C14 then begin
        SetAuditData('CRITICALCHECK14', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C14 then begin
        SetAuditData('CRITICALCHECK14', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck14 = '+sTempValue;
    if ckCritical15.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_C15 then begin
        SetAuditData('CRITICALCHECK15', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_C15 then begin
        SetAuditData('CRITICALCHECK15', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' CriticalCheck15 = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    if ckDubious01.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D1 then begin
        SetAuditData('DUBIOUSCHECK01', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D1 then begin
        SetAuditData('DUBIOUSCHECK01', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck01 = '+sTempValue;
    if ckDubious02.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D2 then begin
        SetAuditData('DUBIOUSCHECK02', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D2 then begin
        SetAuditData('DUBIOUSCHECK02', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck02 = '+sTempValue;
    if ckDubious03.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D3 then begin
        SetAuditData('DUBIOUSCHECK03', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D3 then begin
        SetAuditData('DUBIOUSCHECK03', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck03 = '+sTempValue;
    if ckDubious04.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D4 then begin
        SetAuditData('DUBIOUSCHECK04', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D4 then begin
        SetAuditData('DUBIOUSCHECK04', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck04 = '+sTempValue;
    if ckDubious05.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D5 then begin
        SetAuditData('DUBIOUSCHECK05', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D5 then begin
        SetAuditData('DUBIOUSCHECK05', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck05 = '+sTempValue;
    if ckDubious06.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D6 then begin
        SetAuditData('DUBIOUSCHECK06', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D6 then begin
        SetAuditData('DUBIOUSCHECK06', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck06 = '+sTempValue;
    if ckDubious07.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D7 then begin
        SetAuditData('DUBIOUSCHECK07', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D7 then begin
        SetAuditData('DUBIOUSCHECK07', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck07 = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    if ckDubious08.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D8 then begin
        SetAuditData('DUBIOUSCHECK08', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D8 then begin
        SetAuditData('DUBIOUSCHECK08', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck08 = '+sTempValue;
    if ckDubious09.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D9 then begin
        SetAuditData('DUBIOUSCHECK09', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D9 then begin
        SetAuditData('DUBIOUSCHECK09', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck09 = '+sTempValue;
    if ckDubious10.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D10 then begin
        SetAuditData('DUBIOUSCHECK10', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D10 then begin
        SetAuditData('DUBIOUSCHECK10', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck10 = '+sTempValue;
    if ckDubious11.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D11 then begin
        SetAuditData('DUBIOUSCHECK11', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D11 then begin
        SetAuditData('DUBIOUSCHECK11', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck11 = '+sTempValue;
    if ckDubious12.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D12 then begin
        SetAuditData('DUBIOUSCHECK12', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D12 then begin
        SetAuditData('DUBIOUSCHECK12', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck12 = '+sTempValue;
    if ckDubious13.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D13 then begin
        SetAuditData('DUBIOUSCHECK13', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D13 then begin
        SetAuditData('DUBIOUSCHECK13', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck13 = '+sTempValue;
    if ckDubious14.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D14 then begin
        SetAuditData('DUBIOUSCHECK14', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D14 then begin
        SetAuditData('DUBIOUSCHECK14', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck14 = '+sTempValue;
    if ckDubious15.Checked then begin
      sTempValue := '1,';
      if lAudit and  not Original_D15 then begin
        SetAuditData('DUBIOUSCHECK15', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_D15 then begin
        SetAuditData('DUBIOUSCHECK15', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' DubiousCheck15 = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := IntToStr(ProgramID);
    if (Length(sTempValue) = 0) then begin
      sTempValue := 'NULL';
    end
    else begin
      ProveWholeInteger(sTempValue, lChanged);
      if lChanged then sTempValue := 'NULL';
    end;
    sValue := sValue +' ProgramID = '+sTempValue+',';
    if lAudit and ((sTempValue <> Original_ProgramID) or
      ((Original_ProgramID = '0') and (sTempValue = 'NULL'))) then begin
      SetAuditData('PROGRAMID', Original_ProgramID, sTempValue, AuditString);
    end;
    sTempValue := AccountNoName;
    if (Length(sTempValue) = 0) then sValue := sValue +' AccountNoName = NULL,'
    else sValue := sValue +' AccountNoName = '''+sTempValue+''',';
    if lAudit and (sTempValue <> Original_AccountNoName) then begin
      SetAuditData('ACCOUNTNONAME', Original_AccountNoName, sTempValue,
        AuditString);
    end;
    sTempValue := InvoiceNoName;
    if (Length(sTempValue) = 0) then sValue := sValue +' InvoiceNoName = NULL,'
    else sValue := sValue +' InvoiceNoName = '''+sTempValue+''',';
    if lAudit and (sTempValue <> Original_InvoiceNoName) then begin
      SetAuditData('INVOICENONAME', Original_InvoiceNoName, sTempValue,
        AuditString);
    end;
    sTempValue := TotalRevenueName;
    if (Length(sTempValue) = 0) then sValue := sValue +' TotalRevenueName = NULL,'
    else sValue := sValue +' TotalRevenueName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_TotalRevenueName) then begin
      SetAuditData('TOTALREVENUENAME', Original_TotalRevenueName, sTempValue,
        AuditString);
    end;
    sTempValue := TotalPayableName;
    if (Length(sTempValue) = 0) then sValue := sValue +' TotalPayableName = NULL,'
    else sValue := sValue +' TotalPayableName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_TotalPayableName) then begin
      SetAuditData('TOTALPAYABLENAME', Original_TotalPayableName, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := TotalCreditsName;
    if (Length(sTempValue) = 0) then sValue := sValue +' TotalCreditsName = NULL,'
    else sValue := sValue +' TotalCreditsName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_TotalCreditsName) then begin
      SetAuditData('TOTALCREDITSNAME', Original_TotalCreditsName, sTempValue,
        AuditString);
    end;
    sTempValue := OpeningBalanceName;
    if (Length(sTempValue) = 0) then sValue := sValue +' OpeningBalanceName = NULL,'
    else sValue := sValue +' OpeningBalanceName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_OpeningBalanceName) then begin
      SetAuditData('OPENINGBALANCENAME', Original_OpeningBalanceName, sTempValue,
        AuditString);
    end;
    sTempValue := PaymentsReceivedName;
    if (Length(sTempValue) = 0) then sValue := sValue +' PaymentsReceivedName = NULL,'
    else sValue := sValue +' PaymentsReceivedName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_PaymentsReceivedName) then begin
      SetAuditData('PAYMENTSRECEIVEDNAME', Original_PaymentsReceivedName, sTempValue,
        AuditString);
    end;
    sTempValue := TotalAdjustmentsName;
    if (Length(sTempValue) = 0) then sValue := sValue +' TotalAdjustmentsName = NULL,'
    else sValue := sValue +' TotalAdjustmentsName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_TotalAdjustmentsName) then begin
      SetAuditData('TOTALADJUSTMENTSNAME', Original_TotalAdjustmentsName, sTempValue,
        AuditString);
    end;
    sTempValue := BatchStartName;
    if (Length(sTempValue) = 0) then sValue := sValue +' BatchStartName = NULL,'
    else sValue := sValue +' BatchStartName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_BatchStartName) then begin
      SetAuditData('BATCHSTARTNAME', Original_BatchStartName, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := BatchEndName;
    if (Length(sTempValue) = 0) then sValue := sValue +' BatchEndName = NULL,'
    else sValue := sValue +' BatchEndName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_BatchEndName) then begin
      SetAuditData('BATCHENDNAME', Original_BatchEndName, sTempValue,
        AuditString);
    end;
    sTempValue := PaymentDateName;
    if (Length(sTempValue) = 0) then sValue := sValue +' PaymentDateName = NULL,'
    else sValue := sValue +' PaymentDateName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_PaymentDateName) then begin
      SetAuditData('PAYMENTDATENAME', Original_PaymentDateName, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := GSTName;
    if (Length(sTempValue) = 0) then sValue := sValue +' GSTName = NULL,'
    else sValue := sValue +' GSTName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_GSTName) then begin
      SetAuditData('GSTNAME', Original_GSTName, sTempValue,
        AuditString);
    end;
    sTempValue := GSTAdjustmentName;
    if (Length(sTempValue) = 0) then sValue := sValue +' GSTAdjustmentName = NULL,'
    else sValue := sValue +' GSTAdjustmentName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_GSTAdjustmentName) then begin
      SetAuditData('GSTADJUSTMENTNAME', Original_GSTAdjustmentName, sTempValue,
        AuditString);
    end;
    sTempValue := OrderNumberName;
    if (Length(sTempValue) = 0) then sValue := sValue +' OrderNumberName = NULL,'
    else sValue := sValue +' OrderNumberName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_OrderNumberName) then begin
      SetAuditData('ORDERNUMBERNAME', Original_OrderNumberName, sTempValue,
        AuditString);
    end;
    sTempValue := RequisitionNumberName;
    if (Length(sTempValue) = 0) then sValue := sValue +' RequisitionNumberName = NULL,'
    else sValue := sValue +' RequisitionNumberName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_RequisitionNumberName) then begin
      SetAuditData('REQUISITIONNUMBERNAME', Original_RequisitionNumberName, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := IssueDateName;
    if (Length(sTempValue) = 0) then sValue := sValue +' IssueDateName = NULL,'
    else sValue := sValue +' IssueDateName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_IssueDateName) then begin
      SetAuditData('ISSUEDATENAME', Original_IssueDateName, sTempValue,
        AuditString);
    end;
    sTempValue := RoundingName;
    if (Length(sTempValue) = 0) then sValue := sValue +' RoundingName = NULL,'
    else sValue := sValue +' RoundingName = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_RoundingName) then begin
      SetAuditData('ROUNDINGNAME', Original_RoundingName, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := Trim(edtVar01.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var01Description = NULL,'
    else sValue := sValue +' Var01Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var01) then begin
      SetAuditData('VAR01DESCRIPTION', Original_Var01, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar02.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var02Description = NULL,'
    else sValue := sValue +' Var02Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var02) then begin
      SetAuditData('VAR02DESCRIPTION', Original_Var02, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar03.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var03Description = NULL,'
    else sValue := sValue +' Var03Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var03) then begin
      SetAuditData('VAR03DESCRIPTION', Original_Var03, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar04.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var04Description = NULL,'
    else sValue := sValue +' Var04Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var04) then begin
      SetAuditData('VAR04DESCRIPTION', Original_Var04, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := Trim(edtVar05.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var05Description = NULL,'
    else sValue := sValue +' Var05Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var05) then begin
      SetAuditData('VAR05DESCRIPTION', Original_Var05, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar06.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var06Description = NULL,'
    else sValue := sValue +' Var06Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var06) then begin
      SetAuditData('VAR06DESCRIPTION', Original_Var06, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar07.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var07Description = NULL,'
    else sValue := sValue +' Var07Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var07) then begin
      SetAuditData('VAR07DESCRIPTION', Original_Var07, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar08.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var08Description = NULL,'
    else sValue := sValue +' Var08Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var08) then begin
      SetAuditData('VAR08DESCRIPTION', Original_Var08, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := Trim(edtVar09.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var09Description = NULL,'
    else sValue := sValue +' Var09Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var09) then begin
      SetAuditData('VAR09DESCRIPTION', Original_Var09, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar10.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var10Description = NULL,'
    else sValue := sValue +' Var10Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var10) then begin
      SetAuditData('VAR10DESCRIPTION', Original_Var10, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar11.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var11Description = NULL,'
    else sValue := sValue +' Var11Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var11) then begin
      SetAuditData('VAR11DESCRIPTION', Original_Var11, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar12.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var12Description = NULL,'
    else sValue := sValue +' Var12Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var12) then begin
      SetAuditData('VAR12DESCRIPTION', Original_Var12, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';
    
    sTempValue := Trim(edtVar13.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var13Description = NULL,'
    else sValue := sValue +' Var13Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var13) then begin
      SetAuditData('VAR13DESCRIPTION', Original_Var13, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar14.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var14Description = NULL,'
    else sValue := sValue +' Var14Description = '''+sTempValue+''',';
    if lAudit and  (sTempValue <> Original_Var14) then begin
      SetAuditData('VAR14DESCRIPTION', Original_Var14, sTempValue,
        AuditString);
    end;
    sTempValue := Trim(edtVar15.Text);
    if (Length(sTempValue) = 0) then sValue := sValue +' Var15Description = NULL'
    else sValue := sValue +' Var15Description = '''+sTempValue+'''';
    if lAudit and  (sTempValue <> Original_Var15) then begin
      SetAuditData('VAR15DESCRIPTION', Original_Var15, sTempValue,
        AuditString);
    end;
    AmendString.Add(sValue);
    sValue := '';

    AmendString.Add('WHERE id = '+ Trim(edtID.Text));
{
    // Make sure something has changed.
    if lAudit and (Length(AuditTrailDesc) = 0) then begin
      lAudit := False;
    end;  // lAudit.
}
  end;  // if lAppend then begin..else.
{
// Start Test.
SaveText(AmendString.Text);
// End Test.
}
  qBatchType.Close;
  qBatchType.SQL := AmendString;
  qBatchType.ExecSQL;
  if lAudit then begin
    if lAppend then begin
      // Get and store the new ID for this table.
      with qBatchType do begin
        SQL.Clear;
        SQL.Add('SELECT ID');
        SQL.ADD('FROM tBatchType');
        SQL.Add('WHERE Description LIKE '''+ Description +'''');
        SQL.Add('AND Active = 1');
        Open;
        SetAuditID(FieldByName('ID').AsString, sAuditValue);
        Close;
      end;
    end;  // lAppend.
    SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
{
  if lAudit and (Length(AuditTrailDesc) > 0) then begin
    sAuditField := sAuditField +',Description)';
    sAuditValue := sAuditValue +',';
    AuditTrailDesc := Copy(AuditTrailDesc,2,Length(AuditTrailDesc)-1);
    AuditTrailDesc := ''''+AuditTrailDesc+''')';
    AuditString.Add(sAuditField);
    AuditString.Add(sAuditValue);
    AuditString.Add(AuditTrailDesc);
    qBatchType.SQL := AuditString;
    qBatchType.ExecSQL;
}
  end;
  AmendString.Free;
  AuditString.Free;
  ModalResult := mrOk;
end;  // btnOkClick.

end.
