unit SysEditTariff;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, dbtables;

type
  TSysEditTariffForm = class(TForm)
    edtID: TEdit;
    lblID: TLabel;
    lblAgreementID: TLabel;
    lblSupplierServiceCode: TLabel;
    edtFixedCharge: TEdit;
    lblFixedCharge: TLabel;
    edtFlagfall: TEdit;
    lblFlagfall: TLabel;
    edtMinCharge: TEdit;
    edtMinDuration: TEdit;
    lblMinimum: TLabel;
    edtMaxDuration: TEdit;
    lblMaximum: TLabel;
    edtMaxCharge: TEdit;
    edtStage1Duration: TEdit;
    lblStage1: TLabel;
    edtStage1Charge: TEdit;
    edtStage2Duration: TEdit;
    lblStage2: TLabel;
    edtStage2Charge: TEdit;
    edtStage3Duration: TEdit;
    lblStage3: TLabel;
    edtStage3Charge: TEdit;
    edtStage4Duration: TEdit;
    lblStage4: TLabel;
    edtStage4Charge: TEdit;
    edtStage5Duration: TEdit;
    lblStage5: TLabel;
    edtStage5Charge: TEdit;
    ckSurcharge: TCheckBox;
    edtSurcharge: TEdit;
    ckDiscount: TCheckBox;
    edtDiscount: TEdit;
    ckChargePeriod: TCheckBox;
    btnOk: TButton;
    btnCancel: TButton;
    lblDuration: TLabel;
    lblCharge: TLabel;
    cbAgreement: TComboBox;
    cbSupplierServiceCode: TComboBox;
    lblChargeIntervalSecs: TLabel;
    edtChargeIntervalSecs: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
    AmendString : TStringList;
    AuditString : TStringlist;
    slAgreementIndex : TStringList;
    slSupplierServiceCodeIndex : TStringList;
    sUserName : string;
    lAppend : boolean;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    Original_ID                    : string;
    Original_AgreementID           : string;
    Original_SupplierServiceCodeID : string;
    Original_FixedCharge           : string;
    Original_FlagFall              : string;
    Original_ChargeIntervalSecs    : string;
    Original_MinDuration           : string;
    Original_MinCharge             : string;
    Original_MaxDuration           : string;
    Original_MaxCharge             : string;
    Original_Stage1Duration        : string;
    Original_Stage1Charge          : string;
    Original_Stage2Duration        : string;
    Original_Stage2Charge          : string;
    Original_Stage3Duration        : string;
    Original_Stage3Charge          : string;
    Original_Stage4Duration        : string;
    Original_Stage4Charge          : string;
    Original_Stage5Duration        : string;
    Original_Stage5Charge          : string;
    Original_Surcharge             : string;
    Original_Discount              : string;
    Original_CheckSurcharge        : boolean;
    Original_CheckDiscount         : boolean;
    Original_CheckChargePeriod     : boolean;
  protected
    procedure SetAppend(const Value: boolean);
    procedure SetID(const Value: integer);
    function GetID: integer;
    procedure SetAgreementID(const Value: integer);
    function GetAgreementID: integer;
    procedure SetSupplierServiceCodeID(const Value: integer);
    function GetSupplierServiceCodeID: integer;
    procedure SetFixedCharge(const Value: Currency);
    function GetFixedCharge: Currency;
    procedure SetFlagFall(const Value: Currency);
    function GetFlagFall: Currency;
    procedure SetChargeIntervalSecs(const Value: integer);
    function GetChargeIntervalSecs: integer;
    procedure SetMinDuration(const Value: integer);
    function GetMinDuration: integer;
    procedure SetMinCharge(const Value: Currency);
    function GetMinCharge: Currency;
    procedure SetMaxDuration(const Value: integer);
    function GetMaxDuration: integer;
    procedure SetMaxCharge(const Value: Currency);
    function GetMaxCharge: Currency;
    procedure SetStage1Duration(const Value: integer);
    function GetStage1Duration: integer;
    procedure SetStage1Charge(const Value: Currency);
    function GetStage1Charge: Currency;
    procedure SetStage2Duration(const Value: integer);
    function GetStage2Duration: integer;
    procedure SetStage2Charge(const Value: Currency);
    function GetStage2Charge: Currency;
    procedure SetStage3Duration(const Value: integer);
    function GetStage3Duration: integer;
    procedure SetStage3Charge(const Value: Currency);
    function GetStage3Charge: Currency;
    procedure SetStage4Duration(const Value: integer);
    function GetStage4Duration: integer;
    procedure SetStage4Charge(const Value: Currency);
    function GetStage4Charge: Currency;
    procedure SetStage5Duration(const Value: integer);
    function GetStage5Duration: integer;
    procedure SetStage5Charge(const Value: Currency);
    function GetStage5Charge: Currency;
    procedure SetCheckSurcharge(Value: boolean);
    function GetCheckSurcharge: boolean;
    procedure SetCheckDiscount(Value: boolean);
    function GetCheckDiscount: boolean;
    procedure SetCheckChargePeriod(Value: boolean);
    function GetCheckChargePeriod: boolean;
    procedure SetSurcharge(const Value: Currency);
    function GetSurcharge: Currency;
    procedure SetDiscount(const Value: Currency);
    function GetDiscount: Currency;
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property ID: integer read GetID write SetID;
    property AgreementID: integer read GetAgreementID write SetAgreementID;
    property SupplierServiceCodeID: integer read GetSupplierServiceCodeID
      write SetSupplierServiceCodeID;
    property FixedCharge: Currency read GetFixedCharge write SetFixedCharge;
    property FlagFall: Currency read GetFlagFall write SetFlagFall;
    property ChargeIntervalSecs: integer read GetChargeIntervalSecs write SetChargeIntervalSecs;
    property MinDuration: integer read GetMinDuration write SetMinDuration;
    property MinCharge: Currency read GetMinCharge write SetMinCharge;
    property MaxDuration: integer read GetMaxDuration write SetMaxDuration;
    property MaxCharge: Currency read GetMaxCharge write SetMaxCharge;
    property Stage1Duration: integer read GetStage1Duration write SetStage1Duration;
    property Stage1Charge: Currency read GetStage1Charge write SetStage1Charge;
    property Stage2Duration: integer read GetStage2Duration write SetStage2Duration;
    property Stage2Charge: Currency read GetStage2Charge write SetStage2Charge;
    property Stage3Duration: integer read GetStage3Duration write SetStage3Duration;
    property Stage3Charge: Currency read GetStage3Charge write SetStage3Charge;
    property Stage4Duration: integer read GetStage4Duration write SetStage4Duration;
    property Stage4Charge: Currency read GetStage4Charge write SetStage4Charge;
    property Stage5Duration: integer read GetStage5Duration write SetStage5Duration;
    property Stage5Charge: Currency read GetStage5Charge write SetStage5Charge;
    property CheckSurcharge: boolean read GetCheckSurcharge write SetCheckSurcharge;
    property CheckDiscount: boolean read GetCheckDiscount write SetCheckDiscount;
    property CheckChargePeriod: boolean read GetCheckChargePeriod write SetCheckChargePeriod;
    property Surcharge: Currency read GetSurcharge write SetSurcharge;
    property Discount: Currency read GetDiscount write SetDiscount;
  public
    { Public declarations }
  end;

var
  SysEditTariffForm: TSysEditTariffForm;

implementation

uses
  GenFns, PPSysMain;

{$R *.DFM}

procedure TSysEditTariffForm.FormCreate(Sender: TObject);
var
  qFormCreate : TQuery;
  ActionDescription : string;
begin
  lAppend := False;
  AmendString := TStringList.Create;
  AuditString := TStringList.Create;
  Original_ID                    := '';
  Original_AgreementID           := '';
  Original_SupplierServiceCodeID := '';
  Original_FixedCharge           := CurrToStr(0.00);
  Original_FlagFall              := CurrToStr(0.00);
  Original_ChargeIntervalSecs    := '';
  Original_MinDuration           := '';
  Original_MinCharge             := CurrToStr(0.00);
  Original_MaxDuration           := '';
  Original_MaxCharge             := CurrToStr(0.00);
  Original_Stage1Duration        := '';
  Original_Stage1Charge          := CurrToStr(0.00);
  Original_Stage2Duration        := '';
  Original_Stage2Charge          := CurrToStr(0.00);
  Original_Stage3Duration        := '';
  Original_Stage3Charge          := CurrToStr(0.00);
  Original_Stage4Duration        := '';
  Original_Stage4Charge          := CurrToStr(0.00);
  Original_Stage5Duration        := '';
  Original_Stage5Charge          := CurrToStr(0.00);
  Original_CheckSurcharge        := False;
  Original_CheckDiscount         := False;
  Original_CheckChargePeriod     := False;
  Original_Surcharge             := CurrToStr(0.00);
  Original_Discount              := CurrToStr(0.00);
  sUserName := Trim(MainForm.OPERATORNAME);
  qFormCreate := TQuery.Create(SELF);
  with qFormCreate do begin
    DatabaseName := 'dbPPdata';
    // Read the audit event IDs.
    SQL.Add('SELECT *');
    SQL.Add('FROM tEvent');
    SQL.Add('WHERE Description LIKE ''Reference%''');
    Open;
    while not Eof do begin
      ActionDescription := UpperCase(FieldByName('Description').AsString);
      if (Pos('UPDATE', ActionDescription) > 0) then
        AuditActionUpdate := FieldByName('id').AsString
      else if (Pos('DELETE', ActionDescription) > 0) then
        AuditActionDelete := FieldByName('id').AsString
      else if (Pos('INSERT', ActionDescription) > 0) then
        AuditActionInsert := FieldByName('id').AsString;
      Next;
    end;  // while not Eof.
    Close;
    SQL.Clear;
    // Create a list of Billing Periods and set the default to the most recent.
    slAgreementIndex := TStringList.Create;
    slSupplierServiceCodeIndex := TStringList.Create;
    Close;
    SQL.Clear;                                         // AgreementID..
    SQL.Add('SELECT tAgreement.ID,');
    SQL.Add(' ((CASE tAgreement.AgreementNo');
    SQL.Add('  WHEN NULL THEN ''''');
    SQL.Add('  WHEN '''' THEN ''''');
    SQL.Add('  ELSE tAgreement.AgreementNo + ''- ''');
    SQL.Add('  END) + tAgreement.Description) AS "Description"');
    SQL.Add('FROM tAgreement');
    SQL.Add('WHERE tAgreement.Active = 1');
    SQL.Add('ORDER BY tAgreement.AgreementNo');
    Open;
    while not Eof do begin
      cbAgreement.Items.Add(FieldByName('Description').AsString);
      slAgreementIndex.Add(IntToStr(FieldByName('ID').AsInteger));
      Next;
    end;
    Close;
    SQL.Clear;                                         // SupplierServiceCodeID..
    SQL.Add('SELECT tSupplierServiceCode.ID,');
    SQL.Add(' (tSupplierServiceCode.code  + ''- ''+');
    SQL.Add('  tSupplierServiceCode.AmountCategory + ''- ''+');
    SQL.Add('  tSupplierServiceCode.Description) AS "SupplierServiceCode"');
    SQL.Add('FROM tSupplierServiceCode');
    SQL.Add('WHERE tSupplierServiceCode.Active = 1');
    SQL.Add('ORDER BY tSupplierServiceCode.Code');
    Open;
    while not Eof do begin
      cbSupplierServiceCode.Items.Add(FieldByName('SupplierServiceCode').AsString);
      slSupplierServiceCodeIndex.Add(IntToStr(FieldByName('ID').AsInteger));
      Next;
    end;
    Close;
  end;  // with qformCreate.
  qFormCreate.Close;
  qFormCreate.Free;
  // Three tables are involved. Auditing any one will ensure Auditing for all. 
  lAudit := TestForAudit('tAgreement');
  if not lAudit then lAudit := TestForAudit('tAgreementType');
  if not lAudit then lAudit := TestForAudit('tAgreementTariffs');
end;  // FormCreate.

procedure TSysEditTariffForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  AmendString.Free;
  slAgreementIndex.Free;
  slSupplierServiceCodeIndex.Free;
end;

procedure TSysEditTariffForm.SetAppend(const Value: boolean);
begin
  lAppend := Value;
  if lAppend then begin
    Caption := Caption + ' (ADD)';
  end  // if lAppend then begin.
  else begin
    Caption := Caption + ' (EDIT)';
  end;  // if lAppend then begin..else.
end;  // SetAppend.

procedure TSysEditTariffForm.SetID(const Value: integer);
begin
  if (Value = 0) then Original_ID := ''
  else                Original_ID := IntToStr(Value);
  edtID.Text := Original_ID;
end;  // SetID.

function TSysEditTariffForm.GetID: integer;
begin
  if (Length(Trim(edtID.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtID.Text));
end;  // GetID.

procedure TSysEditTariffForm.SetAgreementID(const Value: integer);
var
  sSelected : string;
  iCount : integer;
begin
  if (Value > 0) then begin
    sSelected := IntToStr(Value);
    for iCount := 0 to slAgreementIndex.Count - 1 do begin
      if (slAgreementIndex[iCount] = sSelected) then begin
        cbAgreement.ItemIndex := iCount;
        Original_AgreementID := sSelected;
        break;
      end;
    end;
  end;
end;  // SetAgreementID.

function TSysEditTariffForm.GetAgreementID: integer;
var
  nSelected : integer;
begin
  nSelected := cbAgreement.ItemIndex;
  if (nSelected < 0) or (Length(Trim(cbAgreement.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(slAgreementIndex[nSelected]);
end;  // GetAgreementID.

procedure TSysEditTariffForm.SetSupplierServiceCodeID(const Value: integer);
var
  sSelected : string;
  iCount : integer;
begin
  if (Value > 0) then begin
    sSelected := IntToStr(Value);
    for iCount := 0 to slSupplierServiceCodeIndex.Count - 1 do begin
      if (slSupplierServiceCodeIndex[iCount] = sSelected) then begin
        cbSupplierServiceCode.ItemIndex := iCount;
        Original_SupplierServiceCodeID := sSelected;
        break;
      end;
    end;
  end;
end;  // SetSupplierServiceCodeID.

function TSysEditTariffForm.GetSupplierServiceCodeID: integer;
var
  nSelected : integer;
begin
  nSelected := cbSupplierServiceCode.ItemIndex;
  if (nSelected < 0) or (Length(Trim(cbSupplierServiceCode.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(slSupplierServiceCodeIndex[nSelected]);
end;  // GetSupplierServiceCodeID.

procedure TSysEditTariffForm.SetFixedCharge(const Value: Currency);
begin
  Original_FixedCharge := CurrToStr(Value);
  edtFixedCharge.Text := Original_FixedCharge;
end;  // SetFixedCharge.

function TSysEditTariffForm.GetFixedCharge: Currency;
begin
  if (Length(Trim(edtFixedCharge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtFixedCharge.Text);
end;  // GetFixedCharge.

procedure TSysEditTariffForm.SetFlagFall(const Value: Currency);
begin
  Original_FlagFall := CurrToStr(Value);
  edtFlagFall.Text := Original_FlagFall;
end;  // SetFlagFall.

function TSysEditTariffForm.GetFlagFall: Currency;
begin
  if (Length(Trim(edtFlagFall.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtFlagFall.Text);
end;  // GetFlagFall.

procedure TSysEditTariffForm.SetChargeIntervalSecs(const Value: integer);
begin
  Original_ChargeIntervalSecs := IntToStr(Value);
  edtMinDuration.Text := Original_ChargeIntervalSecs;
end;  // SetChargeIntervalSecs.

function TSysEditTariffForm.GetChargeIntervalSecs: integer;
begin
  if (Length(Trim(edtChargeIntervalSecs.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtChargeIntervalSecs.Text));
end;  // GetChargeIntervalSecs.

procedure TSysEditTariffForm.SetMinDuration(const Value: integer);
begin
  Original_MinDuration := IntToStr(Value);
  edtMinDuration.Text := Original_MinDuration;
end;  // SetMinDuration.

function TSysEditTariffForm.GetMinDuration: integer;
begin
  if (Length(Trim(edtMinDuration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtMinDuration.Text));
end;  // GetMinDuration.

procedure TSysEditTariffForm.SetMinCharge(const Value: Currency);
begin
  Original_MinCharge := CurrToStr(Value);
  edtMinCharge.Text := Original_MinCharge;
end;  // SetMinCharge.

function TSysEditTariffForm.GetMinCharge: Currency;
begin
  if (Length(Trim(edtMinCharge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtMinCharge.Text);
end;  // GetMinCharge.

procedure TSysEditTariffForm.SetMaxDuration(const Value: integer);
begin
  Original_MaxDuration := IntToStr(Value);
  edtMaxDuration.Text := Original_MaxDuration;
end;  // SetMaxDuration.

function TSysEditTariffForm.GetMaxDuration: integer;
begin
  if (Length(Trim(edtMaxDuration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtMaxDuration.Text));
end;  // GetMaxDuration.

procedure TSysEditTariffForm.SetMaxCharge(const Value: Currency);
begin
  Original_MaxCharge := CurrToStr(Value);
  edtMaxCharge.Text := Original_MaxCharge;
end;  // SetMinCharge.

function TSysEditTariffForm.GetMaxCharge: Currency;
begin
  if (Length(Trim(edtMaxCharge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtMaxCharge.Text);
end;  // GetMaxCharge.

procedure TSysEditTariffForm.SetStage1Duration(const Value: integer);
begin
  Original_Stage1Duration := IntToStr(Value);
  edtStage1Duration.Text := Original_Stage1Duration;
end;  // SetStage1Duration.

function TSysEditTariffForm.GetStage1Duration: integer;
begin
  if (Length(Trim(edtStage1Duration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtStage1Duration.Text));
end;  // GetStage1Duration.

procedure TSysEditTariffForm.SetStage1Charge(const Value: Currency);
begin
  Original_Stage1Charge := CurrToStr(Value);
  edtStage1Charge.Text := Original_Stage1Charge;
end;  // SetStage1Charge.

function TSysEditTariffForm.GetStage1Charge: Currency;
begin
  if (Length(Trim(edtStage1Charge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtStage1Charge.Text);
end;  // GetStage1Charge.

procedure TSysEditTariffForm.SetStage2Duration(const Value: integer);
begin
  Original_Stage2Duration := IntToStr(Value);
  edtStage2Duration.Text := Original_Stage2Duration;
end;  // SetStage2Duration.

function TSysEditTariffForm.GetStage2Duration: integer;
begin
  if (Length(Trim(edtStage2Duration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtStage2Duration.Text));
end;  // GetStage2Duration.

procedure TSysEditTariffForm.SetStage2Charge(const Value: Currency);
begin
  Original_Stage2Charge := CurrToStr(Value);
  edtStage2Charge.Text := Original_Stage2Charge;
end;  // SetStage2Charge.

function TSysEditTariffForm.GetStage2Charge: Currency;
begin
  if (Length(Trim(edtStage2Charge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtStage2Charge.Text);
end;  // GetStage2Charge.

procedure TSysEditTariffForm.SetStage3Duration(const Value: integer);
begin
  Original_Stage3Duration := IntToStr(Value);
  edtStage3Duration.Text := Original_Stage3Duration;
end;  // SetStage3Duration.

function TSysEditTariffForm.GetStage3Duration: integer;
begin
  if (Length(Trim(edtStage3Duration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtStage3Duration.Text));
end;  // GetStage3Duration.

procedure TSysEditTariffForm.SetStage3Charge(const Value: Currency);
begin
  Original_Stage3Charge := CurrToStr(Value);
  edtStage3Charge.Text := Original_Stage3Charge;
end;  // SetStage3Charge.

function TSysEditTariffForm.GetStage3Charge: Currency;
begin
  if (Length(Trim(edtStage3Charge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtStage3Charge.Text);
end;  // GetStage3Charge.

procedure TSysEditTariffForm.SetStage4Duration(const Value: integer);
begin
  Original_Stage4Duration := IntToStr(Value);
  edtStage4Duration.Text := Original_Stage4Duration;
end;  // SetStage4Duration.

function TSysEditTariffForm.GetStage4Duration: integer;
begin
  if (Length(Trim(edtStage4Duration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtStage4Duration.Text));
end;  // GetStage3Duration.

procedure TSysEditTariffForm.SetStage4Charge(const Value: Currency);
begin
  Original_Stage4Charge := CurrToStr(Value);
  edtStage4Charge.Text := Original_Stage4Charge;
end;  // SetStage4Charge.

function TSysEditTariffForm.GetStage4Charge: Currency;
begin
  if (Length(Trim(edtStage4Charge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtStage4Charge.Text);
end;  // GetStage4Charge.

procedure TSysEditTariffForm.SetStage5Duration(const Value: integer);
begin
  Original_Stage5Duration := IntToStr(Value);
  edtStage5Duration.Text := Original_Stage5Duration;
end;  // SetStage5Duration.

function TSysEditTariffForm.GetStage5Duration: integer;
begin
  if (Length(Trim(edtStage5Duration.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(Trim(edtStage5Duration.Text));
end;  // GetStage5Duration.

procedure TSysEditTariffForm.SetStage5Charge(const Value: Currency);
begin
  Original_Stage5Charge := CurrToStr(Value);
  edtStage5Charge.Text := Original_Stage5Charge;
end;  // SetStage5Charge.

function TSysEditTariffForm.GetStage5Charge: Currency;
begin
  if (Length(Trim(edtStage5Charge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtStage5Charge.Text);
end;  // GetStage5Charge.

procedure TSysEditTariffForm.SetSurcharge(const Value: Currency);
begin
  Original_Surcharge := CurrToStr(Value);
  edtSurcharge.Text := Original_Surcharge;
end;  // SetSurcharge.

function TSysEditTariffForm.GetSurcharge: Currency;
begin
  if (Length(Trim(edtSurcharge.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtSurcharge.Text);
end;  // GetFlagFall.

procedure TSysEditTariffForm.SetDiscount(const Value: Currency);
begin
  Original_Discount := CurrToStr(Value);
  edtDiscount.Text := Original_Discount;
end;  // SetDiscount.

function TSysEditTariffForm.GetDiscount: Currency;
begin
  if (Length(Trim(edtDiscount.Text)) = 0) then
    Result := 0
  else
    Result := StrToCurr(edtDiscount.Text);
end;  // GetDiscount.

procedure TSysEditTariffForm.SetCheckSurcharge(Value: boolean);
begin
  Original_CheckSurcharge := Value;
  ckSurcharge.Checked := Original_CheckSurcharge;
end;  // SetCheckSurcharge.

function TSysEditTariffForm.GetCheckSurcharge: boolean;
begin
  Result := ckSurcharge.Checked;
end;  // SetCheckSurcharge.

procedure TSysEditTariffForm.SetCheckDiscount(Value: boolean);
begin
  Original_CheckDiscount := Value;
  ckDiscount.Checked := Original_CheckDiscount;
end;  // SetCheckDiscount.

function TSysEditTariffForm.GetCheckDiscount: boolean;
begin
  Result := ckDiscount.Checked;
end;  // GetCheckDiscount.

procedure TSysEditTariffForm.SetCheckChargePeriod(Value: boolean);
begin
  Original_CheckChargePeriod := Value;
  ckChargePeriod.Checked := Original_CheckChargePeriod;
end;  // SetCheckChargePeriod.

function TSysEditTariffForm.GetCheckChargePeriod: boolean;
begin
  Result := ckChargePeriod.Checked;
end;  // GetCheckChargePeriod.

procedure TSysEditTariffForm.btnOkClick(Sender: TObject);
var
  q: TQuery;
  sField : string;
  sValue : string;
  sAuditInsert : string;
  sAuditField : string;
  sAuditValue : string;
  AuditAction : string;
  lReturn : boolean;
  sStarted : string;
  nStarted : integer;
  sOriginal : string;          // Stores original value for when an ID=0;
  sError : string;
begin
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  q := TQuery.Create(SELF);
  q.DatabaseName := 'dbPPdata';
  lReturn := True;
  if (AgreementID = 0) or (SupplierServiceCodeID = 0) then begin
    sError := 'An Agreement and a SupplierServiceCode MUST be selected.';
    lReturn := False;
  end
  else begin
    if lAppend then begin
      sStarted := IntToStr(AgreementID);
      AmendString.Add('INSERT INTO tAgreementTariffs');
      sField := '(Active,AgreementID,';
      sValue := 'VALUES (1,'+ sStarted +',';
      if lAudit then begin
        SetAuditStart(sUserName, AuditAction, 'tAgreementTariffs',
          sAuditInsert, sAuditField, sAuditValue);
        SetAuditData('AGREEMENTID', '', sStarted, AuditString);
      end;  // lAudit.
      sStarted := IntToStr(SupplierServiceCodeID);
      sField := sField +'SupplierServiceCodeID,';
      sValue := sValue+ sStarted +',';
      if lAudit then begin
        SetAuditData('SUPPLIERSERVICECODEID', '', sStarted, AuditString);
      end;  // lAudit.
      if (FixedCharge <> 0) then begin
        sStarted := CurrToStr(FixedCharge);
        sField := sField + 'FixedCharge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('FIXEDCHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // FixedCharge.
      if (FlagFall <> 0) then begin
        sStarted := CurrToStr(FlagFall);
        sField := sField + 'FlagFall,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('FLAGFALL', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // FlagFall.
      if (ChargeIntervalSecs > 0) then begin
        sStarted := CurrToStr(ChargeIntervalSecs);
        sField := sField + 'ChargeIntervalSecs,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('CHARGEINTERVALSECS', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // ChargeIntervalSecs.
      if (MinDuration > 0) then begin
        sStarted := IntToStr(MinDuration);
        sField := sField + 'MinDuration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('MINDURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // MinDuration.
      if (MinCharge <> 0) then begin
        sStarted := CurrToStr(MinCharge);
        sField := sField + 'MinCharge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('MINCHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // MinCharge.
      if (MaxDuration > 0) then begin
        sStarted := IntToStr(MaxDuration);
        sField := sField + 'MaxDuration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('MAXDURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // MaxDuration.
      if (MaxCharge <> 0) then begin
        sStarted := CurrToStr(MaxCharge);
        sField := sField + 'MaxCharge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('MAXCHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // MaxCharge.
      if (Stage1Duration > 0) then begin
        sStarted := IntToStr(Stage1Duration);
        sField := sField + 'Stage1Duration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('STAGE1DURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage1Duration.
      if (Stage1Charge <> 0) then begin
        sStarted := CurrToStr(Stage1Charge);
        sField := sField + 'Stage1Charge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE1CHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage1Charge.
      if (Stage2Duration > 0) then begin
        sStarted := IntToStr(Stage2Duration);
        sField := sField + 'Stage2Duration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('STAGE2DURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage2Duration.
      if (Stage2Charge <> 0) then begin
        sStarted := CurrToStr(Stage2Charge);
        sField := sField + 'Stage2Charge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE2CHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage2Charge.
      if (Stage3Duration > 0) then begin
        sStarted := IntToStr(Stage3Duration);
        sField := sField + 'Stage3Duration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('STAGE3DURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage3Duration.
      if (Stage3Charge <> 0) then begin
        sStarted := CurrToStr(Stage3Charge);
        sField := sField + 'Stage3Charge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE3CHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage3Charge.
      if (Stage4Duration > 0) then begin
        sStarted := IntToStr(Stage4Duration);
        sField := sField + 'Stage4Duration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('STAGE4DURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage4Duration.
      if (Stage4Charge <> 0) then begin
        sStarted := CurrToStr(Stage4Charge);
        sField := sField + 'Stage4Charge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE4CHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage4Charge.
      if (Stage5Duration > 0) then begin
        sStarted := IntToStr(Stage5Duration);
        sField := sField + 'Stage5Duration,';
        sValue := sValue + sStarted +',';
        if lAudit then begin
          SetAuditData('STAGE5DURATION', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage5Duration.
      if (Stage5Charge <> 0) then begin
        sStarted := CurrToStr(Stage5Charge);
        sField := sField + 'Stage5Charge,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE5CHARGE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage5Charge.
      if (Surcharge > 0) then begin
        sStarted := CurrToStr(Surcharge);
        sField := sField + 'SurchargeRate,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('SURCHARGERATE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Surcharge.
      if (Discount <> 0) then begin
        sStarted := CurrToStr(Discount);
        sField := sField + 'DiscountRate,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('DISCOUNTRATE', '', sStarted, AuditString);
        end;  // lAudit.
      end;  // Discount.
      sField := sField + 'Surcharge,';
      if CheckSurcharge then begin
        sValue := sValue + '1,';
        if lAudit then begin
          SetAuditData('SURCHARGE', '', '1', AuditString);
        end;
      end
      else begin
        sValue := sValue + '0,';
        if lAudit then begin
          SetAuditData('SURCHARGE', '', '0', AuditString);
        end;
      end;  // CheckSurcharge.
      sField := sField + 'Discount,';
      if CheckDiscount then begin
        sValue := sValue + '1,';
        if lAudit then begin
          SetAuditData('DISCOUNT', '', '1', AuditString);
        end;
      end
      else begin
        sValue := sValue + '0,';
        if lAudit then begin
          SetAuditData('DISCOUNT', '', '0', AuditString);
        end;
      end;  // CheckDiscount.
      sField := sField + 'ChargePeriod,';
      if CheckChargePeriod then begin
        sValue := sValue + '1,';
        if lAudit then begin
          SetAuditData('CHARGEPERIOD', '', '1', AuditString);
        end;
      end
      else begin
        sValue := sValue + '0,';
        if lAudit then begin
          SetAuditData('CHARGEPERIOD', '', '0', AuditString);
        end;
      end;  // CheckChargePeriod.
      // Done - remove the last trailing comma.
      AmendString.Add(Copy(sField,1,Length(sField)-1)+')');
      AmendString.Add(Copy(sValue,1,Length(sValue)-1)+')');
    end
    else begin                  ///////////////  UPDATE  ////////////////////
      sStarted := IntToStr(AgreementID);
      AmendString.Add('UPDATE tAgreementTariffs');
      AmendString.Add('SET AgreementID = '+ sStarted +',');
      if lAudit then begin
        SetAuditStart(sUserName, AuditAction, 'tAgreementTariffs',
          sAuditInsert, sAuditField, sAuditValue);
        SetAuditID(IntToStr(ID), sAuditValue);
        if (sStarted <> Original_AgreementID) then begin
          SetAuditData('AGREEMENTID', Original_AgreementID, sStarted, AuditString);
        end;
      end;  // lAudit.
      sStarted := IntToStr(SupplierServiceCodeID);
      if (sStarted <> Original_SupplierServiceCodeID) then begin
        sValue := 'SupplierServiceCodeID = ';
        if (SupplierServiceCodeID = 0) then
             sValue := sValue +sStarted+','
        else sValue := sValue + 'NULL,';
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('SUPPLIERSERVICECODEID', Original_SupplierServiceCodeID,
            sStarted, AuditString);
        end;
      end;  // changed.
      sStarted := CurrToStr(FixedCharge);
      if (sStarted <> Original_FixedCharge) then begin
        AmendString.Add('FixedCharge = '+sStarted+',');
        if lAudit then begin
          SetAuditData('FIXEDCHARGE', Original_FixedCharge, sStarted,
            AuditString);
        end;
      end;  // changed.
      sStarted := CurrToStr(FlagFall);
      if (sStarted <> Original_FlagFall) then begin
        AmendString.Add('FlagFall = '+sStarted+',');
        if lAudit then begin
          SetAuditData('FLAGFALL', Original_FlagFall, sStarted,
            AuditString);
        end;
      end;  // changed.
      nStarted := ChargeIntervalSecs;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_ChargeIntervalSecs) then begin
        sOriginal := Original_ChargeIntervalSecs;         // Temp store value.
        sValue := 'ChargeIntervalSecs = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_ChargeIntervalSecs = '0') then begin
            Original_ChargeIntervalSecs := '';            // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                 // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('CHARGEINTERVALSECS', Original_ChargeIntervalSecs, sStarted,
            AuditString);
        end;  // lAudit.
        Original_ChargeIntervalSecs := sOriginal;         // Reinstates value.
      end;  // ChargeIntervalSecs.
      nStarted := MinDuration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_MinDuration) then begin
        sOriginal := Original_MinDuration;                // Temp store value.
        sValue := 'MinDuration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_MinDuration = '0') then begin
            Original_MinDuration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                 // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('MINDURATION', Original_MinDuration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_MinDuration := sOriginal;                // Reinstates value.
      end;  // MinDuration.
      sStarted := CurrToStr(MinCharge);
      if (sStarted <> Original_MinCharge) then begin
        AmendString.Add('MinCharge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('MINCHARGE', Original_MinCharge, sStarted, AuditString);
        end;  // lAudit.
      end;  // MinCharge.
      nStarted := MaxDuration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_MaxDuration) then begin
        sOriginal := Original_MaxDuration;                // Temp store value.
        sValue := 'MaxDuration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_MaxDuration = '0') then begin
            Original_MaxDuration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                 // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('MAXDURATION', Original_MaxDuration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_MaxDuration := sOriginal;                // Reinstates value.
      end;  // MaxDuration.
      sStarted := CurrToStr(MinCharge);
      if (sStarted <> Original_MaxCharge) then begin
        AmendString.Add('MaxCharge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('MAXCHARGE', Original_MaxCharge, sStarted, AuditString);
        end;  // lAudit.
      end;  // MaxCharge.
      nStarted := Stage1Duration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_Stage1Duration) then begin
        sOriginal := Original_Stage1Duration;                // Temp store value.
        sValue := 'Stage1Duration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_Stage1Duration = '0') then begin
            Original_Stage1Duration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                 // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('STAGE1DURATION', Original_Stage1Duration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_Stage1Duration := sOriginal;                // Reinstates value.
      end;  // Stage1Duration.
      sStarted := CurrToStr(Stage1Charge);
      if (sStarted <> Original_Stage1Charge) then begin
        AmendString.Add('Stage1Charge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE1CHARGE', Original_Stage1Charge, sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage1Charge.
      nStarted := Stage2Duration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_Stage2Duration) then begin
        sOriginal := Original_Stage2Duration;                // Temp store value.
        sValue := 'Stage2Duration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_Stage2Duration = '0') then begin
            Original_Stage2Duration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                    // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('STAGE2DURATION', Original_Stage2Duration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_Stage2Duration := sOriginal;                // Reinstates value.
      end;  // Stage2Duration.
      sStarted := CurrToStr(Stage2Charge);
      if (sStarted <> Original_Stage2Charge) then begin
        AmendString.Add('Stage2Charge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE2CHARGE', Original_Stage2Charge, sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage2Charge.
      nStarted := Stage3Duration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_Stage3Duration) then begin
        sOriginal := Original_Stage3Duration;                // Temp store value.
        sValue := 'Stage3Duration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_Stage3Duration = '0') then begin
            Original_Stage3Duration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                    // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('STAGE3DURATION', Original_Stage3Duration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_Stage3Duration := sOriginal;                // Reinstates value.
      end;  // Stage3Duration.
      sStarted := CurrToStr(Stage3Charge);
      if (sStarted <> Original_Stage3Charge) then begin
        AmendString.Add('Stage3Charge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE3CHARGE', Original_Stage3Charge, sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage3Charge.
      nStarted := Stage4Duration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_Stage4Duration) then begin
        sOriginal := Original_Stage4Duration;                // Temp store value.
        sValue := 'Stage4Duration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_Stage4Duration = '0') then begin
            Original_Stage4Duration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                    // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('STAGE4DURATION', Original_Stage4Duration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_Stage4Duration := sOriginal;                // Reinstates value.
      end;  // Stage4Duration.
      sStarted := CurrToStr(Stage4Charge);
      if (sStarted <> Original_Stage4Charge) then begin
        AmendString.Add('Stage4Charge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE4CHARGE', Original_Stage4Charge, sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage4Charge.
      nStarted := Stage5Duration;
      sStarted := IntToStr(nStarted);
      if (sStarted <> Original_Stage5Duration) then begin
        sOriginal := Original_Stage5Duration;                // Temp store value.
        sValue := 'Stage5Duration = ';
        if (nStarted > 0) then begin
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit and (Original_Stage5Duration = '0') then begin
            Original_Stage5Duration := '';                   // empty forces NULL.
          end;
        end
        else begin
          sValue := sValue + 'NULL,';
          sStarted := '';                                    // empty forces NULL.
        end;
        AmendString.Add(sValue);
        if lAudit then begin
          SetAuditData('STAGE5DURATION', Original_Stage5Duration, sStarted,
            AuditString);
        end;  // lAudit.
        Original_Stage5Duration := sOriginal;                // Reinstates value.
      end;  // Stage5Duration.
      sStarted := CurrToStr(Stage5Charge);
      if (sStarted <> Original_Stage5Charge) then begin
        AmendString.Add('Stage5Charge = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('STAGE5CHARGE', Original_Stage5Charge, sStarted, AuditString);
        end;  // lAudit.
      end;  // Stage5Charge.
      sStarted := CurrToStr(Surcharge);
      if (sStarted <> Original_Surcharge) then begin
        AmendString.Add('SurchargeRate = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('SURCHARGERATE', Original_Surcharge, sStarted, AuditString);
        end;  // lAudit.
      end;  // Surcharge.
      sStarted := CurrToStr(Discount);
      if (sStarted <> Original_Discount) then begin
        AmendString.Add('DiscountRate = '+ sStarted +',');
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('DISCOUNTRATE', Original_Discount, sStarted, AuditString);
        end;  // lAudit.
      end;  // Discount.
      if (CheckSurcharge <> Original_CheckSurcharge) then begin
        sValue := 'Surcharge = ';
        if CheckSurcharge then begin
          sValue := sValue +'1,';
          if lAudit then begin
            SetAuditData('SURCHARGE', '0', '1', AuditString);
          end;
        end
        else begin
          sValue := sValue +'0,';
          if lAudit then begin
            SetAuditData('SURCHARGE', '1', '0', AuditString);
          end;
        end;  // CheckSurcharge.
        AmendString.Add(sValue);
      end;  // not Original_CheckSurcharge.
      if (CheckDiscount <> Original_CheckDiscount) then begin
        sValue := 'Discount = ';
        if CheckDiscount then begin
          sValue := sValue +'1,';
          if lAudit then begin
            SetAuditData('DISCOUNT', '0', '1', AuditString);
          end;
        end
        else begin
          sValue := sValue +'0,';
          if lAudit then begin
            SetAuditData('DISCOUNT', '1', '0', AuditString);
          end;
        end;  // CheckDiscount.
        AmendString.Add(sValue);
      end;  // not Original_CheckDiscount.
      if (CheckChargePeriod <> Original_CheckChargePeriod) then begin
        sValue := 'ChargePeriod = ';
        if CheckChargePeriod then begin
          sValue := sValue +'1,';
          if lAudit then begin
            SetAuditData('CHARGEPERIOD', '0', '1', AuditString);
          end;
        end
        else begin
          sValue := sValue +'0,';
          if lAudit then begin
            SetAuditData('CHARGEPERIOD', '1', '0', AuditString);
          end;
        end;  // CheckChargePeriod.
        AmendString.Add(sValue);
      end;  // not Original_ChargePeriod.
      // Done - remove the last trailing comma.
      with AmendString do begin
        sStarted := Strings[Count-1];
        Strings[Count-1] := Copy(sStarted,1,Length(sStarted)-1);
      end;
      sStarted := Trim(edtID.Text);
      AmendString.Add('WHERE id = '+ sStarted);
    end;
    q.SQL := AmendString;
    q.ExecSQL;
    if lAudit then begin
      if lAppend then begin
        // Get and store the new ID for this table.
        with q do begin
          SQL.Clear;
          SQL.Add('SELECT ID');
          SQL.ADD('FROM tAgreementTariffs');
          SQL.Add('WHERE AgreementID = '+ IntToStr(AgreementID));
          SQL.Add('AND SupplierServiceCodeID = '+ IntToStr(SupplierServiceCodeID));
          SQL.Add('AND Active = 1');
          Open;
          SetAuditID(FieldByName('ID').AsString, sAuditValue);
          Close;
        end;
      end;  // lAppend.
      SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
    end;  // lAudit.
  end;
  AmendString.Clear;
  q.Free;
  if lReturn then begin
    ModalResult := mrOk;
  end
  else begin
    MessageDlg(sError, mtWarning, [mbOk], 0);
  end;  // lReturn.
end;  // btnOkClick().

end.

